(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      8974,        266]
NotebookOptionsPosition[      7648,        215]
NotebookOutlinePosition[      8112,        233]
CellTagsIndexPosition[      8069,        230]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]crtfile\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/crtfile.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/crtfile.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/crtfile.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[
 RowBox[{"   ", 
  RowBox[{
   RowBox[{"#", "include", " ", "\"\<hdf5.h\>\""}], "\n", "   ", 
   RowBox[{"#", "define", " ", "FILE", " ", "\"\<file.h5\>\""}], "\n", "\n", 
   "   ", 
   RowBox[{"int", " ", "main", 
    RowBox[{"(", ")"}], " ", 
    RowBox[{"{", "\n", "\n", "      ", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"hid_t", "       ", "file_id"}], ";"}], "   ", "/"}],
                "*", " ", "file", " ", "identifier", " ", "*", 
               RowBox[{"/", "\n", "      ", "herr_t"}], "      ", "status"}], 
              ";"}], "\n", "\n", "      ", "/"}], "*", " ", "Create", " ", 
            "a", " ", "new", " ", "file", " ", "using", " ", "default", " ", 
            RowBox[{"properties", "."}], " ", "*", 
            RowBox[{"/", "\n", "      ", "file_id"}]}], " ", "=", " ", 
           RowBox[{"H5Fcreate", 
            RowBox[{"(", 
             RowBox[{"FILE", ",", " ", 
              RowBox[{"H5F_ACC", "_TRUNC"}], ",", " ", "H5P_DEFAULT", ",", 
              " ", "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "      ", 
         "/"}], "*", " ", "Terminate", " ", "access", " ", "to", " ", "the", 
        " ", 
        RowBox[{"file", "."}], " ", "*", 
        RowBox[{"/", "\n", "      ", "status"}]}], " ", "=", " ", 
       RowBox[{"H5Fclose", 
        RowBox[{"(", "file_id", ")"}]}]}], ";"}], " ", "\n", "   ", 
     "}"}]}]}]}]], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{3.519293195844782*^9},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.5193134125426784`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.519297276457179*^9, 3.519298918247652*^9, 
   3.519315839908516*^9, 3.519316999625848*^9, {3.519317504423721*^9, 
   3.5193175133152294`*^9}, 3.5198585349166393`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<file.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\file.h5\"\>"], \
"Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192972769502077`*^9, 
   3.519298918278654*^9, 3.5193158406905603`*^9, 3.519317000425894*^9, {
   3.519317505168763*^9, 3.5193175140752726`*^9}, 3.5198585356406803`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fcreate", "[", 
   RowBox[{
   "file", ",", "H5FuACCuTRUNC", ",", "H5PuDEFAULT", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.51929727700121*^9, 3.5192989183036556`*^9, 3.5193158407445636`*^9, {
   3.519317000594903*^9, 3.519317030993642*^9}, {3.5193171114512444`*^9, 
   3.519317135403614*^9}, 3.5193172622758703`*^9, {3.519317296724841*^9, 
   3.519317313794817*^9}, {3.5193175052617683`*^9, 3.519317514134276*^9}, 
   3.519858535689683*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Fclose", "[", "fileID", "]"}]], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, 
   3.5192989163655443`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.519293327980339*^9, 3.519293341758127*^9}, 
   3.519297277015211*^9, 3.5192989183176565`*^9, 3.519315840766565*^9, 
   3.5193170006139045`*^9, {3.519317105401898*^9, 3.5193171368746977`*^9}, 
   3.5193172639239645`*^9, 3.5193173158919373`*^9, {3.51931750528977*^9, 
   3.519317514154277*^9}, 3.5198585357056837`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1089, 983},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 144, 1, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[748, 27, 98, 1, 105, "Section"],
Cell[849, 30, 461, 10, 41, "Text"],
Cell[1313, 42, 663, 12, 41, "Text"],
Cell[1979, 56, 607, 13, 90, "Text"],
Cell[2589, 71, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2903, 83, 187, 4, 105, "Section"],
Cell[3093, 89, 1724, 43, 419, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[4854, 137, 146, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[5025, 143, 171, 3, 43, "Input"],
Cell[5199, 148, 360, 5, 42, "Output"]
}, Open  ]],
Cell[5574, 156, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[5737, 162, 262, 7, 43, "Input"],
Cell[6002, 171, 327, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6366, 181, 245, 6, 43, "Input"],
Cell[6614, 189, 426, 6, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7077, 200, 161, 3, 43, "Input"],
Cell[7241, 205, 367, 5, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
