(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17410,        456]
NotebookOptionsPosition[     15590,        388]
NotebookOutlinePosition[     16054,        406]
CellTagsIndexPosition[     16011,        403]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]h5_crtdat18\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}, 
   3.5192935097227345`*^9}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/crtdat.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/crtdat.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/crtdat.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}, {3.519293488863541*^9, 
  3.5192934978050528`*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[{
 RowBox[{"/", 
  RowBox[{
  "*", "\n", " ", "*", "   ", "Creating", " ", "and", " ", "closing", " ", 
   "a", " ", 
   RowBox[{"dataset", "."}]}]}], "\n", 
 RowBox[{" ", 
  RowBox[{"*", 
   RowBox[{"/", "\n", "\n", "#"}], "include", " ", "\"\<hdf5.h\>\""}]}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "FILE", " ", "\"\<dset.h5\>\""}], "\n"}], "\n", 
 RowBox[{"int", " ", "main", 
  RowBox[{"(", ")"}], " ", 
  RowBox[{"{", "\n", "\n", "   ", 
   RowBox[{
    RowBox[{"hid_t", "       ", "file_id"}], ",", " ", "dataset_id", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"dataspace_id", ";"}], "  ", "/"}], "*", " ", 
                    "identifiers", " ", "*", 
                    RowBox[{"/", "\n", "   ", "hsize_t"}], "     ", 
                    RowBox[{"dims", "[", "2", "]"}]}], ";", "\n", "   ", 
                    RowBox[{"herr_t", "      ", "status"}], ";"}], "\n", "\n",
                     "   ", "/"}], "*", " ", "Create", " ", "a", " ", "new", 
                    " ", "file", " ", "using", " ", "default", " ", 
                    RowBox[{"properties", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "file_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Fcreate", 
                    RowBox[{"(", 
                    RowBox[{"FILE", ",", " ", 
                    RowBox[{"H5F_ACC", "_TRUNC"}], ",", " ", "H5P_DEFAULT", 
                    ",", " ", "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", 
                    "   ", "/"}], "*", " ", "Create", " ", "the", " ", "data",
                     " ", "space", " ", "for", " ", "the", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", 
                    RowBox[{"dims", "[", "0", "]"}]}]}], " ", "=", " ", "4"}],
                     ";", " ", "\n", "   ", 
                    RowBox[{
                    RowBox[{"dims", "[", "1", "]"}], " ", "=", " ", "6"}], 
                    ";", " ", "\n", "   ", 
                    RowBox[{"dataspace_id", " ", "=", " ", 
                    RowBox[{"H5Screate_simple", 
                    RowBox[{"(", 
                    RowBox[{"2", ",", " ", "dims", ",", " ", "NULL"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                   "Create", " ", "the", " ", 
                   RowBox[{"dataset", "."}], " ", "*", 
                   RowBox[{"/", "\n", "   ", "dataset_id"}]}], " ", "=", " ", 
                  RowBox[{"H5Dcreate", 
                   RowBox[{"(", 
                    RowBox[{"file_id", ",", " ", "\"\</dset\>\"", ",", " ", 
                    RowBox[{"H5T_STD", "_I32BE"}], ",", " ", "dataspace_id", 
                    ",", " ", "\n", "                          ", 
                    "H5P_DEFAULT", ",", " ", "H5P_DEFAULT", ",", " ", 
                    "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
                "/"}], "*", " ", "End", " ", "access", " ", "to", " ", "the", 
               " ", "dataset", " ", "and", " ", "release", " ", "resources", 
               " ", "used", " ", "by", " ", 
               RowBox[{"it", "."}], " ", "*", 
               RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
              RowBox[{"H5Dclose", 
               RowBox[{"(", "dataset_id", ")"}]}]}], ";"}], "\n", "\n", "   ",
             "/"}], "*", " ", "Terminate", " ", "access", " ", "to", " ", 
           "the", " ", "data", " ", 
           RowBox[{"space", "."}], " ", "*", 
           RowBox[{"/", " ", "\n", "   ", "status"}]}], " ", "=", " ", 
          RowBox[{"H5Sclose", 
           RowBox[{"(", "dataspace_id", ")"}]}]}], ";"}], "\n", "\n", "   ", 
        "/"}], "*", " ", "Close", " ", "the", " ", 
       RowBox[{"file", "."}], " ", "*", 
       RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
      RowBox[{"H5Fclose", 
       RowBox[{"(", "file_id", ")"}]}]}], ";"}]}], "\n", "}"}]}]}], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{
  3.519293195844782*^9, {3.519293535018181*^9, 3.5192935371253014`*^9}},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.519313422092225*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, {3.519297288075844*^9, 
   3.5192972953282585`*^9}, 3.5192977414197736`*^9, 3.5192989370237265`*^9, 
   3.51929925091668*^9, 3.519299300137495*^9, 3.519299550852835*^9, 
   3.5193158607447076`*^9, 3.519317580667082*^9, 3.5198585414510126`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<dset.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}, {
  3.519293546201821*^9, 3.519293546673848*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\dset.h5\"\>"], \
"Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192935900623293`*^9, 
   3.5192940722649097`*^9, 3.519294143445981*^9, 3.5192942649679317`*^9, {
   3.5192972881468477`*^9, 3.5192972958222866`*^9}, 3.519297741943804*^9, 
   3.519298937050728*^9, 3.519299251599719*^9, 3.519299300835535*^9, 
   3.5192995508928375`*^9, 3.5193158608167114`*^9, 3.5193175807490864`*^9, 
   3.519858541487015*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fcreate", "[", 
   RowBox[{
   "file", ",", "H5FuACCuTRUNC", ",", "H5PuDEFAULT", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, {
   3.519297288163849*^9, 3.5192972958742895`*^9}, 3.519297741996806*^9, 
   3.5192989370667286`*^9, 3.5192992516497216`*^9, 3.519299300886538*^9, 
   3.5192995509208393`*^9, 3.519315860841713*^9, 3.5193175807680874`*^9, 
   3.5198585415030155`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSpaceID", "=", 
  RowBox[{"H5ScreateUsimple", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "6"}], "}"}], ",", "Null"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519293567137018*^9, 3.519293579966752*^9}, {
  3.519293627447468*^9, 3.51929365091481*^9}}],

Cell[BoxData["67108866"], "Output",
 CellChangeTimes->{
  3.5192936515168447`*^9, 3.5192941467531705`*^9, 3.5192942650459366`*^9, {
   3.5192972881838503`*^9, 3.5192972958952913`*^9}, 3.519297742019808*^9, 
   3.5192989370837297`*^9, 3.5192992516767235`*^9, 3.5192993009155397`*^9, 
   3.5192995509428406`*^9, 3.519315860867715*^9, 3.519317580795089*^9, 
   3.519858541524017*^9}]
}, Open  ]],

Cell["\<\
Below, the command \[OpenCurlyDoubleQuote]H5Tcopy[H5TuNATIVEuINT]\
\[CloseCurlyDoubleQuote] could be expected. Yet it does not quite work on the \
fundamental types, i.e., it returns as -1 indicating an error code. I took my \
best look at source code but cannot quite figure out a solution. 

The equivalent command is \
\[OpenCurlyDoubleQuote]H5T`copy[H5TuNATIVEuINT]@Id[]\[CloseCurlyDoubleQuote] \
in .NET formulation. Therefore, mix and match with the DotNet. It is not \
pretty but it works. 

The problem with using the DotNet code exclusively is that I could not coax \
functions such as H5D`read and H5D`write to work. It seems to have to do with \
the \[OpenCurlyQuote]generics\[CloseCurlyQuote] format.

H5Tcopy does work fine on objects that already have identifies, like \
datasets, etc.

Bottom line: \[OpenCurlyDoubleQuote]H5T`copy[H5TuNATIVEuINT]@Id[]\
\[CloseCurlyDoubleQuote] is used in place of \
\[OpenCurlyDoubleQuote]H5Tcopy[H5TuNATIVEuINT]\[CloseCurlyDoubleQuote].\
\>", "Text",
 CellChangeTimes->{{3.5192505795812707`*^9, 3.5192506125981593`*^9}, {
  3.5192937713646994`*^9, 3.5192938689112787`*^9}, {3.519294185924411*^9, 
  3.5192942242426023`*^9}, {3.5192973329234085`*^9, 3.5192973583348627`*^9}, {
  3.519299428421832*^9, 3.519299541414295*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dcreate", "[", 
   RowBox[{"fileID", ",", "\"\</dset\>\"", ",", 
    RowBox[{
     RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
     RowBox[{"Id", "[", "]"}]}], ",", "dataSpaceID", ",", "H5PuDEFAULT", ",", 
    "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519218583559203*^9, 3.5192186776015816`*^9}, 
   3.5192187251753025`*^9, {3.519219006500394*^9, 3.5192190343469863`*^9}, {
   3.519219139844021*^9, 3.519219205938801*^9}, {3.5192394497466803`*^9, 
   3.5192394603722887`*^9}, {3.5192402536706624`*^9, 3.5192402758209295`*^9}, 
   3.5192403881393538`*^9, {3.519250513762506*^9, 3.5192505185057774`*^9}, 
   3.5192519173847885`*^9, {3.519293687744917*^9, 3.519293688518961*^9}, 
   3.5192941721956253`*^9}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{
  3.5192942652719493`*^9, {3.5192972883548594`*^9, 3.5192972960693007`*^9}, 
   3.519297742194818*^9, 3.5192989371087313`*^9, 3.5192992518597336`*^9, 
   3.5192993011035504`*^9, 3.5192995509658413`*^9, 3.519315861012723*^9, 
   3.519317580940097*^9, 3.5198585416730256`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}]], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
   3.519294255857411*^9, 3.519294258239547*^9}, 3.5192989304753513`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192942653069515`*^9, {3.5192972883718605`*^9, 3.519297296089302*^9}, 
   3.5192977422168193`*^9, 3.519298937125732*^9, 3.5192992518827353`*^9, 
   3.5192993011225514`*^9, 3.519299550986843*^9, 3.519315861034724*^9, 
   3.5193175809610987`*^9, 3.5198585416890264`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}]], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
   3.519294255857411*^9, 3.519294258239547*^9}, {3.519297733940346*^9, 
   3.5192977368015094`*^9}, 3.5192989327334805`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192942653069515`*^9, {3.5192972883718605`*^9, 3.519297296089302*^9}, 
   3.5192977422378206`*^9, 3.5192989371417327`*^9, 3.5192992519057364`*^9, 
   3.519299301139552*^9, 3.519299551003844*^9, 3.5193158610537252`*^9, 
   3.5193175809810996`*^9, 3.519858541705027*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Fclose", "[", "fileID", "]"}]], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, 
   3.519298935150619*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.519293327980339*^9, 3.519293341758127*^9}, 
   3.519294265323952*^9, {3.5192972883878613`*^9, 3.519297296106303*^9}, 
   3.5192977422548213`*^9, 3.5192989371567335`*^9, 3.519299251924738*^9, 
   3.519299301155553*^9, 3.519299551029845*^9, 3.5193158610687265`*^9, 
   3.5193175809981003`*^9, 3.519858541720028*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1089, 983},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 176, 2, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[780, 28, 98, 1, 105, "Section"],
Cell[881, 31, 509, 11, 41, "Text"],
Cell[1393, 44, 663, 12, 41, "Text"],
Cell[2059, 58, 607, 13, 90, "Text"],
Cell[2669, 73, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2983, 85, 187, 4, 105, "Section"],
Cell[3173, 91, 4739, 103, 959, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[7949, 199, 144, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[8118, 205, 171, 3, 43, "Input"],
Cell[8292, 210, 606, 8, 42, "Output"]
}, Open  ]],
Cell[8913, 221, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[9076, 227, 311, 8, 43, "Input"],
Cell[9390, 237, 501, 8, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9928, 250, 245, 6, 43, "Input"],
Cell[10176, 258, 427, 6, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10640, 269, 304, 7, 43, "Input"],
Cell[10947, 278, 380, 6, 42, "Output"]
}, Open  ]],
Cell[11342, 287, 1283, 25, 311, "Text"],
Cell[CellGroupData[{
Cell[12650, 316, 808, 14, 71, "Input"],
Cell[13461, 332, 330, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13828, 342, 210, 3, 43, "Input"],
Cell[14041, 347, 321, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14399, 357, 264, 4, 43, "Input"],
Cell[14666, 363, 321, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15024, 373, 159, 3, 43, "Input"],
Cell[15186, 378, 364, 5, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
