(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     42612,       1055]
NotebookOptionsPosition[     38357,        908]
NotebookOutlinePosition[     39546,        946]
CellTagsIndexPosition[     39461,        941]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]h5_rdwt18\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}, 
   3.5192935097227345`*^9, 3.5192943555601134`*^9}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/rdwt.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/rdwt.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/rdwt.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}, {3.519293488863541*^9, 
  3.5192934978050528`*^9}, {3.5192943687078657`*^9, 3.5192943692978992`*^9}, {
  3.519294399419622*^9, 3.519294399420622*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[{
 RowBox[{"/", 
  RowBox[{
  "*", " ", "\n", " ", "*", "   ", "Writing", " ", "and", " ", "reading", " ",
    "an", " ", "existing", " ", 
   RowBox[{"dataset", "."}]}]}], "\n", 
 RowBox[{" ", 
  RowBox[{"*", 
   RowBox[{"/", "\n", "\n", "#"}], "include", " ", "\"\<hdf5.h\>\""}]}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "FILE", " ", "\"\<dset.h5\>\""}], "\n"}], "\n", 
 RowBox[{"int", " ", "main", 
  RowBox[{"(", ")"}], " ", 
  RowBox[{"{", "\n", "\n", "   ", 
   RowBox[{
    RowBox[{"hid_t", "       ", "file_id"}], ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"dataset_id", ";"}], "  ", "/"}], "*", " ", "identifiers", " ",
       "*", 
      RowBox[{"/", "\n", "   ", "herr_t"}], "      ", "status"}], ";", "\n", 
     "   ", 
     RowBox[{"int", "         ", "i"}]}], ",", " ", "j", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"dset_data", "[", "4", "]"}], "[", "6", "]"}], 
                    ";"}], "\n", "\n", "   ", "/"}], "*", " ", "Initialize", 
                    " ", "the", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "for"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"i", " ", "<", " ", "4"}], ";", " ", 
                    RowBox[{"i", "++"}]}], ")"}], "\n", "      ", "for", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"j", " ", "<", " ", "6"}], ";", " ", 
                    RowBox[{"j", "++"}]}], ")"}], "\n", "         ", 
                    RowBox[{
                    RowBox[{"dset_data", "[", "i", "]"}], "[", "j", "]"}]}], 
                    " ", "=", " ", 
                    RowBox[{
                    RowBox[{"i", " ", "*", " ", "6"}], " ", "+", " ", "j", 
                    " ", "+", " ", "1"}]}], ";"}], "\n", "\n", "   ", "/"}], 
                    "*", " ", "Open", " ", "an", " ", "existing", " ", 
                    RowBox[{"file", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "file_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Fopen", 
                    RowBox[{"(", 
                    RowBox[{"FILE", ",", " ", 
                    RowBox[{"H5F_ACC", "_RDWR"}], ",", " ", "H5P_DEFAULT"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                   "Open", " ", "an", " ", "existing", " ", 
                   RowBox[{"dataset", "."}], " ", "*", 
                   RowBox[{"/", "\n", "   ", "dataset_id"}]}], " ", "=", " ", 
                  RowBox[{"H5Dopen", 
                   RowBox[{"(", 
                    RowBox[{
                    "file_id", ",", " ", "\"\</dset\>\"", ",", " ", 
                    "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
                "/"}], "*", " ", "Write", " ", "the", " ", 
               RowBox[{"dataset", "."}], " ", "*", 
               RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
              RowBox[{"H5Dwrite", 
               RowBox[{"(", 
                RowBox[{"dataset_id", ",", " ", 
                 RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", 
                 " ", "H5S_ALL", ",", " ", "H5P_DEFAULT", ",", " ", "\n", 
                 "                     ", "dset_data"}], ")"}]}]}], ";", "\n",
              "\n", "   ", 
             RowBox[{"status", " ", "=", " ", 
              RowBox[{"H5Dread", 
               RowBox[{"(", 
                RowBox[{"dataset_id", ",", " ", 
                 RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", 
                 " ", "H5S_ALL", ",", " ", "H5P_DEFAULT", ",", " ", "\n", 
                 "                    ", "dset_data"}], ")"}]}]}], ";"}], 
            "\n", "\n", "   ", "/"}], "*", " ", "Close", " ", "the", " ", 
           RowBox[{"dataset", "."}], " ", "*", 
           RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
          RowBox[{"H5Dclose", 
           RowBox[{"(", "dataset_id", ")"}]}]}], ";"}], "\n", "\n", "   ", 
        "/"}], "*", " ", "Close", " ", "the", " ", 
       RowBox[{"file", "."}], " ", "*", 
       RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
      RowBox[{"H5Fclose", 
       RowBox[{"(", "file_id", ")"}]}]}], ";"}]}], "\n", "}"}]}]}], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{
  3.519293195844782*^9, {3.519293535018181*^9, 3.5192935371253014`*^9}, 
   3.5192947363358927`*^9},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.519313400212973*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519297761970949*^9, 3.519298869500864*^9, 
   3.5192989037618237`*^9, 3.5192993398187647`*^9, 3.519315872570384*^9, 
   3.519317591178683*^9, 3.519655280946087*^9, 3.519660689503439*^9, 
   3.5196607636806817`*^9, 3.5196608266532836`*^9, 3.519661709346771*^9, 
   3.519661902593824*^9, 3.5196620846482368`*^9, 3.5196621328689947`*^9, 
   3.519662191197331*^9, 3.519662475761607*^9, 3.519858546005273*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dsetData", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"6", "i"}], "+", "j", "+", "1"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "6"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5192952891495113`*^9, 3.5192953409484744`*^9}, {
  3.5192955298142767`*^9, 3.5192955337805037`*^9}, {3.519296992134917*^9, 
  3.519296997833243*^9}, {3.519660820424927*^9, 3.519660830413499*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"8", ",", "9", ",", "10", ",", "11", ",", "12", ",", "13"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", "15", ",", "16", ",", "17", ",", "18", ",", "19"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"20", ",", "21", ",", "22", ",", "23", ",", "24", ",", "25"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"26", ",", "27", ",", "28", ",", "29", ",", "30", ",", "31"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.519295325415586*^9, 3.5192953413204956`*^9}, 
   3.519295605184588*^9, 3.5192958765891113`*^9, {3.5192961627124767`*^9, 
   3.5192961899300337`*^9}, 3.5192964965955734`*^9, 3.519296715140074*^9, 
   3.5192968294596124`*^9, {3.5192969870076237`*^9, 3.519296998851301*^9}, 
   3.5192970674812264`*^9, {3.519297125026518*^9, 3.5192971783145657`*^9}, 
   3.519297221141015*^9, 3.5192973163304596`*^9, 3.519297762065954*^9, 
   3.5192988695398664`*^9, 3.5192989037958255`*^9, 3.5192993405428057`*^9, 
   3.5193158726093864`*^9, 3.5193175912126846`*^9, 3.5196606917835693`*^9, 
   3.5196607673488913`*^9, 3.5196608266862855`*^9, 3.519661710164818*^9, 
   3.5196620854862847`*^9, 3.519662133747045*^9, 3.519662192032379*^9, 
   3.51966247633564*^9, 3.5198585460372753`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<dset.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}, {
  3.519293546201821*^9, 3.519293546673848*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\dset.h5\"\>"], \
"Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192935900623293`*^9, 
   3.5192940722649097`*^9, 3.519294143445981*^9, 3.5192942649679317`*^9, 
   3.51929519942638*^9, 3.5192956052085896`*^9, 3.5192958766121125`*^9, {
   3.5192961627434783`*^9, 3.519296189952035*^9}, 3.5192964982366676`*^9, 
   3.5192967151690755`*^9, 3.5192968294806137`*^9, {3.5192969870256248`*^9, 
   3.5192969988793025`*^9}, 3.519297067500228*^9, {3.5192971250555196`*^9, 
   3.519297178339567*^9}, 3.5192972211590166`*^9, 3.5192973163494606`*^9, 
   3.519297762093956*^9, 3.5192988695638676`*^9, 3.519298903833828*^9, 
   3.5192993405658073`*^9, 3.5193158726343875`*^9, 3.5193175912306857`*^9, 
   3.5196605843654256`*^9, 3.5196606939066906`*^9, 3.5196607692019978`*^9, 
   3.519660826712287*^9, 3.5196617101878185`*^9, 3.519662085526287*^9, 
   3.519662133765046*^9, 3.51966219204838*^9, 3.519662476353641*^9, 
   3.519858546058276*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fopen", "[", 
   RowBox[{"file", ",", "H5FuACCuRDWR", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}, {
  3.51929517844018*^9, 3.51929519331003*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, 
   3.519295201047473*^9, 3.5192956052665925`*^9, 3.519295876670116*^9, {
   3.51929616276748*^9, 3.519296189973036*^9}, 3.5192964997407537`*^9, 
   3.519296715224078*^9, 3.5192968295336165`*^9, {3.5192969870766277`*^9, 
   3.519296998899304*^9}, 3.5192970675232286`*^9, {3.519297125100522*^9, 
   3.5192971783905697`*^9}, 3.519297221207019*^9, 3.519297316401464*^9, 
   3.5192977621119576`*^9, 3.519298869583869*^9, 3.519298903854829*^9, 
   3.5192993406168103`*^9, 3.5193158726563888`*^9, 3.519317591248687*^9, 
   3.5196605457792187`*^9, 3.5196605884406586`*^9, 3.5196606500531826`*^9, 
   3.5196606954717803`*^9, 3.519660770893094*^9, 3.5196608267382884`*^9, 
   3.5196617102428217`*^9, 3.51966208558229*^9, 3.519662133813049*^9, 
   3.5196621920953827`*^9, 3.5196624764016438`*^9, 3.519858546074277*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dopen", "[", 
   RowBox[{"fileID", ",", " ", "\"\</dset\>\"", ",", " ", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519295208255885*^9, 3.519295229725113*^9}}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{
  3.519295230478156*^9, 3.519295605287594*^9, 3.519295876693117*^9, {
   3.519296162791481*^9, 3.519296189995037*^9}, 3.5192965010508285`*^9, 
   3.51929671525508*^9, 3.5192968295516176`*^9, {3.519296987098629*^9, 
   3.5192969989233055`*^9}, 3.5192970675522304`*^9, {3.5192971251255236`*^9, 
   3.5192971784155717`*^9}, 3.51929722122502*^9, 3.519297316419465*^9, 
   3.519297762130958*^9, 3.51929886960387*^9, 3.5192989038808303`*^9, 
   3.519299340645812*^9, 3.51931587267339*^9, 3.519317591265688*^9, 
   3.5196605476113234`*^9, 3.5196605903777695`*^9, 3.519660651448262*^9, 
   3.519660696984867*^9, 3.5196607732712307`*^9, 3.51966082676429*^9, 
   3.519661710259823*^9, 3.5196620856042914`*^9, 3.51966213383105*^9, 
   3.5196621921123834`*^9, 3.519662476418645*^9, 3.5198585460922785`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dwrite", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
   "H5PuDEFAULT", ",", 
   RowBox[{"Flatten", "[", "dsetData", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519295236790517*^9, 3.5192952388296337`*^9}, 
   3.5192952688993535`*^9, {3.5192953728693*^9, 3.519295376504508*^9}, {
   3.5192954081633186`*^9, 3.519295418879932*^9}, {3.5192955373667088`*^9, 
   3.5192955416279526`*^9}, 3.519298894059269*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192954830946045`*^9, 3.519295541882967*^9, 3.519295605496606*^9, 
   3.51929587692113*^9, {3.519296162819483*^9, 3.519296190019038*^9}, 
   3.519296504955052*^9, 3.5192967154320903`*^9, 3.5192968297476287`*^9, {
   3.51929698729064*^9, 3.5192969989543066`*^9}, 3.5192970677832437`*^9, {
   3.519297125291533*^9, 3.5192971785945816`*^9}, 3.51929722140003*^9, 
   3.5192973165964746`*^9, 3.5192977621549597`*^9, 3.519298869630872*^9, 
   3.519298903907832*^9, 3.5192993408128214`*^9, 3.5193158726903906`*^9, 
   3.519317591284689*^9, 3.5196605930019197`*^9, 3.5196617104038315`*^9, 
   3.5196620857553*^9, 3.519662133974058*^9, 3.5196621922543917`*^9, 
   3.519662476565653*^9, 3.519858546108279*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataObject", "=", 
  RowBox[{"NETNew", "[", 
   RowBox[{"\"\<System.Int32[]\>\"", ",", 
    RowBox[{"Length", "@", 
     RowBox[{"Flatten", "@", "dsetData"}]}]}], 
   RowBox[{"(*", "bufferSize", "*)"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.519231062285945*^9, {3.5192311487638917`*^9, 3.519231172598255*^9}, {
   3.519231218079856*^9, 3.5192312364009037`*^9}, {3.519231293255156*^9, 
   3.5192313075209723`*^9}, {3.519231363911197*^9, 3.519231455806453*^9}, {
   3.5192315933703213`*^9, 3.5192315937653437`*^9}, {3.519231638908926*^9, 
   3.519231651415642*^9}, {3.519237671194953*^9, 3.5192376964363966`*^9}, {
   3.5192378451509027`*^9, 3.5192378456459312`*^9}, {3.519237920814231*^9, 
   3.5192379214142647`*^9}, {3.519238233378108*^9, 3.5192382498270493`*^9}, 
   3.5192397945013995`*^9, {3.5192956761176453`*^9, 3.519295701628104*^9}, {
   3.5192957580793333`*^9, 3.5192957724091525`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\[LeftGuillemet]", 
   RowBox[{"NETObject", "[", 
    RowBox[{"System", ".", 
     RowBox[{"Int32", "[", "]"}]}], "]"}], "\[RightGuillemet]"}],
  NETLink`Objects`NETObject$65896894693377]], "Output",
 CellChangeTimes->{
  3.5192957882300577`*^9, 3.5192958769431314`*^9, {3.519296162841484*^9, 
   3.5192961900400395`*^9}, 3.51929650650114*^9, 3.5192967154530916`*^9, 
   3.51929682976863*^9, {3.5192969873136415`*^9, 3.519296998979308*^9}, 
   3.519297067805245*^9, {3.5192971253085337`*^9, 3.519297178615583*^9}, 
   3.5192972214220314`*^9, 3.5192973166184764`*^9, 3.5192977621759605`*^9, 
   3.5192988696488724`*^9, 3.519298903925833*^9, 3.519299340835823*^9, 
   3.519315872711392*^9, 3.51931759130569*^9, 3.5196617104258327`*^9, 
   3.5196620857773013`*^9, 3.519662133995059*^9, 3.5196621922743926`*^9, 
   3.519662476587654*^9, 3.5198585461312804`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dread", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
   "H5PuDEFAULT", ",", "dataObject"}], "]"}]], "Input",
 CellChangeTimes->{{3.5192956306340437`*^9, 3.5192956387795095`*^9}, {
   3.51929575120994*^9, 3.519295754483127*^9}, {3.5192961383530836`*^9, 
   3.519296140030179*^9}, {3.5192988648325973`*^9, 3.519298865598641*^9}, 
   3.5192988973064547`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.519295877056138*^9, {3.519296162869486*^9, 3.519296190068041*^9}, 
   3.519296511138406*^9, 3.519296715475093*^9, 3.519296829785631*^9, {
   3.5192969873336425`*^9, 3.5192969990013094`*^9}, 3.519297067835247*^9, {
   3.519297125328535*^9, 3.5192971786405845`*^9}, 3.5192972214440327`*^9, 
   3.5192973166384773`*^9, 3.5192977621949615`*^9, 3.5192988696698737`*^9, 
   3.5192989039478345`*^9, 3.5192993408588243`*^9, 3.519315872734393*^9, 
   3.519317591322691*^9, 3.5196617104458337`*^9, 3.5196620858043027`*^9, 
   3.5196621340140605`*^9, 3.5196621922933936`*^9, 3.5196624766076555`*^9, 
   3.519858546148281*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}]], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
   3.519294255857411*^9, 3.519294258239547*^9}, 3.5192988995455823`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192942653069515`*^9, 3.5192955593609667`*^9, 3.519295877080139*^9, {
   3.5192961629184885`*^9, 3.5192961901070433`*^9}, 3.519296550941682*^9, 
   3.519296715497094*^9, 3.519296829804632*^9, {3.519296987350643*^9, 
   3.5192969990233107`*^9}, 3.519297067860248*^9, {3.519297125352536*^9, 
   3.5192971786625853`*^9}, 3.519297221464034*^9, 3.5192973166594787`*^9, 
   3.5192977622139626`*^9, 3.519298869695875*^9, 3.519298903965835*^9, 
   3.5192993408808255`*^9, 3.519315872755395*^9, 3.5193175913356915`*^9, {
   3.5196605679484863`*^9, 3.519660596079096*^9}, 3.5196606555014944`*^9, 
   3.5196607430175*^9, 3.5196607944274406`*^9, 3.519660833198658*^9, 
   3.5196617104628344`*^9, 3.519662085823304*^9, 3.519662134031061*^9, 
   3.519662192310395*^9, 3.5196624766236563`*^9, 3.5198585461642823`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Fclose", "[", "fileID", "]"}]], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, 
   3.519298901669704*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.519293327980339*^9, 3.519293341758127*^9}, 
   3.519294265323952*^9, 3.5192955615300913`*^9, 3.5192958770961404`*^9, {
   3.5192961629354897`*^9, 3.5192961901240444`*^9}, 3.5192965525807757`*^9, 
   3.519296715515095*^9, 3.5192968298216333`*^9, {3.5192969873686447`*^9, 
   3.519296999045312*^9}, 3.5192970678862495`*^9, {3.5192971253725376`*^9, 
   3.519297178688587*^9}, 3.5192972214790344`*^9, 3.51929731668148*^9, 
   3.519297762231964*^9, 3.5192988697158766`*^9, 3.5192989039818363`*^9, 
   3.5192993408988266`*^9, 3.5193158727703953`*^9, 3.5193175913526926`*^9, {
   3.5196605698215933`*^9, 3.519660597855197*^9}, 3.5196606573826017`*^9, 
   3.519660744814603*^9, 3.519660796308548*^9, 3.5196608348487525`*^9, 
   3.5196617104798355`*^9, 3.519662085841305*^9, 3.5196621340490627`*^9, 
   3.5196621923273954`*^9, 3.5196624766406574`*^9, 3.5198585461802835`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Implementation in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " using the Extend Functionality"
}], "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.519313400212973*^9, {3.5196551888108177`*^9, 3.5196551938611064`*^9}}],

Cell[TextData[{
 "This example is the same as above but written with a syntax that is closer \
to normal ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " style and uses the \[OpenCurlyDoubleQuote]HDF5Extend`\
\[CloseCurlyDoubleQuote] for this purpose."
}], "Text",
 CellChangeTimes->{{3.5196552048007317`*^9, 3.519655235272475*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Needs", "[", "\"\<HDF5Extend`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"dsetData", "=", 
  RowBox[{"2", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"6", "i"}], "+", "j", "+", "1"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "6"}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<dset.h5\>\""}], "}"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}, {
   3.5196552435039454`*^9, 3.5196552566506977`*^9}, {3.5196552987731066`*^9, 
   3.5196552990461226`*^9}, 3.5196621821898155`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"16", ",", "18", ",", "20", ",", "22", ",", "24", ",", "26"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"28", ",", "30", ",", "32", ",", "34", ",", "36", ",", "38"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"40", ",", "42", ",", "44", ",", "46", ",", "48", ",", "50"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"52", ",", "54", ",", "56", ",", "58", ",", "60", ",", "62"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519297761970949*^9, 3.519298869500864*^9, 
   3.5192989037618237`*^9, 3.5192993398187647`*^9, 3.519315872570384*^9, 
   3.519317591178683*^9, 3.519655257179728*^9, {3.519655287897485*^9, 
   3.519655299776164*^9}, 3.5196561031441145`*^9, 3.5196564797036524`*^9, 
   3.519658519478321*^9, 3.519659137405664*^9, 3.5196594247320986`*^9, 
   3.51965973159465*^9, 3.519659804238805*^9, 3.5196603542822657`*^9, {
   3.5196607476307635`*^9, 3.519660759428438*^9}, 3.519660858848125*^9, 
   3.519661167239764*^9, 3.519661710594842*^9, 3.5196619134814463`*^9, 
   3.5196620860143147`*^9, 3.5196621340690637`*^9, 3.519662192348397*^9, 
   3.5196624766646585`*^9, 3.5198585462042847`*^9}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\dset.h5\"\>"], \
"Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519297761970949*^9, 3.519298869500864*^9, 
   3.5192989037618237`*^9, 3.5192993398187647`*^9, 3.519315872570384*^9, 
   3.519317591178683*^9, 3.519655257179728*^9, {3.519655287897485*^9, 
   3.519655299776164*^9}, 3.5196561031441145`*^9, 3.5196564797036524`*^9, 
   3.519658519478321*^9, 3.519659137405664*^9, 3.5196594247320986`*^9, 
   3.51965973159465*^9, 3.519659804238805*^9, 3.5196603542822657`*^9, {
   3.5196607476307635`*^9, 3.519660759428438*^9}, 3.519660858848125*^9, 
   3.519661167239764*^9, 3.519661710594842*^9, 3.5196619134814463`*^9, 
   3.5196620860143147`*^9, 3.5196621340690637`*^9, 3.519662192348397*^9, 
   3.5196624766646585`*^9, 3.519858546207285*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5FExtendOpen", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"fileID", "=", 
      RowBox[{"H5Fopen", "[", 
       RowBox[{"file", ",", "H5FuACCuRDWR", ",", "H5PuDEFAULT"}], "]"}]}], 
     "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"H5DExtendOpen", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dataSetID", "=", 
        RowBox[{"H5Dopen", "[", 
         RowBox[{
         "fileID", ",", " ", "\"\</dset\>\"", ",", " ", "H5PuDEFAULT"}], 
         "]"}]}], "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
      "CompoundExpression", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"write", " ", "out", " ", "the", " ", "data"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"H5DExtendWrite", "[", 
         RowBox[{"dataSetID", ",", 
          RowBox[{
           RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
           RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
          "H5PuDEFAULT", ",", "dsetData", ",", 
          RowBox[{"\"\<DataType\>\"", "\[Rule]", "Integer32"}]}], "]"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"read", " ", "the", " ", "data", " ", "back", " ", "in"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"H5DExtendRead", "[", 
         RowBox[{"dataSetID", ",", 
          RowBox[{
           RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
           RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
          "H5PuDEFAULT", ",", 
          RowBox[{"Dimensions", "@", "dsetData"}], ",", 
          RowBox[{"\"\<DataType\>\"", "\[Rule]", "Integer32"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}]}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"close", " ", "H5DExtendOpen"}], " ", "*)"}], 
   "\[IndentingNewLine]", "]"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"close", " ", "H5FExtendOpen"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.5196594381448655`*^9, 3.5196594642473583`*^9}, {
   3.5196594975052605`*^9, 3.5196595031285825`*^9}, {3.5196596851029906`*^9, 
   3.5196597656125956`*^9}, {3.5196598253170104`*^9, 3.519659827983163*^9}, {
   3.5196599615818043`*^9, 3.519659963040888*^9}, {3.51966035733444*^9, 
   3.5196604079603357`*^9}, {3.5196608936831174`*^9, 
   3.5196609636891212`*^9}, {3.519660996891021*^9, 3.5196610147970448`*^9}, {
   3.519661172540067*^9, 3.5196612021107583`*^9}, {3.519662163346738*^9, 
   3.519662179391656*^9}, {3.519662226070326*^9, 3.5196622346518164`*^9}, 
   3.5196624945136795`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"16", ",", "18", ",", "20", ",", "22", ",", "24", ",", "26"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"28", ",", "30", ",", "32", ",", "34", ",", "36", ",", "38"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"40", ",", "42", ",", "44", ",", "46", ",", "48", ",", "50"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"52", ",", "54", ",", "56", ",", "58", ",", "60", ",", "62"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.519659465929455*^9, 3.5196594995123754`*^9, {3.519659736720943*^9, 
   3.5196597659446144`*^9}, {3.5196598173175526`*^9, 3.5196598303913007`*^9}, 
   3.519660401880988*^9, 3.5196604630274854`*^9, 3.51966051939771*^9, 
   3.519660862361326*^9, {3.519660942553913*^9, 3.519660964043142*^9}, {
   3.5196609987451267`*^9, 3.519661015956111*^9}, {3.5196611855128093`*^9, 
   3.5196612077020783`*^9}, 3.519661710639845*^9, 3.5196620860643177`*^9, 
   3.5196621341130657`*^9, 3.5196621923933992`*^9, 3.5196622368269405`*^9, {
   3.5196624767126617`*^9, 3.519662495725749*^9}, 3.5198585462522874`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Documentation of the employed Extend functions\
\>", "Subsubsection",
 CellChangeTimes->{{3.5196616644992056`*^9, 3.519661674808795*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "H5FExtendOpen"}]], "Input",
 CellChangeTimes->{{3.5196616767709074`*^9, 3.519661703057411*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5FExtendOpen[{\\\"fileIDsymbol\\\" = H5Fopen[....]}, body] \
sets the fileIDsymbol and then runs the body. The purpose of this function is \
that it provides an automatic H5Fclose[fileIDsymbol] after executing body. \
The return value is that of the body.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858546347293*^9},
 CellTags->"Info3519844146-7102080"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5FExtendOpen", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"HoldAll", ",", "ReadProtected"}], "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5FExtendOpen],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198585463652935`*^9},
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "H5DExtendOpen"}]], "Input",
 CellChangeTimes->{{3.519661682026208*^9, 3.519661701782338*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5DExtendOpen[{\\\"dataSetIDsymbol\\\" = H5Dopen[....]}, body] \
sets the dataSetIDsymbol and then runs the body. The purpose of this function \
is that it provides an automatic H5Dclose[dataSetIDsymbol] after executing \
body. The return value is that of the body.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5198585464482985`*^9},
 CellTags->"Info3519844146-7102080"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5DExtendOpen", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"HoldAll", ",", "ReadProtected"}], "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5DExtendOpen],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858546458299*^9},
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "H5DExtendWrite"}]], "Input",
 CellChangeTimes->{{3.519661693745878*^9, 3.519661700360257*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5DExtendRead[\\\"DataSpaceID\\\", \\\"MemoryTypeID\\\", \
\\\"MemorySpaceID\\\", \\\"FileSpaceID\\\", \\\"xferPListID\\\", \
\\\"Data\\\"] writes data to a file. The first 5 arguments are as defined for \
H5Dwrite. The \\\"Data\\\" argument should be a list or a list of lists, \
depending on dimensions of data. This function takes the option \
\\\"DataType\\\", which is Integer32 by default. Other allowed values are \
Byte, SingleFloat, and DoubleFloat. (Other allowed values can be easily added \
by additional programming of H5Dwrite in \\\"HDF5`\\\" and of H5DExtendWrite \
in \\\"HDF5Extend`\\\".)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858546542304*^9},
 CellTags->"Info3519844146-7102080"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5DExtendWrite", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "H5DExtendWrite", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"\<\"DataType\"\>", "\[Rule]", "Integer32"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5DExtendWrite],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858546565305*^9},
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "H5DExtendRead"}]], "Input",
 CellChangeTimes->{{3.5196616986931615`*^9, 3.519661698805168*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5DExtendRead[\\\"DataSpaceID\\\", \\\"MemoryTypeID\\\", \
\\\"MemorySpaceID\\\", \\\"FileSpaceID\\\", \\\"xferPListID\\\", \
\\\"Dimensions\\\"] reads data from a file. The first 5 arguments are as \
defined for H5Dread. The \\\"Dimensions\\\" argument should be a list of \
dimensions of the object to be read, e.g., \\\"{10}\\\" for a rank 1 data set \
of length 10, \\\"{10,5}\\\" for a rank 2 data set of dimensions 10 by 5, and \
so forth. This function takes the option \\\"DataType\\\", which is Integer32 \
by default. Allowed DataTypes include Byte, Integer32, Integer64, \
SingleFloat, and DoubleFloat. (Other allowed values can be easily added by \
additional programming of H5Dread in \\\"HDF5`\\\" and of H5DExtendRead in \\\
\"HDF5Extend`\\\".)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.51985854665431*^9},
 CellTags->"Info3519844146-7102080"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5DExtendRead", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "H5DExtendRead", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"\<\"DataType\"\>", "\[Rule]", "Integer32"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5DExtendRead],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198585466743116`*^9},
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1423, 981},
WindowMargins->{{74, Automatic}, {Automatic, 18}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3519844146-7102080"->{
  Cell[32083, 732, 402, 6, 93, "Print",
   CellTags->"Info3519844146-7102080"],
  Cell[32488, 740, 529, 15, 32, "Print",
   CellTags->"Info3519844146-7102080"],
  Cell[33214, 767, 415, 7, 93, "Print",
   CellTags->"Info3519844146-7102080"],
  Cell[33632, 776, 527, 15, 32, "Print",
   CellTags->"Info3519844146-7102080"],
  Cell[34357, 803, 752, 11, 151, "Print",
   CellTags->"Info3519844146-7102080"],
  Cell[35112, 816, 1038, 29, 74, "Print",
   CellTags->"Info3519844146-7102080"],
  Cell[36349, 857, 904, 13, 180, "Print",
   CellTags->"Info3519844146-7102080"],
  Cell[37256, 872, 1037, 29, 74, "Print",
   CellTags->"Info3519844146-7102080"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3519844146-7102080", 38787, 921}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 198, 2, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[802, 28, 98, 1, 105, "Section"],
Cell[903, 31, 602, 12, 41, "Text"],
Cell[1508, 45, 663, 12, 41, "Text"],
Cell[2174, 59, 607, 13, 90, "Text"],
Cell[2784, 74, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3098, 86, 187, 4, 105, "Section"],
Cell[3288, 92, 5245, 119, 1040, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[8570, 216, 144, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[8739, 222, 171, 3, 43, "Input"],
Cell[8913, 227, 1263, 17, 42, "Output"]
}, Open  ]],
Cell[10191, 247, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[10354, 253, 498, 12, 43, "Input"],
Cell[10855, 267, 1280, 25, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12172, 297, 311, 8, 43, "Input"],
Cell[12486, 307, 1021, 15, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13544, 327, 265, 6, 43, "Input"],
Cell[13812, 335, 985, 13, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14834, 353, 232, 5, 43, "Input"],
Cell[15069, 360, 850, 12, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15956, 377, 604, 12, 71, "Input"],
Cell[16563, 391, 752, 11, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17352, 407, 924, 16, 43, "Input"],
Cell[18279, 425, 902, 16, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19218, 446, 549, 11, 43, "Input"],
Cell[19770, 459, 667, 10, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20474, 474, 210, 3, 43, "Input"],
Cell[20687, 479, 855, 12, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21579, 496, 159, 3, 43, "Input"],
Cell[21741, 501, 917, 12, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22707, 519, 283, 7, 105, "Section"],
Cell[22993, 528, 338, 8, 41, "Text"],
Cell[CellGroupData[{
Cell[23356, 540, 925, 26, 125, "Input"],
Cell[24284, 568, 1954, 35, 42, "Output"],
Cell[26241, 605, 1547, 22, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27825, 632, 2785, 57, 557, "Input"],
Cell[30613, 691, 1111, 23, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31761, 719, 147, 3, 38, "Subsubsection"],
Cell[CellGroupData[{
Cell[31933, 726, 125, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[32083, 732, 402, 6, 93, "Print",
 CellTags->"Info3519844146-7102080"],
Cell[32488, 740, 529, 15, 32, "Print",
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33066, 761, 123, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[33214, 767, 415, 7, 93, "Print",
 CellTags->"Info3519844146-7102080"],
Cell[33632, 776, 527, 15, 32, "Print",
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34208, 797, 124, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[34357, 803, 752, 11, 151, "Print",
 CellTags->"Info3519844146-7102080"],
Cell[35112, 816, 1038, 29, 74, "Print",
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36199, 851, 125, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[36349, 857, 904, 13, 180, "Print",
 CellTags->"Info3519844146-7102080"],
Cell[37256, 872, 1037, 29, 74, "Print",
 CellTags->"Info3519844146-7102080"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
