(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     21650,        544]
NotebookOptionsPosition[     19624,        470]
NotebookOutlinePosition[     20090,        488]
CellTagsIndexPosition[     20047,        485]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]h5_crtatt18\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}, 
   3.5192935097227345`*^9, 3.5192943555601134`*^9, 3.519297569739954*^9}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/crtatt.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/crtatt.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/crtatt.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}, {3.519293488863541*^9, 
  3.5192934978050528`*^9}, {3.5192943687078657`*^9, 3.5192943692978992`*^9}, {
  3.519294399419622*^9, 3.519294399420622*^9}, {3.519297581437623*^9, 
  3.519297589704096*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[{
 RowBox[{"/", 
  RowBox[{
  "*", "\n", " ", "*", "   ", "Creating", " ", "a", " ", "dataset", " ", 
   RowBox[{"attribute", "."}]}]}], "\n", 
 RowBox[{" ", 
  RowBox[{"*", 
   RowBox[{"/", "\n", "\n", "#"}], "include", " ", "\"\<hdf5.h\>\""}]}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "FILE", " ", "\"\<dset.h5\>\""}], "\n"}], "\n", 
 RowBox[{"int", " ", "main", 
  RowBox[{"(", ")"}], " ", 
  RowBox[{"{", "\n", "\n", "   ", 
   RowBox[{
    RowBox[{"hid_t", "       ", "file_id"}], ",", " ", "dataset_id", ",", " ",
     "attribute_id", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"dataspace_id", ";"}], "  ", "/"}], "*", " ", 
                    "identifiers", " ", "*", 
                    RowBox[{"/", "\n", "   ", "hsize_t"}], "     ", "dims"}], 
                    ";", "\n", "   ", 
                    RowBox[{"int", "         ", 
                    RowBox[{"attr_data", "[", "2", "]"}]}], ";", "\n", "   ", 
                    RowBox[{"herr_t", "      ", "status"}], ";"}], "\n", "\n",
                     "   ", "/"}], "*", " ", "Initialize", " ", "the", " ", 
                    "attribute", " ", 
                    RowBox[{"data", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", 
                    RowBox[{"attr_data", "[", "0", "]"}]}]}], " ", "=", " ", 
                    "100"}], ";", "\n", "   ", 
                    RowBox[{
                    RowBox[{"attr_data", "[", "1", "]"}], " ", "=", " ", 
                    "200"}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                    "Open", " ", "an", " ", "existing", " ", 
                    RowBox[{"file", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "file_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Fopen", 
                    RowBox[{"(", 
                    RowBox[{"FILE", ",", " ", 
                    RowBox[{"H5F_ACC", "_RDWR"}], ",", " ", "H5P_DEFAULT"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                    "Open", " ", "an", " ", "existing", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "dataset_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Dopen", 
                    RowBox[{"(", 
                    RowBox[{
                    "file_id", ",", " ", "\"\</dset\>\"", ",", " ", 
                    "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
                    "/"}], "*", " ", "Create", " ", "the", " ", "data", " ", 
                    "space", " ", "for", " ", "the", " ", 
                    RowBox[{"attribute", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "dims"}]}], " ", "=", " ", 
                    "2"}], ";", "\n", "   ", 
                    RowBox[{"dataspace_id", " ", "=", " ", 
                    RowBox[{"H5Screate_simple", 
                    RowBox[{"(", 
                    RowBox[{"1", ",", " ", 
                    RowBox[{"&", "dims"}], ",", " ", "NULL"}], ")"}]}]}], 
                    ";"}], "\n", "\n", "   ", "/"}], "*", " ", "Create", " ", 
                    "a", " ", "dataset", " ", 
                    RowBox[{"attribute", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "attribute_id"}]}], " ", "=", 
                    " ", 
                    RowBox[{"H5Acreate", " ", 
                    RowBox[{"(", 
                    RowBox[{"dataset_id", ",", " ", "\"\<Units\>\"", ",", " ", 
                    RowBox[{"H5T_STD", "_I32BE"}], ",", " ", "dataspace_id", 
                    ",", " ", "\n", "                             ", 
                    "H5P_DEFAULT", ",", " ", "H5P_DEFAULT"}], ")"}]}]}], 
                    ";"}], "\n", "\n", "   ", "/"}], "*", " ", "Write", " ", 
                    "the", " ", "attribute", " ", 
                    RowBox[{"data", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
                    RowBox[{"H5Awrite", 
                    RowBox[{"(", 
                    RowBox[{"attribute_id", ",", " ", 
                    RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "attr_data"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                   "Close", " ", "the", " ", 
                   RowBox[{"attribute", "."}], " ", "*", 
                   RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
                  RowBox[{"H5Aclose", 
                   RowBox[{"(", "attribute_id", ")"}]}]}], ";"}], "\n", "\n", 
                "   ", "/"}], "*", " ", "Close", " ", "the", " ", 
               RowBox[{"dataspace", "."}], " ", "*", 
               RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
              RowBox[{"H5Sclose", 
               RowBox[{"(", "dataspace_id", ")"}]}]}], ";"}], "\n", "\n", 
            "   ", "/"}], "*", " ", "Close", " ", "to", " ", "the", " ", 
           RowBox[{"dataset", "."}], " ", "*", 
           RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
          RowBox[{"H5Dclose", 
           RowBox[{"(", "dataset_id", ")"}]}]}], ";"}], "\n", "\n", "   ", 
        "/"}], "*", " ", "Close", " ", "the", " ", 
       RowBox[{"file", "."}], " ", "*", 
       RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
      RowBox[{"H5Fclose", 
       RowBox[{"(", "file_id", ")"}]}]}], ";"}]}], "\n", "}"}]}]}], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{
  3.519293195844782*^9, {3.519293535018181*^9, 3.5192935371253014`*^9}, 
   3.5192947363358927`*^9, {3.5192976111403217`*^9, 3.519297613493457*^9}},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.519313430009678*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519298385033586*^9, 3.5192985987368093`*^9, {
   3.519298677505315*^9, 3.5192987039768286`*^9}, {3.519299021085534*^9, 
   3.5192990583276644`*^9}, 3.519299150636944*^9, 3.519299358026806*^9, 
   3.5193176025563335`*^9, 3.5198585550427904`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"attrData", "=", 
  RowBox[{"{", 
   RowBox[{"100", ",", "200"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5192981707253284`*^9, 3.5192981798848524`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"100", ",", "200"}], "}"}]], "Output",
 CellChangeTimes->{
  3.519298180232872*^9, 3.5192983855516157`*^9, 3.5192985991758347`*^9, {
   3.519298677532316*^9, 3.5192987040048304`*^9}, {3.5192990211215363`*^9, 
   3.519299058982702*^9}, 3.5192991507159486`*^9, 3.5192993580978103`*^9, 
   3.5193176025803347`*^9, 3.5198585550667915`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<dset.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}, {
  3.519293546201821*^9, 3.519293546673848*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\dset.h5\"\>"], \
"Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192935900623293`*^9, 
   3.5192940722649097`*^9, 3.519294143445981*^9, 3.5192942649679317`*^9, 
   3.51929519942638*^9, 3.5192956052085896`*^9, 3.5192958766121125`*^9, {
   3.5192961627434783`*^9, 3.519296189952035*^9}, 3.5192964982366676`*^9, 
   3.5192967151690755`*^9, 3.5192968294806137`*^9, {3.5192969870256248`*^9, 
   3.5192969988793025`*^9}, 3.519297067500228*^9, {3.5192971250555196`*^9, 
   3.519297178339567*^9}, 3.5192972211590166`*^9, 3.5192973163494606`*^9, 
   3.5192983855706167`*^9, 3.519298599190835*^9, {3.5192986775503173`*^9, 
   3.5192987040238314`*^9}, {3.5192990211415377`*^9, 3.5192990590117035`*^9}, 
   3.5192991507349496`*^9, 3.5192993581158113`*^9, 3.519317602597336*^9, 
   3.5198585550817924`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fopen", "[", 
   RowBox[{"file", ",", "H5FuACCuRDWR", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}, {
  3.51929517844018*^9, 3.51929519331003*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, 
   3.519295201047473*^9, 3.5192956052665925`*^9, 3.519295876670116*^9, {
   3.51929616276748*^9, 3.519296189973036*^9}, 3.5192964997407537`*^9, 
   3.519296715224078*^9, 3.5192968295336165`*^9, {3.5192969870766277`*^9, 
   3.519296998899304*^9}, 3.5192970675232286`*^9, {3.519297125100522*^9, 
   3.5192971783905697`*^9}, 3.519297221207019*^9, 3.519297316401464*^9, 
   3.51929838561862*^9, 3.5192985992418385`*^9, {3.5192986775683184`*^9, 
   3.5192987040438323`*^9}, {3.5192990211625385`*^9, 3.519299059067707*^9}, 
   3.519299150750951*^9, 3.519299358131812*^9, 3.5193176026133366`*^9, 
   3.519858555097793*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dopen", "[", 
   RowBox[{"fileID", ",", " ", "\"\</dset\>\"", ",", " ", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519295208255885*^9, 3.519295229725113*^9}}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{
  3.519295230478156*^9, 3.519295605287594*^9, 3.519295876693117*^9, {
   3.519296162791481*^9, 3.519296189995037*^9}, 3.5192965010508285`*^9, 
   3.51929671525508*^9, 3.5192968295516176`*^9, {3.519296987098629*^9, 
   3.5192969989233055`*^9}, 3.5192970675522304`*^9, {3.5192971251255236`*^9, 
   3.5192971784155717`*^9}, 3.51929722122502*^9, 3.519297316419465*^9, 
   3.5192983856416206`*^9, 3.519298599257839*^9, {3.519298677586319*^9, 
   3.5192987040618334`*^9}, {3.51929902118754*^9, 3.5192990590947084`*^9}, 
   3.519299150777952*^9, 3.519299358146813*^9, 3.5193176026293373`*^9, 
   3.5198585551137943`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSpaceID", "=", 
  RowBox[{"H5ScreateUsimple", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "2", "}"}], ",", "Null"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519293567137018*^9, 3.519293579966752*^9}, {
   3.519293627447468*^9, 3.51929365091481*^9}, 3.519297807720566*^9, {
   3.519298192153554*^9, 3.5192982000800076`*^9}}],

Cell[BoxData["67108866"], "Output",
 CellChangeTimes->{{3.5192981938286495`*^9, 3.519298200425027*^9}, 
   3.5192983856646223`*^9, 3.51929859927884*^9, {3.5192986776043205`*^9, 
   3.5192987040798345`*^9}, {3.519299021208541*^9, 3.5192990591187096`*^9}, 
   3.519299150797953*^9, 3.519299358163814*^9, 3.5193176026463385`*^9, 
   3.519858555127795*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"attributeID", "=", 
  RowBox[{"H5Acreate", "[", 
   RowBox[{"dataSetID", ",", "\"\<Units\>\"", ",", 
    RowBox[{
     RowBox[{"H5T`copy", "[", "H5TuSTDuI32BE", "]"}], "@", 
     RowBox[{"Id", "[", "]"}]}], ",", "dataSpaceID", ",", "H5PuDEFAULT", ",", 
    "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5192983625052977`*^9, 3.519298409457983*^9}, {
   3.519298482416156*^9, 3.5192984976690283`*^9}, 3.5192991056483707`*^9}],

Cell[BoxData["100663296"], "Output",
 CellChangeTimes->{
  3.5192984986190825`*^9, 3.51929859945185*^9, {3.5192986776303215`*^9, 
   3.519298704103836*^9}, {3.519299021238543*^9, 3.5192990593247213`*^9}, 
   3.5192991508279552`*^9, 3.5192993581808147`*^9, 3.5193176026623397`*^9, 
   3.519858555176798*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Awrite", "[", "Integer32", "]"}], "[", 
  RowBox[{"attributeID", ",", " ", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", " ", "attrData"}], "]"}]], "Input",
 CellChangeTimes->{{3.5192988477116175`*^9, 3.519298850353769*^9}, {
  3.519298944489153*^9, 3.519299000873378*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.5192990212605443`*^9, 3.5192990593467226`*^9}, 
   3.519299150847956*^9, 3.519299358196816*^9, 3.5193176026793404`*^9, 
   3.5198585552047997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"H5Aclose", "[", "attributeID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Fclose", "[", "fileID", "]"}]}], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
  3.519294255857411*^9, 3.519294258239547*^9}, {3.5192976786471834`*^9, 
  3.5192976970572357`*^9}, {3.5192978590565023`*^9, 3.519297865346862*^9}, {
  3.519298947165306*^9, 3.5192989534256644`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192985031613426`*^9, 3.5192985994728518`*^9, {3.5192986776473227`*^9, 
   3.5192987041208367`*^9}, {3.5192990212795453`*^9, 3.5192990593657236`*^9}, 
   3.519299150862957*^9, 3.5192993582138166`*^9, 3.5193176026963415`*^9, 
   3.5198585552248006`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192985031613426`*^9, 3.5192985994728518`*^9, {3.5192986776473227`*^9, 
   3.5192987041208367`*^9}, {3.5192990212795453`*^9, 3.5192990593657236`*^9}, 
   3.519299150862957*^9, 3.5192993582138166`*^9, 3.5193176026963415`*^9, 
   3.5198585552258005`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192985031613426`*^9, 3.5192985994728518`*^9, {3.5192986776473227`*^9, 
   3.5192987041208367`*^9}, {3.5192990212795453`*^9, 3.5192990593657236`*^9}, 
   3.519299150862957*^9, 3.5192993582138166`*^9, 3.5193176026963415`*^9, 
   3.519858555226801*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192985031613426`*^9, 3.5192985994728518`*^9, {3.5192986776473227`*^9, 
   3.5192987041208367`*^9}, {3.5192990212795453`*^9, 3.5192990593657236`*^9}, 
   3.519299150862957*^9, 3.5192993582138166`*^9, 3.5193176026963415`*^9, 
   3.519858555227801*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1089, 983},
WindowMargins->{{81, Automatic}, {10, Automatic}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 222, 2, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[826, 28, 98, 1, 105, "Section"],
Cell[927, 31, 657, 13, 41, "Text"],
Cell[1587, 46, 663, 12, 41, "Text"],
Cell[2253, 60, 607, 13, 90, "Text"],
Cell[2863, 75, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3177, 87, 187, 4, 105, "Section"],
Cell[3367, 93, 6748, 146, 1310, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[10152, 244, 144, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[10321, 250, 171, 3, 43, "Input"],
Cell[10495, 255, 1103, 15, 42, "Output"]
}, Open  ]],
Cell[11613, 273, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[11776, 279, 177, 4, 43, "Input"],
Cell[11956, 285, 374, 7, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12367, 297, 311, 8, 43, "Input"],
Cell[12681, 307, 886, 13, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13604, 325, 265, 6, 43, "Input"],
Cell[13872, 333, 793, 11, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14702, 349, 232, 5, 43, "Input"],
Cell[14937, 356, 669, 10, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15643, 371, 353, 7, 43, "Input"],
Cell[15999, 380, 352, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16388, 390, 460, 9, 71, "Input"],
Cell[16851, 401, 306, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17194, 411, 374, 8, 43, "Input"],
Cell[17571, 421, 198, 3, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17806, 429, 550, 8, 125, "Input"],
Cell[18359, 439, 305, 5, 42, "Output"],
Cell[18667, 446, 305, 5, 42, "Output"],
Cell[18975, 453, 303, 5, 42, "Output"],
Cell[19281, 460, 303, 5, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
