(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     19467,        479]
NotebookOptionsPosition[     17598,        410]
NotebookOutlinePosition[     18064,        428]
CellTagsIndexPosition[     18021,        425]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]h5_crtgrpar18\[CloseCurlyDoubleQuote]", \
"Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}, 
   3.5192935097227345`*^9, 3.5192943555601134`*^9, 3.519297569739954*^9, 
   3.5192996482954082`*^9, 3.5192998637117295`*^9}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/crtgrpar.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/crtgrpar.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/crtgrpar.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}, {3.519293488863541*^9, 
  3.5192934978050528`*^9}, {3.5192943687078657`*^9, 3.5192943692978992`*^9}, {
  3.519294399419622*^9, 3.519294399420622*^9}, {3.519297581437623*^9, 
  3.519297589704096*^9}, {3.5192996582149763`*^9, 3.519299666932474*^9}, {
  3.519299875591409*^9, 3.5192998884281435`*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"/", 
    RowBox[{
    "*", "\n", " ", "*", "   ", "Creating", " ", "groups", " ", "using", " ", 
     "absolute", " ", "and", " ", "relative", " ", 
     RowBox[{"names", "."}], "\n", " ", "*", 
     RowBox[{"/", "\n", "\n", "#"}], "include", " ", "\"\<hdf5.h\>\""}]}], 
   "\n", 
   RowBox[{"#", "define", " ", "FILE", " ", "\"\<groups.h5\>\""}], "\n", "\n", 
   RowBox[{"int", " ", "main", 
    RowBox[{"(", ")"}], " ", 
    RowBox[{"{", "\n", "\n", "   ", 
     RowBox[{
      RowBox[{"hid_t", "       ", "file_id"}], ",", " ", "group1_id", ",", 
      " ", "group2_id", ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"group3_id", ";"}], "  ", "/"}], "*", " ", 
                    "identifiers", " ", "*", 
                    RowBox[{"/", "\n", "   ", "herr_t"}], "      ", 
                    "status"}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                    "Create", " ", "a", " ", "new", " ", "file", " ", "using",
                     " ", "default", " ", 
                    RowBox[{"properties", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "file_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Fcreate", 
                    RowBox[{"(", 
                    RowBox[{"FILE", ",", " ", 
                    RowBox[{"H5F_ACC", "_TRUNC"}], ",", " ", "H5P_DEFAULT", 
                    ",", " ", "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", 
                    "   ", "/"}], "*", " ", "Create", " ", "group", " ", 
                    "\"\<MyGroup\>\"", " ", "in", " ", "the", " ", "root", 
                    " ", "group", " ", "using", " ", "absolute", " ", 
                    RowBox[{"name", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "group1_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Gcreate", 
                    RowBox[{"(", 
                    RowBox[{
                    "file_id", ",", " ", "\"\</MyGroup\>\"", ",", " ", 
                    "H5P_DEFAULT", ",", " ", "H5P_DEFAULT", ",", " ", 
                    "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
                    "/"}], "*", " ", "Create", " ", "group", " ", 
                    "\"\<Group_A\>\"", " ", "in", " ", "group", " ", 
                    "\"\<MyGroup\>\"", " ", "using", " ", "absolute", " ", 
                    RowBox[{"name", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "group2_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Gcreate", 
                    RowBox[{"(", 
                    RowBox[{
                    "file_id", ",", " ", "\"\</MyGroup/Group_A\>\"", ",", " ",
                     "H5P_DEFAULT", ",", " ", "H5P_DEFAULT", ",", " ", 
                    "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
                  "/"}], "*", " ", "Create", " ", "group", " ", 
                 "\"\<Group_B\>\"", " ", "in", " ", "group", " ", 
                 "\"\<MyGroup\>\"", " ", "using", " ", "relative", " ", 
                 RowBox[{"name", "."}], " ", "*", 
                 RowBox[{"/", "\n", "   ", "group3_id"}]}], " ", "=", " ", 
                RowBox[{"H5Gcreate", 
                 RowBox[{"(", 
                  RowBox[{
                  "group1_id", ",", " ", "\"\<Group_B\>\"", ",", " ", 
                   "H5P_DEFAULT", ",", " ", "H5P_DEFAULT", ",", " ", 
                   "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
              "/"}], "*", " ", "Close", " ", 
             RowBox[{"groups", "."}], " ", "*", 
             RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
            RowBox[{"H5Gclose", 
             RowBox[{"(", "group1_id", ")"}]}]}], ";", "\n", "   ", 
           RowBox[{"status", " ", "=", " ", 
            RowBox[{"H5Gclose", 
             RowBox[{"(", "group2_id", ")"}]}]}], ";", "\n", "   ", 
           RowBox[{"status", " ", "=", " ", 
            RowBox[{"H5Gclose", 
             RowBox[{"(", "group3_id", ")"}]}]}], ";"}], "\n", "\n", "   ", 
          "/"}], "*", " ", "Close", " ", "the", " ", 
         RowBox[{"file", "."}], " ", "*", 
         RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
        RowBox[{"H5Fclose", 
         RowBox[{"(", "file_id", ")"}]}]}], ";"}]}], "\n", "}"}]}], "\n", 
   "\n"}], "}"}]], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{
  3.519293195844782*^9, {3.519293535018181*^9, 3.5192935371253014`*^9}, 
   3.5192947363358927`*^9, {3.5192976111403217`*^9, 3.519297613493457*^9}, 
   3.519299687043625*^9, 3.519299907039208*^9},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.519313443658458*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519298385033586*^9, 3.5192985987368093`*^9, {
   3.519298677505315*^9, 3.5192987039768286`*^9}, {3.519299021085534*^9, 
   3.5192990583276644`*^9}, 3.519299150636944*^9, 3.519299358026806*^9, 
   3.5192998028952513`*^9, {3.519299974267053*^9, 3.519299990806999*^9}, 
   3.5193000243959208`*^9, 3.5196628714532394`*^9, 3.5198585658354073`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<groups.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}, {
   3.519293546201821*^9, 3.519293546673848*^9}, {3.519299700630402*^9, 
   3.5192997010814276`*^9}, 3.5192999274513755`*^9}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\groups.h5\"\>"],\
 "Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192935900623293`*^9, 
   3.5192940722649097`*^9, 3.519294143445981*^9, 3.5192942649679317`*^9, 
   3.51929519942638*^9, 3.5192956052085896`*^9, 3.5192958766121125`*^9, {
   3.5192961627434783`*^9, 3.519296189952035*^9}, 3.5192964982366676`*^9, 
   3.5192967151690755`*^9, 3.5192968294806137`*^9, {3.5192969870256248`*^9, 
   3.5192969988793025`*^9}, 3.519297067500228*^9, {3.5192971250555196`*^9, 
   3.519297178339567*^9}, 3.5192972211590166`*^9, 3.5192973163494606`*^9, 
   3.5192983855706167`*^9, 3.519298599190835*^9, {3.5192986775503173`*^9, 
   3.5192987040238314`*^9}, {3.5192990211415377`*^9, 3.5192990590117035`*^9}, 
   3.5192991507349496`*^9, 3.5192993581158113`*^9, 3.519299803606292*^9, {
   3.5192999743440576`*^9, 3.519299990840001*^9}, 3.519300024877948*^9, 
   3.519662872299288*^9, 3.519858565861409*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fcreate", "[", 
   RowBox[{
   "file", ",", "H5FuACCuTRUNC", ",", "H5PuDEFAULT", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}, {
  3.51929517844018*^9, 3.51929519331003*^9}, {3.5192997040635986`*^9, 
  3.519299719896504*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, 
   3.519295201047473*^9, 3.5192956052665925`*^9, 3.519295876670116*^9, {
   3.51929616276748*^9, 3.519296189973036*^9}, 3.5192964997407537`*^9, 
   3.519296715224078*^9, 3.5192968295336165`*^9, {3.5192969870766277`*^9, 
   3.519296998899304*^9}, 3.5192970675232286`*^9, {3.519297125100522*^9, 
   3.5192971783905697`*^9}, 3.519297221207019*^9, 3.519297316401464*^9, 
   3.51929838561862*^9, 3.5192985992418385`*^9, {3.5192986775683184`*^9, 
   3.5192987040438323`*^9}, {3.5192990211625385`*^9, 3.519299059067707*^9}, 
   3.519299150750951*^9, 3.519299358131812*^9, 3.519299803656295*^9, {
   3.5192999743630586`*^9, 3.5192999908630023`*^9}, 3.51930002492395*^9, 
   3.519662872352291*^9, 3.51985856587741*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"group1ID", "=", 
  RowBox[{"H5Gcreate", "[", 
   RowBox[{
   "fileID", ",", " ", "\"\</MyGroup\>\"", ",", " ", "H5PuDEFAULT", ",", 
    "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519295208255885*^9, 3.519295229725113*^9}, {
   3.5192997260598564`*^9, 3.519299743166835*^9}, 3.5192999401070995`*^9, {
   3.519299979934377*^9, 3.519299980939435*^9}}],

Cell[BoxData["33554432"], "Output",
 CellChangeTimes->{
  3.519295230478156*^9, 3.519295605287594*^9, 3.519295876693117*^9, {
   3.519296162791481*^9, 3.519296189995037*^9}, 3.5192965010508285`*^9, 
   3.51929671525508*^9, 3.5192968295516176`*^9, {3.519296987098629*^9, 
   3.5192969989233055`*^9}, 3.5192970675522304`*^9, {3.5192971251255236`*^9, 
   3.5192971784155717`*^9}, 3.51929722122502*^9, 3.519297316419465*^9, 
   3.5192983856416206`*^9, 3.519298599257839*^9, {3.519298677586319*^9, 
   3.5192987040618334`*^9}, {3.51929902118754*^9, 3.5192990590947084`*^9}, 
   3.519299150777952*^9, 3.519299358146813*^9, 3.519299743640862*^9, 
   3.5192998036772957`*^9, {3.51929997439106*^9, 3.519299990890004*^9}, 
   3.5193000249389515`*^9, 3.519662872372292*^9, 3.519858565894411*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"group2ID", "=", 
  RowBox[{"H5Gcreate", "[", 
   RowBox[{
   "fileID", ",", " ", "\"\</MyGroup/Group_A\>\"", ",", " ", "H5PuDEFAULT", 
    ",", "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519299946214449*^9, 3.5192999843626304`*^9}}],

Cell[BoxData["33554433"], "Output",
 CellChangeTimes->{{3.5192999744110613`*^9, 3.5192999909120054`*^9}, 
   3.5193000249539523`*^9, 3.5196628723962936`*^9, 3.519858565910412*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"group3ID", "=", 
  RowBox[{"H5Gcreate", "[", 
   RowBox[{
   "fileID", ",", " ", "\"\<Group_B\>\"", ",", " ", "H5PuDEFAULT", ",", 
    "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5192999472275066`*^9, 3.5192999872937984`*^9}}],

Cell[BoxData["33554434"], "Output",
 CellChangeTimes->{{3.5192999744310627`*^9, 3.5192999909340067`*^9}, 
   3.5193000249699535`*^9, 3.519662872416294*^9, 3.5198585659264126`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"H5Gclose", "[", "group1ID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Gclose", "[", "group2ID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Gclose", "[", "group3ID", "]"}]}], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
  3.519294255857411*^9, 3.519294258239547*^9}, {3.5192976786471834`*^9, 
  3.5192976970572357`*^9}, {3.5192978590565023`*^9, 3.519297865346862*^9}, {
  3.519298947165306*^9, 3.5192989534256644`*^9}, {3.5192997733345604`*^9, 
  3.5192997910195723`*^9}, {3.519299915975719*^9, 3.5192999227341056`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.519299791492599*^9, 3.519299803702297*^9}, {
   3.519299974477065*^9, 3.5192999909570074`*^9}, 3.519300024987954*^9, 
   3.519662872438296*^9, 3.5198585659444137`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.519299791492599*^9, 3.519299803702297*^9}, {
   3.519299974477065*^9, 3.5192999909570074`*^9}, 3.519300024987954*^9, 
   3.519662872438296*^9, 3.519858565946414*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.519299791492599*^9, 3.519299803702297*^9}, {
   3.519299974477065*^9, 3.5192999909570074`*^9}, 3.519300024987954*^9, 
   3.519662872438296*^9, 3.519858565947414*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Fclose", "[", "fileID", "]"}]], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
  3.519294255857411*^9, 3.519294258239547*^9}, {3.5192976786471834`*^9, 
  3.5192976970572357`*^9}, {3.5192978590565023`*^9, 3.519297865346862*^9}, {
  3.519298947165306*^9, 3.5192989534256644`*^9}, {3.5192997733345604`*^9, 
  3.5192997739895983`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5192985031613426`*^9, 3.5192985994728518`*^9, {3.5192986776473227`*^9, 
   3.5192987041208367`*^9}, {3.5192990212795453`*^9, 3.5192990593657236`*^9}, 
   3.519299150862957*^9, 3.5192993582138166`*^9, {3.519299793242699*^9, 
   3.5192998037192984`*^9}, {3.519299974508067*^9, 3.5192999909780087`*^9}, 
   3.519300025006955*^9, 3.5196628724642973`*^9, 3.519858565963415*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1089, 983},
WindowMargins->{{81, Automatic}, {10, Automatic}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 278, 4, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[882, 30, 98, 1, 105, "Section"],
Cell[983, 33, 762, 14, 41, "Text"],
Cell[1748, 49, 663, 12, 41, "Text"],
Cell[2414, 63, 607, 13, 90, "Text"],
Cell[3024, 78, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3338, 90, 187, 4, 105, "Section"],
Cell[3528, 96, 5257, 113, 959, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[8822, 214, 144, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[8991, 220, 171, 3, 43, "Input"],
Cell[9165, 225, 1201, 16, 42, "Output"]
}, Open  ]],
Cell[10381, 244, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[10544, 250, 390, 9, 43, "Input"],
Cell[10937, 261, 982, 14, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11956, 280, 343, 8, 43, "Input"],
Cell[12302, 290, 887, 12, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13226, 307, 407, 8, 43, "Input"],
Cell[13636, 317, 784, 11, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14457, 333, 291, 6, 71, "Input"],
Cell[14751, 341, 179, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14967, 348, 284, 6, 43, "Input"],
Cell[15254, 356, 179, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15470, 363, 577, 8, 98, "Input"],
Cell[16050, 373, 218, 3, 42, "Output"],
Cell[16271, 378, 216, 3, 42, "Output"],
Cell[16490, 383, 216, 3, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16743, 391, 387, 6, 43, "Input"],
Cell[17133, 399, 425, 6, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
