(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     46791,       1189]
NotebookOptionsPosition[     42281,       1032]
NotebookOutlinePosition[     43309,       1066]
CellTagsIndexPosition[     43223,       1061]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]h5_crtgrpd18\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}, 
   3.5192935097227345`*^9, 3.5192943555601134`*^9, 3.519297569739954*^9, 
   3.5192996482954082`*^9, 3.5192998637117295`*^9, 3.519300195040681*^9}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/crtgrpd.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/crtgrpd.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/crtgrpd.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}, {3.519293488863541*^9, 
  3.5192934978050528`*^9}, {3.5192943687078657`*^9, 3.5192943692978992`*^9}, {
  3.519294399419622*^9, 3.519294399420622*^9}, {3.519297581437623*^9, 
  3.519297589704096*^9}, {3.5192996582149763`*^9, 3.519299666932474*^9}, {
  3.519299875591409*^9, 3.5192998884281435`*^9}, {3.51930020377318*^9, 
  3.5193002097265205`*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[{
 RowBox[{"/", 
  RowBox[{
  "*", "\n", " ", "*", "  ", "Create", " ", "two", " ", "datasets", " ", 
   "within", " ", 
   RowBox[{"groups", "."}], "\n", " ", "*", 
   RowBox[{"/", "\n", "\n", "#"}], "include", " ", "\"\<hdf5.h\>\""}]}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "FILE", " ", "\"\<groups.h5\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"int", " ", "main", 
   RowBox[{"(", ")"}], " ", 
   RowBox[{"{", "\n", "\n", "   ", 
    RowBox[{
     RowBox[{"hid_t", "       ", "file_id"}], ",", " ", "group_id", ",", " ", 
     "dataset_id", ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"dataspace_id", ";"}], "  ", "/"}], "*", " ", "identifiers", 
       " ", "*", 
       RowBox[{"/", "\n", "   ", "hsize_t"}], "     ", 
       RowBox[{"dims", "[", "2", "]"}]}], ";", "\n", "   ", 
      RowBox[{"herr_t", "      ", "status"}], ";", "\n", "   ", 
      RowBox[{"int", "         ", "i"}]}], ",", " ", "j", ",", " ", 
     RowBox[{
      RowBox[{"dset1_data", "[", "3", "]"}], "[", "3", "]"}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"dset2_data", "[", "2", "]"}], "[", "10", "]"}], 
                    ";"}], "\n", "\n", "   ", "/"}], "*", " ", "Initialize", 
                    " ", "the", " ", "first", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "for"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"i", " ", "<", " ", "3"}], ";", " ", 
                    RowBox[{"i", "++"}]}], ")"}], "\n", "      ", "for", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"j", " ", "<", " ", "3"}], ";", " ", 
                    RowBox[{"j", "++"}]}], ")"}], "\n", "         ", 
                    RowBox[{
                    RowBox[{"dset1_data", "[", "i", "]"}], "[", "j", "]"}]}], 
                    " ", "=", " ", 
                    RowBox[{"j", " ", "+", " ", "1"}]}], ";"}], "\n", "\n", 
                    "   ", "/"}], "*", " ", "Initialize", " ", "the", " ", 
                    "second", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "for"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"i", " ", "<", " ", "2"}], ";", " ", 
                    RowBox[{"i", "++"}]}], ")"}], "\n", "      ", "for", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"j", " ", "<", " ", "10"}], ";", " ", 
                    RowBox[{"j", "++"}]}], ")"}], "\n", "         ", 
                    RowBox[{
                    RowBox[{"dset2_data", "[", "i", "]"}], "[", "j", "]"}]}], 
                    " ", "=", " ", 
                    RowBox[{"j", " ", "+", " ", "1"}]}], ";"}], "\n", "\n", 
                    "   ", "/"}], "*", " ", "Open", " ", "an", " ", 
                    "existing", " ", 
                    RowBox[{"file", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "file_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Fopen", 
                    RowBox[{"(", 
                    RowBox[{"FILE", ",", " ", 
                    RowBox[{"H5F_ACC", "_RDWR"}], ",", " ", "H5P_DEFAULT"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                    "Create", " ", "the", " ", "data", " ", "space", " ", 
                    "for", " ", "the", " ", "first", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", 
                    RowBox[{"dims", "[", "0", "]"}]}]}], " ", "=", " ", "3"}],
                     ";", "\n", "   ", 
                    RowBox[{
                    RowBox[{"dims", "[", "1", "]"}], " ", "=", " ", "3"}], 
                    ";", "\n", "   ", 
                    RowBox[{"dataspace_id", " ", "=", " ", 
                    RowBox[{"H5Screate_simple", 
                    RowBox[{"(", 
                    RowBox[{"2", ",", " ", "dims", ",", " ", "NULL"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                    "Create", " ", "a", " ", "dataset", " ", "in", " ", 
                    "group", " ", 
                    RowBox[{"\"\<MyGroup\>\"", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "dataset_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Dcreate", 
                    RowBox[{"(", 
                    RowBox[{
                    "file_id", ",", " ", "\"\</MyGroup/dset1\>\"", ",", " ", 
                    RowBox[{"H5T_STD", "_I32BE"}], ",", " ", "dataspace_id", 
                    ",", "\n", "                          ", "H5P_DEFAULT", 
                    ",", " ", "H5P_DEFAULT", ",", " ", "H5P_DEFAULT"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                    "Write", " ", "the", " ", "first", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
                    RowBox[{"H5Dwrite", 
                    RowBox[{"(", 
                    RowBox[{"dataset_id", ",", " ", 
                    RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", 
                    " ", "H5S_ALL", ",", " ", "H5P_DEFAULT", ",", "\n", 
                    "                     ", "dset1_data"}], ")"}]}]}], ";"}],
                     "\n", "\n", "   ", "/"}], "*", " ", "Close", " ", "the", 
                    " ", "data", " ", "space", " ", "for", " ", "the", " ", 
                    "first", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
                    RowBox[{"H5Sclose", 
                    RowBox[{"(", "dataspace_id", ")"}]}]}], ";"}], "\n", "\n",
                     "   ", "/"}], "*", " ", "Close", " ", "the", " ", 
                    "first", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
                    RowBox[{"H5Dclose", 
                    RowBox[{"(", "dataset_id", ")"}]}]}], ";"}], "\n", "\n", 
                    "   ", "/"}], "*", " ", "Open", " ", "an", " ", 
                    "existing", " ", "group", " ", "of", " ", "the", " ", 
                    "specified", " ", 
                    RowBox[{"file", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "group_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Gopen", 
                    RowBox[{"(", 
                    RowBox[{
                    "file_id", ",", " ", "\"\</MyGroup/Group_A\>\"", ",", " ",
                     "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
                    "/"}], "*", " ", "Create", " ", "the", " ", "data", " ", 
                    "space", " ", "for", " ", "the", " ", "second", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", 
                    RowBox[{"dims", "[", "0", "]"}]}]}], " ", "=", " ", "2"}],
                     ";", "\n", "   ", 
                    RowBox[{
                    RowBox[{"dims", "[", "1", "]"}], " ", "=", " ", "10"}], 
                    ";", "\n", "   ", 
                    RowBox[{"dataspace_id", " ", "=", " ", 
                    RowBox[{"H5Screate_simple", 
                    RowBox[{"(", 
                    RowBox[{"2", ",", " ", "dims", ",", " ", "NULL"}], 
                    ")"}]}]}], ";"}], "\n", "\n", "   ", "/"}], "*", " ", 
                    "Create", " ", "the", " ", "second", " ", "dataset", " ", 
                    "in", " ", "group", " ", 
                    RowBox[{"\"\<Group_A\>\"", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "dataset_id"}]}], " ", "=", " ", 
                    RowBox[{"H5Dcreate", 
                    RowBox[{"(", 
                    RowBox[{"group_id", ",", " ", "\"\<dset2\>\"", ",", " ", 
                    RowBox[{"H5T_STD", "_I32BE"}], ",", " ", "dataspace_id", 
                    ",", " ", "\n", "                          ", 
                    "H5P_DEFAULT", ",", " ", "H5P_DEFAULT", ",", " ", 
                    "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "   ", 
                    "/"}], "*", " ", "Write", " ", "the", " ", "second", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
                    RowBox[{"H5Dwrite", 
                    RowBox[{"(", 
                    RowBox[{"dataset_id", ",", " ", 
                    RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", 
                    " ", "H5S_ALL", ",", " ", "H5P_DEFAULT", ",", "\n", 
                    "                     ", "dset2_data"}], ")"}]}]}], ";"}],
                     "\n", "\n", "   ", "/"}], "*", " ", "Close", " ", "the", 
                    " ", "data", " ", "space", " ", "for", " ", "the", " ", 
                    "second", " ", 
                    RowBox[{"dataset", "."}], " ", "*", 
                    RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
                   RowBox[{"H5Sclose", 
                    RowBox[{"(", "dataspace_id", ")"}]}]}], ";"}], "\n", "\n",
                  "   ", "/"}], "*", " ", "Close", " ", "the", " ", "second", 
                " ", "dataset", " ", "*", 
                RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
               RowBox[{"H5Dclose", 
                RowBox[{"(", "dataset_id", ")"}]}]}], ";"}], "\n", "\n", 
             "   ", "/"}], "*", " ", "Close", " ", "the", " ", 
            RowBox[{"group", "."}], " ", "*", 
            RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
           RowBox[{"H5Gclose", 
            RowBox[{"(", "group_id", ")"}]}]}], ";"}], "\n", "\n", "   ", 
         "/"}], "*", " ", "Close", " ", "the", " ", 
        RowBox[{"file", "."}], " ", "*", 
        RowBox[{"/", "\n", "   ", "status"}]}], " ", "=", " ", 
       RowBox[{"H5Fclose", 
        RowBox[{"(", "file_id", ")"}]}]}], ";"}]}], "\n", "}"}]}], 
  "\n"}], "\n"}], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{
  3.519293195844782*^9, {3.519293535018181*^9, 3.5192935371253014`*^9}, 
   3.5192947363358927`*^9, {3.5192976111403217`*^9, 3.519297613493457*^9}, 
   3.519299687043625*^9, 3.519299907039208*^9, 3.519300234101915*^9},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.5193134509158735`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519298385033586*^9, 3.5192985987368093`*^9, {
   3.519298677505315*^9, 3.5192987039768286`*^9}, {3.519299021085534*^9, 
   3.5192990583276644`*^9}, 3.519299150636944*^9, 3.519299358026806*^9, 
   3.5192998028952513`*^9, {3.519299974267053*^9, 3.519299990806999*^9}, 
   3.5193000243959208`*^9, 3.519300554724253*^9, 3.5196635337611213`*^9, 
   3.519858570882696*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<groups.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}, {
   3.519293546201821*^9, 3.519293546673848*^9}, {3.519299700630402*^9, 
   3.5192997010814276`*^9}, 3.5192999274513755`*^9}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\groups.h5\"\>"],\
 "Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192935900623293`*^9, 
   3.5192940722649097`*^9, 3.519294143445981*^9, 3.5192942649679317`*^9, 
   3.51929519942638*^9, 3.5192956052085896`*^9, 3.5192958766121125`*^9, {
   3.5192961627434783`*^9, 3.519296189952035*^9}, 3.5192964982366676`*^9, 
   3.5192967151690755`*^9, 3.5192968294806137`*^9, {3.5192969870256248`*^9, 
   3.5192969988793025`*^9}, 3.519297067500228*^9, {3.5192971250555196`*^9, 
   3.519297178339567*^9}, 3.5192972211590166`*^9, 3.5192973163494606`*^9, 
   3.5192983855706167`*^9, 3.519298599190835*^9, {3.5192986775503173`*^9, 
   3.5192987040238314`*^9}, {3.5192990211415377`*^9, 3.5192990590117035`*^9}, 
   3.5192991507349496`*^9, 3.5192993581158113`*^9, 3.519299803606292*^9, {
   3.5192999743440576`*^9, 3.519299990840001*^9}, 3.519300024877948*^9, 
   3.5193005569333797`*^9, 3.5196635346031694`*^9, 3.5198585709066973`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSet1Data", "=", 
  RowBox[{"Table", "[", 
   RowBox[{"j", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193003075491157`*^9, 3.5193003106262913`*^9}, {
  3.51930042877905*^9, 3.5193004449889765`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.519300440566724*^9, 3.519300445391*^9}, 
   3.5193005583824625`*^9, 3.5196635346271706`*^9, 3.5198585709236984`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSet2Data", "=", 
  RowBox[{"Table", "[", 
   RowBox[{"j", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "10"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519300454746535*^9, 3.5193004785558968`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8",
      ",", "9", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8",
      ",", "9", ",", "10"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5193004788259125`*^9, 3.5193005602315683`*^9, 
  3.519663534649172*^9, 3.5198585709406996`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fopen", "[", 
   RowBox[{"file", ",", "H5FuACCuRDWR", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}, {
  3.51929517844018*^9, 3.51929519331003*^9}, {3.5192997040635986`*^9, 
  3.519299719896504*^9}, {3.519300517294112*^9, 3.5193005410704727`*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, 
   3.519295201047473*^9, 3.5192956052665925`*^9, 3.519295876670116*^9, {
   3.51929616276748*^9, 3.519296189973036*^9}, 3.5192964997407537`*^9, 
   3.519296715224078*^9, 3.5192968295336165`*^9, {3.5192969870766277`*^9, 
   3.519296998899304*^9}, 3.5192970675232286`*^9, {3.519297125100522*^9, 
   3.5192971783905697`*^9}, 3.519297221207019*^9, 3.519297316401464*^9, 
   3.51929838561862*^9, 3.5192985992418385`*^9, {3.5192986775683184`*^9, 
   3.5192987040438323`*^9}, {3.5192990211625385`*^9, 3.519299059067707*^9}, 
   3.519299150750951*^9, 3.519299358131812*^9, 3.519299803656295*^9, {
   3.5192999743630586`*^9, 3.5192999908630023`*^9}, 3.51930002492395*^9, {
   3.5193005418225155`*^9, 3.519300561731654*^9}, 3.519663534704175*^9, 
   3.5198585709567003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSpaceID", "=", 
  RowBox[{"H5ScreateUsimple", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "3"}], "}"}], ",", "Null"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193005785726175`*^9, 3.519300600259858*^9}}],

Cell[BoxData["67108866"], "Output",
 CellChangeTimes->{{3.5193005916013627`*^9, 3.5193006006358795`*^9}, 
   3.5196635347231765`*^9, 3.519858570972701*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dcreate", "[", 
   RowBox[{"fileID", ",", "\"\</MyGroup/dset1\>\"", ",", 
    RowBox[{
     RowBox[{"H5T`copy", "[", "H5TuSTDuI32BE", "]"}], "@", 
     RowBox[{"Id", "[", "]"}]}], ",", "dataSpaceID", ",", "H5PuDEFAULT", ",", 
    "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193006122835455`*^9, 3.519300683856639*^9}, {
  3.519300716119485*^9, 3.519300717364556*^9}}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{3.5193007180135927`*^9, 3.5196635348671846`*^9, 
  3.5198585709927025`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dwrite", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
   "H5PuDEFAULT", ",", 
   RowBox[{"Flatten", "@", "dataSet1Data"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519300737805725*^9, 3.5193007944409647`*^9}, {
  3.519300831396078*^9, 3.519300835263299*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.519300795289013*^9, 3.5193008357863293`*^9, 
  3.5196635348861856`*^9, 3.519858571008703*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}]], "Input"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193008542483854`*^9, 3.5196635349021864`*^9, 
  3.5198585710257044`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}]], "Input"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.519300873548489*^9, 3.519663534920188*^9, 
  3.519858571041705*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"groupID", "=", 
  RowBox[{"H5Gopen", "[", 
   RowBox[{
   "fileID", ",", " ", "\"\</MyGroup/Group_A\>\"", ",", " ", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519295208255885*^9, 3.519295229725113*^9}, {
   3.5192997260598564`*^9, 3.519299743166835*^9}, 3.5192999401070995`*^9, {
   3.519299979934377*^9, 3.519299980939435*^9}, {3.519300900575035*^9, 
   3.5193009164069405`*^9}}],

Cell[BoxData["33554432"], "Output",
 CellChangeTimes->{
  3.519295230478156*^9, 3.519295605287594*^9, 3.519295876693117*^9, {
   3.519296162791481*^9, 3.519296189995037*^9}, 3.5192965010508285`*^9, 
   3.51929671525508*^9, 3.5192968295516176`*^9, {3.519296987098629*^9, 
   3.5192969989233055`*^9}, 3.5192970675522304`*^9, {3.5192971251255236`*^9, 
   3.5192971784155717`*^9}, 3.51929722122502*^9, 3.519297316419465*^9, 
   3.5192983856416206`*^9, 3.519298599257839*^9, {3.519298677586319*^9, 
   3.5192987040618334`*^9}, {3.51929902118754*^9, 3.5192990590947084`*^9}, 
   3.519299150777952*^9, 3.519299358146813*^9, 3.519299743640862*^9, 
   3.5192998036772957`*^9, {3.51929997439106*^9, 3.519299990890004*^9}, 
   3.5193000249389515`*^9, 3.5193009168579664`*^9, 3.5196635349361887`*^9, 
   3.5198585710587063`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSpaceID", "=", 
  RowBox[{"H5ScreateUsimple", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "10"}], "}"}], ",", "Null"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193005785726175`*^9, 3.519300600259858*^9}, {
  3.5193009295556927`*^9, 3.5193009313497953`*^9}}],

Cell[BoxData["67108866"], "Output",
 CellChangeTimes->{3.519300933568922*^9, 3.5196635349521894`*^9, 
  3.519858571074707*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dcreate", "[", 
   RowBox[{"groupID", ",", "\"\<dset2\>\"", ",", 
    RowBox[{
     RowBox[{"H5T`copy", "[", "H5TuSTDuI32BE", "]"}], "@", 
     RowBox[{"Id", "[", "]"}]}], ",", "dataSpaceID", ",", "H5PuDEFAULT", ",", 
    "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193006122835455`*^9, 3.519300683856639*^9}, {
  3.519300716119485*^9, 3.519300717364556*^9}, {3.519300963745648*^9, 
  3.5193009650497227`*^9}, {3.519663357402034*^9, 3.5196633581740785`*^9}}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{3.519300974006235*^9, 3.51966353497019*^9, 
  3.519858571091708*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dwrite", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
   "H5PuDEFAULT", ",", 
   RowBox[{"Flatten", "@", "dataSet2Data"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519300737805725*^9, 3.5193007944409647`*^9}, {
   3.519300831396078*^9, 3.519300835263299*^9}, 3.519300996404516*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009968885436`*^9, 3.519663534987191*^9, 
  3.5198585711087093`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Gclose", "[", "groupID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Fclose", "[", "fileID", "]"}]}], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
  3.519294255857411*^9, 3.519294258239547*^9}, {3.5192976786471834`*^9, 
  3.5192976970572357`*^9}, {3.5192978590565023`*^9, 3.519297865346862*^9}, {
  3.519298947165306*^9, 3.5192989534256644`*^9}, {3.5192997733345604`*^9, 
  3.5192997910195723`*^9}, {3.519299915975719*^9, 3.5192999227341056`*^9}, {
  3.5193002501308317`*^9, 3.519300284100775*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5196635350041924`*^9, 
  3.51985857112671*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5196635350041924`*^9, 
  3.5198585711287103`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5196635350041924`*^9, 
  3.51985857112971*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5196635350041924`*^9, 
  3.5198585711307106`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Implementation in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " using the Extend Functionality"
}], "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.519313400212973*^9, {3.5196551888108177`*^9, 3.5196551938611064`*^9}}],

Cell[TextData[{
 "This example is similar to the above but written with a syntax that is \
closer to normal ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " style and uses the \[OpenCurlyDoubleQuote]HDF5Extend`\
\[CloseCurlyDoubleQuote] for this purpose."
}], "Text",
 CellChangeTimes->{{3.5196552048007317`*^9, 3.519655235272475*^9}, {
   3.519662641042061*^9, 3.5196626468963957`*^9}, 3.519662806171506*^9}],

Cell["\<\
Remember that this function assumes it is operating on a fresh copy of \
\[OpenCurlyDoubleQuote]groups.h5\[CloseCurlyDoubleQuote]. It cannot be run in \
direct sequence to the foregoing implementation since groups.h5 is no longer \
fresh, i.e., the H5Dcreate commands will fail.\
\>", "Text",
 CellChangeTimes->{{3.5196637775560656`*^9, 3.5196638377535086`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Needs", "[", "\"\<HDF5Extend`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"file", "=", 
   RowBox[{"FileNameJoin", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Directory", "[", "]"}], ",", "\"\<groups.h5\>\""}], "}"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dataSet1Data", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "3"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"dataSet2Data", "=", 
  RowBox[{"Table", "[", 
   RowBox[{"j", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "10"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}, {
   3.5196552435039454`*^9, 3.5196552566506977`*^9}, {3.5196552987731066`*^9, 
   3.5196552990461226`*^9}, 3.5196621821898155`*^9, {3.5196628256286182`*^9, 
   3.519662849731997*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8",
      ",", "9", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8",
      ",", "9", ",", "10"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519297761970949*^9, 3.519298869500864*^9, 
   3.5192989037618237`*^9, 3.5192993398187647`*^9, 3.519315872570384*^9, 
   3.519317591178683*^9, 3.519655257179728*^9, {3.519655287897485*^9, 
   3.519655299776164*^9}, 3.5196561031441145`*^9, 3.5196564797036524`*^9, 
   3.519658519478321*^9, 3.519659137405664*^9, 3.5196594247320986`*^9, 
   3.51965973159465*^9, 3.519659804238805*^9, 3.5196603542822657`*^9, {
   3.5196607476307635`*^9, 3.519660759428438*^9}, 3.519660858848125*^9, 
   3.519661167239764*^9, 3.519661710594842*^9, 3.5196619134814463`*^9, 
   3.5196620860143147`*^9, 3.5196621340690637`*^9, 3.519662192348397*^9, 
   3.5196624766646585`*^9, 3.51966326921299*^9, 3.5196634049967566`*^9, 
   3.519663477317893*^9, 3.519663567552054*^9, 3.5196638434248333`*^9, 
   3.5198585711517115`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5FExtendOpen", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"fileID", "=", 
      RowBox[{"H5Fopen", "[", 
       RowBox[{"file", ",", "H5FuACCuRDWR", ",", "H5PuDEFAULT"}], "]"}]}], 
     "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
    "CompoundExpression", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dataSpaceID", "=", 
       RowBox[{"H5ScreateUsimple", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "3"}], "}"}], ",", "Null"}], "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"dataSetID", "=", 
       RowBox[{"H5Dcreate", "[", 
        RowBox[{"fileID", ",", "\"\</MyGroup/dset1\>\"", ",", 
         RowBox[{
          RowBox[{"H5T`copy", "[", "H5TuSTDuI32BE", "]"}], "@", 
          RowBox[{"Id", "[", "]"}]}], ",", "dataSpaceID", ",", "H5PuDEFAULT", 
         ",", "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"H5DExtendWrite", "[", 
       RowBox[{"dataSetID", ",", 
        RowBox[{
         RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
         RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
        "H5PuDEFAULT", ",", "dataSet1Data", ",", 
        RowBox[{"\"\<DataType\>\"", "\[Rule]", "Integer32"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"H5Dclose", "[", "dataSetID", "]"}], ",", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"H5GExtendOpen", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"groupID", "=", 
          RowBox[{"H5Gopen", "[", 
           RowBox[{
           "fileID", ",", " ", "\"\</MyGroup/Group_A\>\"", ",", " ", 
            "H5PuDEFAULT"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
        "CompoundExpression", "[", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"dataSpaceID", "=", 
           RowBox[{"H5ScreateUsimple", "[", 
            RowBox[{"2", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "10"}], "}"}], ",", "Null"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"dataSetID", "=", 
           RowBox[{"H5Dcreate", "[", 
            RowBox[{"groupID", ",", "\"\<dset2\>\"", ",", 
             RowBox[{
              RowBox[{"H5T`copy", "[", "H5TuSTDuI32BE", "]"}], "@", 
              RowBox[{"Id", "[", "]"}]}], ",", "dataSpaceID", ",", 
             "H5PuDEFAULT", ",", "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}],
           ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"H5DExtendWrite", "[", 
           RowBox[{"dataSetID", ",", 
            RowBox[{
             RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
             RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
            "H5PuDEFAULT", ",", "dataSet2Data", ",", 
            RowBox[{"\"\<DataType\>\"", "\[Rule]", "Integer32"}]}], "]"}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"H5Dclose", "[", "dataSetID", "]"}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], " ", 
       RowBox[{"(*", " ", 
        RowBox[{"close", " ", "CompoundExpression"}], " ", "*)"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], " ", 
     RowBox[{"(*", " ", 
      RowBox[{"close", " ", "H5GExtendOpen"}], " ", "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"close", " ", "CompoundExpression"}], " ", "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"close", " ", "H5FExtendOpen"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.519662937514018*^9, 3.519663253039065*^9}, {
  3.519663389391864*^9, 3.5196633901579075`*^9}, {3.519663636321987*^9, 
  3.519663650862819*^9}, {3.5196637198877673`*^9, 3.519663762272191*^9}}],

Cell[BoxData[
 RowBox[{"-", "1"}]], "Output",
 CellChangeTimes->{
  3.519663275838369*^9, 3.5196634128452053`*^9, {3.519663444147996*^9, 
   3.51966349859711*^9}, 3.519663651459853*^9, 3.5196638436788473`*^9, 
   3.5198585711757126`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Documentation of the employed Extend functions", "Subsubsection",
 CellChangeTimes->{{3.5196616644992056`*^9, 3.519661674808795*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "H5FExtendOpen"}]], "Input",
 CellChangeTimes->{{3.5196616767709074`*^9, 3.519661703057411*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5FExtendOpen[{\\\"fileIDsymbol\\\" = H5Fopen[....]}, body] \
sets the fileIDsymbol and then runs the body. The purpose of this function is \
that it provides an automatic H5Fclose[fileIDsymbol] after executing body. \
The return value is that of the body.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198585712357163`*^9},
 CellTags->"Info3519844171-7102080"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5FExtendOpen", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"HoldAll", ",", "ReadProtected"}], "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5FExtendOpen],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858571250717*^9},
 CellTags->"Info3519844171-7102080"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "H5GExtendOpen"}]], "Input",
 CellChangeTimes->{{3.519661682026208*^9, 3.519661701782338*^9}, 
   3.519663263496663*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5GExtendOpen[{\\\"groupIDsymbol\\\" = H5Gopen[....]}, body] \
sets the groupIDsymbol and then runs the body. The purpose of this function \
is that it provides an automatic H5Dclose[dataSetIDsymbol] after executing \
body. The return value is that of the body.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5198585713227215`*^9},
 CellTags->"Info3519844171-7102080"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5GExtendOpen", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"HoldAll", ",", "ReadProtected"}], "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5GExtendOpen],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198585713377223`*^9},
 CellTags->"Info3519844171-7102080"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "H5DExtendWrite"}]], "Input",
 CellChangeTimes->{{3.519661693745878*^9, 3.519661700360257*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5DExtendRead[\\\"DataSpaceID\\\", \\\"MemoryTypeID\\\", \
\\\"MemorySpaceID\\\", \\\"FileSpaceID\\\", \\\"xferPListID\\\", \
\\\"Data\\\"] writes data to a file. The first 5 arguments are as defined for \
H5Dwrite. The \\\"Data\\\" argument should be a list or a list of lists, \
depending on dimensions of data. This function takes the option \
\\\"DataType\\\", which is Integer32 by default. Other allowed values are \
Byte, SingleFloat, and DoubleFloat. (Other allowed values can be easily added \
by additional programming of H5Dwrite in \\\"HDF5`\\\" and of H5DExtendWrite \
in \\\"HDF5Extend`\\\".)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198585714147263`*^9},
 CellTags->"Info3519844171-7102080"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5DExtendWrite", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "H5DExtendWrite", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"\<\"DataType\"\>", "\[Rule]", "Integer32"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5DExtendWrite],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198585714297276`*^9},
 CellTags->"Info3519844171-7102080"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1089, 983},
WindowMargins->{{84, Automatic}, {Automatic, 25}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3519844171-7102080"->{
  Cell[38122, 911, 404, 6, 122, "Print",
   CellTags->"Info3519844171-7102080"],
  Cell[38529, 919, 527, 15, 32, "Print",
   CellTags->"Info3519844171-7102080"],
  Cell[39279, 947, 411, 7, 122, "Print",
   CellTags->"Info3519844171-7102080"],
  Cell[39693, 956, 529, 15, 32, "Print",
   CellTags->"Info3519844171-7102080"],
  Cell[40420, 983, 754, 11, 180, "Print",
   CellTags->"Info3519844171-7102080"],
  Cell[41177, 996, 1040, 29, 74, "Print",
   CellTags->"Info3519844171-7102080"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3519844171-7102080", 42711, 1045}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 297, 3, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[901, 29, 98, 1, 105, "Section"],
Cell[1002, 32, 809, 15, 41, "Text"],
Cell[1814, 49, 663, 12, 41, "Text"],
Cell[2480, 63, 607, 13, 90, "Text"],
Cell[3090, 78, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3404, 90, 187, 4, 105, "Section"],
Cell[3594, 96, 12624, 261, 2093, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[16255, 362, 146, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[16426, 368, 171, 3, 43, "Input"],
Cell[16600, 373, 1225, 17, 42, "Output"]
}, Open  ]],
Cell[17840, 393, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[18003, 399, 390, 9, 43, "Input"],
Cell[18396, 410, 1010, 14, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19443, 429, 348, 9, 43, "Input"],
Cell[19794, 440, 399, 10, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20230, 455, 297, 8, 43, "Input"],
Cell[20530, 465, 472, 12, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21039, 482, 364, 7, 43, "Input"],
Cell[21406, 491, 942, 13, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22385, 509, 258, 6, 43, "Input"],
Cell[22646, 517, 155, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22838, 524, 457, 9, 71, "Input"],
Cell[23298, 535, 130, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23465, 542, 452, 10, 71, "Input"],
Cell[23920, 554, 143, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24100, 561, 71, 1, 43, "Input"],
Cell[24174, 564, 123, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24334, 571, 69, 1, 43, "Input"],
Cell[24406, 574, 117, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24560, 581, 423, 9, 43, "Input"],
Cell[24986, 592, 816, 12, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25839, 609, 312, 7, 43, "Input"],
Cell[26154, 618, 126, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26317, 625, 548, 10, 71, "Input"],
Cell[26868, 637, 123, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27028, 644, 475, 10, 71, "Input"],
Cell[27506, 656, 121, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27664, 663, 698, 10, 125, "Input"],
Cell[28365, 675, 120, 2, 42, "Output"],
Cell[28488, 679, 123, 2, 42, "Output"],
Cell[28614, 683, 120, 2, 42, "Output"],
Cell[28737, 687, 123, 2, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28909, 695, 283, 7, 157, "Section"],
Cell[29195, 704, 415, 9, 99, "Text"],
Cell[29613, 715, 372, 6, 66, "Text"],
Cell[CellGroupData[{
Cell[30010, 725, 1178, 33, 152, "Input"],
Cell[31191, 760, 1937, 33, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33165, 798, 4366, 90, 1124, "Input"],
Cell[37534, 890, 237, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37808, 900, 139, 1, 38, "Subsubsection"],
Cell[CellGroupData[{
Cell[37972, 905, 125, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[38122, 911, 404, 6, 122, "Print",
 CellTags->"Info3519844171-7102080"],
Cell[38529, 919, 527, 15, 32, "Print",
 CellTags->"Info3519844171-7102080"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[39105, 940, 149, 3, 43, "Input"],
Cell[CellGroupData[{
Cell[39279, 947, 411, 7, 122, "Print",
 CellTags->"Info3519844171-7102080"],
Cell[39693, 956, 529, 15, 32, "Print",
 CellTags->"Info3519844171-7102080"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[40271, 977, 124, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[40420, 983, 754, 11, 180, "Print",
 CellTags->"Info3519844171-7102080"],
Cell[41177, 996, 1040, 29, 74, "Print",
 CellTags->"Info3519844171-7102080"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
