(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     53681,       1313]
NotebookOptionsPosition[     49662,       1169]
NotebookOutlinePosition[     50128,       1187]
CellTagsIndexPosition[     50085,       1184]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]h5_hype\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}, 
   3.5192935097227345`*^9, 3.5192943555601134`*^9, 3.519297569739954*^9, 
   3.5192996482954082`*^9, 3.5192998637117295`*^9, 3.519300195040681*^9, 
   3.5193122677061977`*^9, 3.519312579896054*^9}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/selectsimple.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/selectsimple.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/selectsimple.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}, {3.519293488863541*^9, 
  3.5192934978050528`*^9}, {3.5192943687078657`*^9, 3.5192943692978992`*^9}, {
  3.519294399419622*^9, 3.519294399420622*^9}, {3.519297581437623*^9, 
  3.519297589704096*^9}, {3.5192996582149763`*^9, 3.519299666932474*^9}, {
  3.519299875591409*^9, 3.5192998884281435`*^9}, {3.51930020377318*^9, 
  3.5193002097265205`*^9}, {3.5193122779837856`*^9, 3.5193122993560076`*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"/", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**"}]}], "*", "\n", " ", "*", "  ", "\n", " ", "*", 
  " ", "This", " ", "example", " ", "shows", " ", "how", " ", "to", " ", 
  "write", " ", "a", " ", "subset", " ", "of", " ", "data", " ", 
  RowBox[{"(", 
   RowBox[{"a", " ", "slab"}], ")"}], " ", "to"}], "\n", 
 RowBox[{" ", 
  RowBox[{
  "*", " ", "a", " ", "dataset", " ", "in", " ", "an", " ", "HDF5", " ", 
   RowBox[{"file", "."}], "\n", " ", "*", "\n", " ", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**"}], "*", 
   RowBox[{"/", "\n", " ", "\n", "#"}], "include", " ", "\"\<hdf5.h\>\""}], 
  "\n"}], "\n", 
 RowBox[{"#", "define", " ", "FILE", "        ", "\"\<hype.h5\>\""}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "DATASETNAME", " ", "\"\<IntArray\>\""}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "RANK", "  ", "2"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"/", 
   RowBox[{"*", " ", 
    RowBox[{"Note", ":", " ", 
     RowBox[{
     "changing", " ", "these", " ", "values", " ", "modifies", " ", "the", 
      " ", "subset", " ", 
      RowBox[{"size", "."}], " ", "*", 
      RowBox[{"/", "\n", "\n", "#"}], "define", " ", "DIM0_SUB", "  ", 
      RowBox[{"3", "                 ", "/"}], "*", " ", "subset", " ", 
      "dimensions", " ", "*", 
      RowBox[{"/", " ", "\n", "#"}], "define", " ", "DIM1_SUB", "  ", 
      "4"}]}]}]}], " ", "\n"}], "\n", 
 RowBox[{
  RowBox[{"/", 
   RowBox[{"*", " ", "End", " ", "Note", " ", "*", 
    RowBox[{"/", "\n", "\n", "#"}], "define", " ", "DIM0", "     ", 
    RowBox[{"8", "                 ", "/"}], "*", " ", "size", " ", "of", " ",
     "dataset", " ", "*", 
    RowBox[{"/", "       ", "\n", "#"}], "define", " ", "DIM1", "     ", 
    "10"}]}], " ", "\n"}], "\n", "int", "\n", 
 RowBox[{"main", " ", 
  RowBox[{"(", "void", ")"}]}], "\n", 
 RowBox[{"{", "\n", "    ", 
  RowBox[{
   RowBox[{"hsize_t", "     ", 
    RowBox[{"dims", "[", "2", "]"}]}], ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dimsm", "[", "2", "]"}], ";", "   ", "\n", "    ", 
            RowBox[{"int", "         ", 
             RowBox[{
              RowBox[{"data", "[", "DIM0", "]"}], "[", "DIM1", "]"}]}], ";"}],
            "           ", "/"}], "*", " ", "data", " ", "to", " ", "write", 
          " ", "*", 
          RowBox[{"/", "\n", "    ", "int"}], "         ", 
          RowBox[{
           RowBox[{"sdata", "[", "DIM0_SUB", "]"}], "[", "DIM1_SUB", "]"}]}], 
         ";"}], "  ", "/"}], "*", " ", "subset", " ", "to", " ", "write", " ",
        "*", 
       RowBox[{"/", "\n", "    ", "int"}], "         ", 
       RowBox[{
        RowBox[{"rdata", "[", "DIM0", "]"}], "[", "DIM1", "]"}]}], ";"}], 
     "          ", "/"}], "*", " ", "buffer", " ", "for", " ", "read", " ", 
    "*", 
    RowBox[{"/", "\n", " ", "\n", "    ", "hid_t"}], "       ", "file_id"}], 
   ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"dataset_id", ";"}], "        ", "/"}], "*", " ", "handles", " ",
     "*", 
    RowBox[{"/", "\n", "    ", "hid_t"}], "       ", "dataspace_id"}], ",", 
   " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"memspace_id", ";", " ", "\n", "\n", "    ", 
          RowBox[{"herr_t", "      ", "status"}], ";", 
          "                             ", "\n", "   ", "\n", "    ", 
          RowBox[{"hsize_t", "     ", 
           RowBox[{"count", "[", "2", "]"}]}], ";"}], "              ", "/"}],
         "*", " ", "size", " ", "of", " ", "subset", " ", "in", " ", "the", 
        " ", "file", " ", "*", 
        RowBox[{"/", "\n", "    ", "hsize_t"}], "     ", 
        RowBox[{"offset", "[", "2", "]"}]}], ";"}], "             ", "/"}], 
     "*", " ", "subset", " ", "offset", " ", "in", " ", "the", " ", "file", 
     " ", "*", 
     RowBox[{"/", "\n", "    ", "hsize_t"}], "     ", 
     RowBox[{"stride", "[", "2", "]"}]}], ";", "\n", "    ", 
    RowBox[{"int", "         ", "i"}]}], ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"j", ";"}], "\n", "\n", "\n", "    ", "/", 
                    RowBox[{
                    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**", "**"}]}], "*", "\n", "     ", "*", " ", "Create", 
                    " ", "a", " ", "new", " ", "file", " ", "with", " ", 
                    "default", " ", "creation", " ", "and", " ", "access", 
                    " ", 
                    RowBox[{"properties", "."}], "\n", "     ", "*", " ", 
                    "Then", " ", "create", " ", "a", " ", "dataset", " ", 
                    "and", " ", "write", " ", "data", " ", "to", " ", "it", 
                    " ", "and", " ", "close", " ", "the", " ", "file", "\n", 
                    "     ", "*", " ", "and", " ", 
                    RowBox[{"dataset", ".", " ", "\n", "     ", 
                    RowBox[{
                    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                     "**", "**"}]}], "*", 
                    RowBox[{"/", "\n", "\n", "    ", "file_id"}]}], " ", "=", 
                   " ", 
                   RowBox[{"H5Fcreate", " ", 
                    RowBox[{"(", 
                    RowBox[{"FILE", ",", " ", 
                    RowBox[{"H5F_ACC", "_TRUNC"}], ",", " ", "H5P_DEFAULT", 
                    ",", " ", "H5P_DEFAULT"}], ")"}]}]}], ";", "\n", "\n", 
                  "    ", 
                  RowBox[{
                   RowBox[{"dims", "[", "0", "]"}], " ", "=", " ", "DIM0"}], 
                  ";", "\n", "    ", 
                  RowBox[{
                   RowBox[{"dims", "[", "1", "]"}], " ", "=", " ", "DIM1"}], 
                  ";", "\n", "    ", 
                  RowBox[{"dataspace_id", " ", "=", " ", 
                   RowBox[{"H5Screate_simple", " ", 
                    RowBox[{"(", 
                    RowBox[{"RANK", ",", " ", "dims", ",", " ", "NULL"}], 
                    ")"}]}]}], ";", " ", "\n", "\n", "    ", 
                  RowBox[{"dataset_id", " ", "=", " ", 
                   RowBox[{"H5Dcreate", " ", 
                    RowBox[{"(", 
                    RowBox[{"file_id", ",", " ", "DATASETNAME", ",", " ", 
                    RowBox[{"H5T_STD", "_I32BE"}], ",", " ", "dataspace_id", 
                    ",", "\n", "                         ", "H5P_DEFAULT", 
                    ",", " ", "H5P_DEFAULT", ",", " ", "H5P_DEFAULT"}], 
                    ")"}]}]}], ";", "\n", "\n", "\n", "    ", 
                  RowBox[{
                   RowBox[{"for", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"j", " ", "<", " ", "DIM0"}], ";", " ", 
                    RowBox[{"j", "++"}]}], ")"}], " ", 
                    RowBox[{"{", "\n", "\t", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"for", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"i", " ", "<", " ", "DIM1"}], ";", " ", 
                    RowBox[{"i", "++"}]}], ")"}], "\n", "            ", "if", 
                    " ", 
                    RowBox[{"(", 
                    RowBox[{"i", "<", " ", 
                    RowBox[{"(", 
                    RowBox[{"DIM1", "/", "2"}], ")"}]}], ")"}], "\n", 
                    "\t       ", 
                    RowBox[{
                    RowBox[{"data", "[", "j", "]"}], "[", "i", "]"}]}], " ", 
                    "=", " ", "1"}], ";", "\n", "            ", 
                    RowBox[{
                    RowBox[{"else", "\n", "               ", 
                    RowBox[{
                    RowBox[{"data", "[", "j", "]"}], "[", "i", "]"}]}], " ", 
                    "=", " ", "2"}], ";"}], "\n", "    ", "}"}], "     ", 
                    "\n", "\n", "    ", "status"}], " ", "=", " ", 
                   RowBox[{"H5Dwrite", " ", 
                    RowBox[{"(", 
                    RowBox[{"dataset_id", ",", " ", 
                    RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", 
                    " ", "H5S_ALL", ",", "\n", "                      ", 
                    "H5P_DEFAULT", ",", " ", "data"}], ")"}]}]}], ";", "\n", 
                  "\n", "    ", 
                  RowBox[{"printf", " ", 
                   RowBox[{
                   "(", "\"\<\\nData Written to File:\\n\>\"", ")"}]}], ";", 
                  "\n", "    ", 
                  RowBox[{
                   RowBox[{"for", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"i", "<", "DIM0"}], ";", " ", 
                    RowBox[{"i", "++"}]}], ")"}], 
                    RowBox[{"{", "\n", "       ", 
                    RowBox[{
                    RowBox[{"for", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
                    RowBox[{"j", "<", "DIM1"}], ";", " ", 
                    RowBox[{"j", "++"}]}], ")"}], "\n", "           ", 
                    "printf", " ", 
                    RowBox[{"(", 
                    RowBox[{"\"\< %i\>\"", ",", " ", 
                    RowBox[{
                    RowBox[{"data", "[", "i", "]"}], "[", "j", "]"}]}], 
                    ")"}]}], ";", "\n", "       ", 
                    RowBox[{"printf", " ", 
                    RowBox[{"(", "\"\<\\n\>\"", ")"}]}], ";"}], "\n", "    ", 
                    "}"}], "\n", "    ", "status"}], " ", "=", " ", 
                   RowBox[{"H5Sclose", " ", 
                    RowBox[{"(", "dataspace_id", ")"}]}]}], ";", "\n", "    ", 
                  RowBox[{"status", " ", "=", " ", 
                   RowBox[{"H5Dclose", " ", 
                    RowBox[{"(", "dataset_id", ")"}]}]}], ";", "\n", "    ", 
                  RowBox[{"status", " ", "=", " ", 
                   RowBox[{"H5Fclose", " ", 
                    RowBox[{"(", "file_id", ")"}]}]}], ";"}], "\n", "\n", 
                 "\n", "    ", "/", 
                 RowBox[{
                 "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                   "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
                "*", "\n", "     ", "*", " ", "Reopen", " ", "the", " ", 
                "file", " ", "and", " ", "dataset", " ", "and", " ", "write", 
                " ", "a", " ", "subset", " ", "of", " ", "data", " ", "to", 
                "\n", "     ", "*", " ", "the", " ", 
                RowBox[{"dataset", ".", "\n", "     ", 
                 RowBox[{
                 "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
                   "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
                "*", 
                RowBox[{"/", "\n", "\n", "    ", "file_id"}]}], " ", "=", " ", 
               RowBox[{"H5Fopen", " ", 
                RowBox[{"(", 
                 RowBox[{"FILE", ",", " ", 
                  RowBox[{"H5F_ACC", "_RDWR"}], ",", " ", "H5P_DEFAULT"}], 
                 ")"}]}]}], ";", "\n", "    ", 
              RowBox[{"dataset_id", " ", "=", " ", 
               RowBox[{"H5Dopen", " ", 
                RowBox[{"(", 
                 RowBox[{
                 "file_id", ",", " ", "DATASETNAME", ",", " ", 
                  "H5P_DEFAULT"}], ")"}]}]}], ";"}], "\n", "\n", "    ", "/", 
             RowBox[{
             "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
               "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
               "**", "**", "**", "**", "**", "**", "**", "**"}]}], "*", "\n", 
            "     ", "*", " ", "Specify", " ", "size", " ", "and", " ", 
            "shape", " ", "of", " ", "subset", " ", "to", " ", 
            RowBox[{"write", ".", "\n", "     ", 
             RowBox[{
             "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
               "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
               "**", "**", "**", "**", "**", "**", "**", "**"}]}], "*", 
            RowBox[{"/", "\n", "\n", "    ", 
             RowBox[{"offset", "[", "0", "]"}]}]}], " ", "=", " ", "1"}], ";",
           "\n", "    ", 
          RowBox[{
           RowBox[{"offset", "[", "1", "]"}], " ", "=", " ", "2"}], ";", "\n",
           "\n", "    ", 
          RowBox[{
           RowBox[{"count", "[", "0", "]"}], "  ", "=", " ", "DIM0_SUB"}], 
          ";", "  ", "\n", "    ", 
          RowBox[{
           RowBox[{"count", "[", "1", "]"}], "  ", "=", " ", "DIM1_SUB"}], 
          ";", "\n", "\n", "    ", 
          RowBox[{
           RowBox[{"stride", "[", "0", "]"}], " ", "=", " ", "1"}], ";", "\n",
           "    ", 
          RowBox[{
           RowBox[{"stride", "[", "1", "]"}], " ", "=", " ", "1"}], ";"}], 
         "\n", "\n", "    ", "/", 
         RowBox[{
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
           "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
           "**", "**", "**", "**", "**", "**"}]}], "*", "\n", "     ", "*", 
        " ", "Create", " ", "memory", " ", "space", " ", "with", " ", "size", 
        " ", "of", " ", 
        RowBox[{"subset", ".", " ", "Get"}], " ", "file", " ", "dataspace", 
        " ", "\n", "     ", "*", " ", "and", " ", "select", " ", "subset", 
        " ", "from", " ", "file", " ", 
        RowBox[{"dataspace", ".", "             ", "\n", "     ", 
         RowBox[{
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
           "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
           "**", "**", "**", "**", "**", "**"}]}], "*", 
        RowBox[{"/", "\n", "\n", "    ", 
         RowBox[{"dimsm", "[", "0", "]"}]}]}], " ", "=", " ", "DIM0_SUB"}], 
      ";", "\n", "    ", 
      RowBox[{
       RowBox[{"dimsm", "[", "1", "]"}], " ", "=", " ", "DIM1_SUB"}], ";", 
      "\n", "    ", 
      RowBox[{"memspace_id", " ", "=", " ", 
       RowBox[{"H5Screate_simple", " ", 
        RowBox[{"(", 
         RowBox[{"RANK", ",", " ", "dimsm", ",", " ", "NULL"}], ")"}]}]}], 
      ";", " ", "\n", "\n", "    ", 
      RowBox[{"dataspace_id", " ", "=", " ", 
       RowBox[{"H5Dget_space", " ", 
        RowBox[{"(", "dataset_id", ")"}]}]}], ";", "\n", "    ", 
      RowBox[{"status", " ", "=", " ", 
       RowBox[{"H5Sselect_hyperslab", " ", 
        RowBox[{"(", 
         RowBox[{"dataspace_id", ",", " ", 
          RowBox[{"H5S_SELECT", "_SET"}], ",", " ", "offset", ",", "\n", 
          "                                  ", "stride", ",", " ", "count", 
          ",", " ", "NULL"}], ")"}]}]}], ";"}], "\n", "\n", "    ", "/", 
     RowBox[{
     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
       "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
       "**", "**", "**", "**", "**"}]}], "*", "\n", "     ", "*", " ", 
    "Write", " ", "a", " ", "subset", " ", "of", " ", "data", " ", "to", " ", 
    "the", " ", "dataset"}], ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
     "then", " ", "read", " ", "the", " ", "\n", "     ", "*", " ", "entire", 
      " ", "dataset", " ", "back", " ", "from", " ", "the", " ", 
      RowBox[{"file", ".", " ", "Close"}], " ", 
      RowBox[{"everything", ".", " ", "\n", "     ", 
       RowBox[{
       "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**"}]}], "*", 
      RowBox[{"/", "\n", "\n", "    ", "for"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
        RowBox[{"j", " ", "<", " ", "DIM0_SUB"}], ";", " ", 
        RowBox[{"j", "++"}]}], ")"}], " ", 
      RowBox[{"{", "\n", "\t", 
       RowBox[{
        RowBox[{
         RowBox[{"for", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
            RowBox[{"i", " ", "<", " ", "DIM1_SUB"}], ";", " ", 
            RowBox[{"i", "++"}]}], ")"}], "\n", "\t   ", 
          RowBox[{
           RowBox[{"sdata", "[", "j", "]"}], "[", "i", "]"}]}], " ", "=", " ",
          "5"}], ";"}], "\n", "    ", "}"}], "     ", "\n", "\n", "    ", 
      "status"}], " ", "=", " ", 
     RowBox[{"H5Dwrite", " ", 
      RowBox[{"(", 
       RowBox[{"dataset_id", ",", " ", 
        RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "memspace_id", ",", "\n", 
        "                       ", "dataspace_id", ",", " ", "H5P_DEFAULT", 
        ",", " ", "sdata"}], ")"}]}]}], ";", "\n", "    ", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Dread", " ", 
      RowBox[{"(", 
       RowBox[{"dataset_id", ",", " ", 
        RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", " ", 
        "H5S_ALL", ",", "\n", "                       ", "H5P_DEFAULT", ",", 
        " ", "rdata"}], ")"}]}]}], ";", "\n", "\n", "    ", 
    RowBox[{"printf", " ", 
     RowBox[{"(", "\"\<\\nData after Selection is Written:\\n\>\"", ")"}]}], 
    ";", "\n", "    ", 
    RowBox[{
     RowBox[{"for", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
        RowBox[{"i", "<", "DIM0"}], ";", " ", 
        RowBox[{"i", "++"}]}], ")"}], 
      RowBox[{"{", "\n", "       ", 
       RowBox[{
        RowBox[{"for", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
           RowBox[{"j", "<", "DIM1"}], ";", " ", 
           RowBox[{"j", "++"}]}], ")"}], "\n", "           ", "printf", " ", 
         RowBox[{"(", 
          RowBox[{"\"\< %i\>\"", ",", " ", 
           RowBox[{
            RowBox[{"rdata", "[", "i", "]"}], "[", "j", "]"}]}], ")"}]}], ";",
         "\n", "       ", 
        RowBox[{"printf", " ", 
         RowBox[{"(", "\"\<\\n\>\"", ")"}]}], ";"}], "\n", "    ", "}"}], 
      "\n", "\n", "\n", "    ", "status"}], " ", "=", " ", 
     RowBox[{"H5Sclose", " ", 
      RowBox[{"(", "dataspace_id", ")"}]}]}], ";", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Sclose", " ", 
      RowBox[{"(", "memspace_id", ")"}]}]}], ";", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Dclose", " ", 
      RowBox[{"(", "dataset_id", ")"}]}]}], ";", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Fclose", " ", 
      RowBox[{"(", "file_id", ")"}]}]}], ";"}]}], "\n", " ", "\n", 
  "}"}]}], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{
  3.519293195844782*^9, {3.519293535018181*^9, 3.5192935371253014`*^9}, 
   3.5192947363358927`*^9, {3.5192976111403217`*^9, 3.519297613493457*^9}, 
   3.519299687043625*^9, 3.519299907039208*^9, 3.519300234101915*^9, {
   3.5193123235503917`*^9, 3.5193123294377284`*^9}, {3.5193125852913623`*^9, 
   3.5193125885265474`*^9}},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, {
  3.519313390833437*^9, 3.5193133931945715`*^9}}],

Cell[CellGroupData[{

Cell["set up", "Subsection",
 CellChangeTimes->{{3.5193133876242533`*^9, 3.5193133879962745`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519298385033586*^9, 3.5192985987368093`*^9, {
   3.519298677505315*^9, 3.5192987039768286`*^9}, {3.519299021085534*^9, 
   3.5192990583276644`*^9}, 3.519299150636944*^9, 3.519299358026806*^9, 
   3.5192998028952513`*^9, {3.519299974267053*^9, 3.519299990806999*^9}, 
   3.5193000243959208`*^9, 3.519300554724253*^9, 3.51931242387813*^9, 
   3.5193126862231355`*^9, 3.5193133236955967`*^9, 3.5193140381574616`*^9, 
   3.5193144346321387`*^9, 3.5193147950697546`*^9, 3.5193178949880595`*^9, 
   3.5193185021017847`*^9, 3.5198585769990463`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dims", "=", 
  RowBox[{"{", 
   RowBox[{"8", ",", "10"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.519312726710451*^9, 3.519312738795142*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"8", ",", "10"}], "}"}]], "Output",
 CellChangeTimes->{3.5193127390351562`*^9, 3.5193133244716415`*^9, 
  3.519314038907504*^9, 3.5193144354001827`*^9, 3.519314795841799*^9, 
  3.5193178955260906`*^9, 3.519318502861828*^9, 3.5198585770240474`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dimsSubset", "=", 
  RowBox[{"{", 
   RowBox[{"3", ",", "4"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.519313671637498*^9, 3.5193136775578365`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.5193136782948785`*^9, 3.519314038935506*^9, 
  3.519314435423184*^9, 3.5193147958617997`*^9, 3.519317895548092*^9, 
  3.5193185028868294`*^9, 3.5198585770400486`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"offset", ",", "count", ",", "stride"}], "}"}], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", "dimsSubset", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.519313773058299*^9, 3.51931378951224*^9}, 
   3.5193138368439474`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.519313849219655*^9, 3.5193140389585075`*^9, 
  3.519314435443185*^9, 3.5193147958818007`*^9, 3.5193178955690928`*^9, 
  3.5193185029128313`*^9, 3.5198585770570493`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"data", "=", "\[IndentingNewLine]", 
  RowBox[{"ConstantArray", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConstantArray", "[", 
      RowBox[{"1", ",", 
       RowBox[{
        RowBox[{
        "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "/", 
        "2"}]}], "]"}], "~", "Join", "~", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"2", ",", 
       RowBox[{
        RowBox[{
        "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "/", 
        "2"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"dims", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.5193131363808827`*^9, 3.519313212070212*^9}, {
  3.519317875164926*^9, 3.519317893016947*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.519313191822054*^9, 3.5193132165734696`*^9}, 
   3.519313324491642*^9, 3.519314038980509*^9, 3.5193144354671865`*^9, 
   3.519314795901802*^9, 3.519317895596094*^9, 3.5193185029398327`*^9, 
   3.5198585770740504`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"subsetData", "=", 
  RowBox[{"ConstantArray", "[", 
   RowBox[{"5", ",", "dimsSubset"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519314899647736*^9, 3.5193149189518404`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"5", ",", "5", ",", "5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5", ",", "5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5", ",", "5", ",", "5"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.519314919349863*^9, 3.519317895617096*^9, 
  3.5193185029658337`*^9, 3.519858577091051*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<hype.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}, {
   3.519293546201821*^9, 3.519293546673848*^9}, {3.519299700630402*^9, 
   3.5192997010814276`*^9}, 3.5192999274513755`*^9, 3.5193123460486784`*^9}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\hype.h5\"\>"], \
"Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192935900623293`*^9, 
   3.5192940722649097`*^9, 3.519294143445981*^9, 3.5192942649679317`*^9, 
   3.51929519942638*^9, 3.5192956052085896`*^9, 3.5192958766121125`*^9, {
   3.5192961627434783`*^9, 3.519296189952035*^9}, 3.5192964982366676`*^9, 
   3.5192967151690755`*^9, 3.5192968294806137`*^9, {3.5192969870256248`*^9, 
   3.5192969988793025`*^9}, 3.519297067500228*^9, {3.5192971250555196`*^9, 
   3.519297178339567*^9}, 3.5192972211590166`*^9, 3.5192973163494606`*^9, 
   3.5192983855706167`*^9, 3.519298599190835*^9, {3.5192986775503173`*^9, 
   3.5192987040238314`*^9}, {3.5192990211415377`*^9, 3.5192990590117035`*^9}, 
   3.5192991507349496`*^9, 3.5192993581158113`*^9, 3.519299803606292*^9, {
   3.5192999743440576`*^9, 3.519299990840001*^9}, 3.519300024877948*^9, 
   3.5193005569333797`*^9, 3.519312693613558*^9, 3.5193133245116434`*^9, 
   3.5193140390085106`*^9, 3.519314435496188*^9, 3.519314795919803*^9, 
   3.5193178956390967`*^9, 3.5193185029888353`*^9, 3.519858577107052*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Write Full Data Set", "Subsection",
 CellChangeTimes->{{3.5193133687171717`*^9, 3.519313369157197*^9}, {
  3.5193134962204647`*^9, 3.5193135002076926`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fcreate", "[", 
   RowBox[{
   "file", ",", "H5FuACCuTRUNC", ",", "H5PuDEFAULT", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}, {
  3.51929517844018*^9, 3.51929519331003*^9}, {3.5192997040635986`*^9, 
  3.519299719896504*^9}, {3.519300517294112*^9, 3.5193005410704727`*^9}, {
  3.519312660799681*^9, 3.519312668507122*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, 
   3.519295201047473*^9, 3.5192956052665925`*^9, 3.519295876670116*^9, {
   3.51929616276748*^9, 3.519296189973036*^9}, 3.5192964997407537`*^9, 
   3.519296715224078*^9, 3.5192968295336165`*^9, {3.5192969870766277`*^9, 
   3.519296998899304*^9}, 3.5192970675232286`*^9, {3.519297125100522*^9, 
   3.5192971783905697`*^9}, 3.519297221207019*^9, 3.519297316401464*^9, 
   3.51929838561862*^9, 3.5192985992418385`*^9, {3.5192986775683184`*^9, 
   3.5192987040438323`*^9}, {3.5192990211625385`*^9, 3.519299059067707*^9}, 
   3.519299150750951*^9, 3.519299358131812*^9, 3.519299803656295*^9, {
   3.5192999743630586`*^9, 3.5192999908630023`*^9}, 3.51930002492395*^9, {
   3.5193005418225155`*^9, 3.519300561731654*^9}, 3.519312695624673*^9, 
   3.519313324574647*^9, 3.5193140459549074`*^9, 3.5193147986429586`*^9, 
   3.5193178956881*^9, 3.5193185030528393`*^9, 3.519858577124053*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSpaceID", "=", 
  RowBox[{"H5ScreateUsimple", "[", 
   RowBox[{
    RowBox[{"Length", "@", "dims"}], ",", "dims", ",", "Null"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5193005785726175`*^9, 3.519300600259858*^9}, {
  3.5193127733351183`*^9, 3.519312779124449*^9}}],

Cell[BoxData["67108866"], "Output",
 CellChangeTimes->{{3.5193005916013627`*^9, 3.5193006006358795`*^9}, 
   3.5193127795344725`*^9, 3.5193133246096487`*^9, 3.519314046030912*^9, 
   3.519314798710963*^9, 3.519317895712101*^9, 3.5193185030788403`*^9, 
   3.5198585771390543`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dcreate", "[", 
   RowBox[{"fileID", ",", "\"\<IntArray\>\"", ",", 
    RowBox[{
     RowBox[{"H5T`copy", "[", "H5TuSTDuI32BE", "]"}], "@", 
     RowBox[{"Id", "[", "]"}]}], ",", "dataSpaceID", ",", "H5PuDEFAULT", ",", 
    "H5PuDEFAULT", ",", "H5PuDEFAULT"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193006122835455`*^9, 3.519300683856639*^9}, {
  3.519300716119485*^9, 3.519300717364556*^9}, {3.519312812845378*^9, 
  3.519312813883437*^9}}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{3.5193007180135927`*^9, 3.5193128361167088`*^9, 
  3.5193133247716584`*^9, 3.5193140461819205`*^9, 3.5193147988619714`*^9, 
  3.5193178958611097`*^9, 3.5193185032288494`*^9, 3.519858577156055*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dwrite", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
   "H5PuDEFAULT", ",", 
   RowBox[{"Flatten", "@", "data"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519300737805725*^9, 3.5193007944409647`*^9}, {
   3.519300831396078*^9, 3.519300835263299*^9}, 3.519313253801599*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.519300795289013*^9, 3.5193008357863293`*^9, 
  3.519313254467637*^9, 3.5193133247916594`*^9, 3.519314046205922*^9, 
  3.5193147988819723`*^9, 3.5193178958821106`*^9, 3.51931850325185*^9, 
  3.519858577172056*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Fclose", "[", "fileID", "]"}]}], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
  3.519294255857411*^9, 3.519294258239547*^9}, {3.5192976786471834`*^9, 
  3.5192976970572357`*^9}, {3.5192978590565023`*^9, 3.519297865346862*^9}, {
  3.519298947165306*^9, 3.5192989534256644`*^9}, {3.5192997733345604`*^9, 
  3.5192997910195723`*^9}, {3.519299915975719*^9, 3.5192999227341056`*^9}, {
  3.5193002501308317`*^9, 3.519300284100775*^9}, {3.5193126037264166`*^9, 
  3.519312620163357*^9}, {3.5193133554504128`*^9, 3.519313355624423*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.519313356528475*^9, 3.5193140462299232`*^9, 
  3.519314798906974*^9, 3.519317895906112*^9, 3.519318503272852*^9, 
  3.519858577190057*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.519313356528475*^9, 3.5193140462299232`*^9, 
  3.519314798906974*^9, 3.519317895906112*^9, 3.519318503272852*^9, 
  3.5198585771920567`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.519313356528475*^9, 3.5193140462299232`*^9, 
  3.519314798906974*^9, 3.519317895906112*^9, 3.519318503272852*^9, 
  3.519858577193057*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Write to Subregion of Data Set", "Subsection",
 CellChangeTimes->{{3.5193133687171717`*^9, 3.519313369157197*^9}, {
  3.5193134717290635`*^9, 3.51931347201908*^9}, {3.51931350330287*^9, 
  3.5193135066710625`*^9}, {3.5193156225320826`*^9, 3.5193156228901033`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fopen", "[", 
   RowBox[{"file", ",", "H5FuACCuRDWR", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}, {
  3.51929517844018*^9, 3.51929519331003*^9}, {3.5192997040635986`*^9, 
  3.519299719896504*^9}, {3.519300517294112*^9, 3.5193005410704727`*^9}, {
  3.519312660799681*^9, 3.519312668507122*^9}, {3.5193135368277874`*^9, 
  3.519313543042143*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, 
   3.519295201047473*^9, 3.5192956052665925`*^9, 3.519295876670116*^9, {
   3.51929616276748*^9, 3.519296189973036*^9}, 3.5192964997407537`*^9, 
   3.519296715224078*^9, 3.5192968295336165`*^9, {3.5192969870766277`*^9, 
   3.519296998899304*^9}, 3.5192970675232286`*^9, {3.519297125100522*^9, 
   3.5192971783905697`*^9}, 3.519297221207019*^9, 3.519297316401464*^9, 
   3.51929838561862*^9, 3.5192985992418385`*^9, {3.5192986775683184`*^9, 
   3.5192987040438323`*^9}, {3.5192990211625385`*^9, 3.519299059067707*^9}, 
   3.519299150750951*^9, 3.519299358131812*^9, 3.519299803656295*^9, {
   3.5192999743630586`*^9, 3.5192999908630023`*^9}, 3.51930002492395*^9, {
   3.5193005418225155`*^9, 3.519300561731654*^9}, 3.519312695624673*^9, 
   3.519313324574647*^9, 3.5193135742379265`*^9, 3.51931423954198*^9, 
   3.519314438468358*^9, 3.519314803962263*^9, 3.519315173841419*^9, 
   3.5193178959341135`*^9, 3.5193185033068533`*^9, 3.519858577210058*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dopen", "[", 
   RowBox[{"fileID", ",", "\"\<IntArray\>\"", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5193006122835455`*^9, 3.519300683856639*^9}, {
  3.519300716119485*^9, 3.519300717364556*^9}, {3.519312812845378*^9, 
  3.519312813883437*^9}, {3.519313546559344*^9, 3.5193135707657285`*^9}}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{
  3.5193007180135927`*^9, 3.5193128361167088`*^9, 3.5193133247716584`*^9, {
   3.519313571471769*^9, 3.519313575897022*^9}, 3.519314241781108*^9, 
   3.519314440145454*^9, 3.519314805379344*^9, 3.5193151754245095`*^9, 
   3.519317895952115*^9, 3.519318503331855*^9, 3.519858577226059*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"memorySpaceID", "=", 
  RowBox[{"H5ScreateUsimple", "[", 
   RowBox[{
    RowBox[{"Length", "@", "dimsSubset"}], ",", "dimsSubset", ",", "Null"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5193005785726175`*^9, 3.519300600259858*^9}, {
  3.5193127733351183`*^9, 3.519312779124449*^9}, {3.5193136245178027`*^9, 
  3.5193136256878695`*^9}, {3.5193136862823353`*^9, 3.519313689747534*^9}}],

Cell[BoxData["67108866"], "Output",
 CellChangeTimes->{3.5193136903285666`*^9, 3.519314243530208*^9, 
  3.5193144420705643`*^9, 3.519314806965435*^9, 3.5193151770276012`*^9, 
  3.519317895971116*^9, 3.5193185033558564`*^9, 3.5198585772420597`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSpaceID", "=", 
  RowBox[{"H5DgetSpace", "[", "dataSetID", "]"}]}]], "Input",
 CellChangeTimes->{{3.519313695474861*^9, 3.5193137112527637`*^9}}],

Cell[BoxData["67108867"], "Output",
 CellChangeTimes->{3.51931371206081*^9, 3.519314245676331*^9, 
  3.519314446136797*^9, 3.5193148085715265`*^9, 3.519315178683696*^9, 
  3.519317895995117*^9, 3.5193185033788576`*^9, 3.5198585772580605`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5SselectHyperSlab", " ", "[", 
  RowBox[{
  "dataSpaceID", ",", " ", "H5SuSET", ",", " ", "offset", ",", "stride", ",", 
   " ", "count", ",", " ", "Null"}], "]"}]], "Input",
 CellChangeTimes->{{3.5193137358491707`*^9, 3.51931375297515*^9}, {
   3.5193138697698307`*^9, 3.519313878940355*^9}, 3.5193141483217626`*^9, 
   3.5193142503826003`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.5193144032993464`*^9, {3.5193144494229846`*^9, 3.5193144541942577`*^9}, {
   3.5193145970624294`*^9, 3.5193146130763454`*^9}, 3.519314810327627*^9, 
   3.519315180250786*^9, 3.519317896014118*^9, 3.5193185034028587`*^9, 
   3.5198585772740617`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dwrite", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "memorySpaceID", ",", "dataSpaceID", ",",
    "H5PuDEFAULT", ",", 
   RowBox[{"Flatten", "@", "subsetData"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519300737805725*^9, 3.5193007944409647`*^9}, {
   3.519300831396078*^9, 3.519300835263299*^9}, 3.519313253801599*^9, {
   3.519314957731058*^9, 3.519314967813635*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.519314968310663*^9, 3.519315183856992*^9, 
  3.5193178960691214`*^9, 3.5193185034288607`*^9, 3.519858577291063*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"readDataObject", "=", 
  RowBox[{"MakeNETObject", "[", 
   RowBox[{"Flatten", "@", "data"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193152834486885`*^9, 3.5193152948493404`*^9}, {
  3.5193153717127366`*^9, 3.519315373644847*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\[LeftGuillemet]", 
   RowBox[{"NETObject", "[", 
    RowBox[{"System", ".", 
     RowBox[{"Int32", "[", "]"}]}], "]"}], "\[RightGuillemet]"}],
  NETLink`Objects`NETObject$832787380699137]], "Output",
 CellChangeTimes->{3.5193152958493977`*^9, 3.519315374321886*^9, 
  3.5193178960931225`*^9, 3.519318503455862*^9, 3.5198585773080635`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dread", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
   "H5PuDEFAULT", ",", "readDataObject"}], "]"}]], "Input",
 CellChangeTimes->{{3.519300737805725*^9, 3.5193007944409647`*^9}, {
   3.519300831396078*^9, 3.519300835263299*^9}, 3.519313253801599*^9, {
   3.519314957731058*^9, 3.519314967813635*^9}, {3.519315315339512*^9, 
   3.5193153602920837`*^9}, 3.519315393400977*^9, 3.5193184880739822`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.5193153611491327`*^9, 3.5193153949870677`*^9}, 
   3.519317896113124*^9, 3.5193185034808636`*^9, 3.5198585773240643`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NETObjectToExpression", "@", "readDataObject"}]], "Input",
 CellChangeTimes->{{3.5193153978962345`*^9, 3.5193154101379347`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2", 
   ",", "2", ",", "2", ",", "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", 
   "5", ",", "2", ",", "2", ",", "2", ",", "2", ",", "1", ",", "1", ",", "5", 
   ",", "5", ",", "5", ",", "5", ",", "2", ",", "2", ",", "2", ",", "2", ",", 
   "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "2", ",", "2", 
   ",", "2", ",", "2", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2", 
   ",", "2", ",", "2", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "2", ",", "2", ",", "2", ",", "2", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.519315410703967*^9, 3.519315552962104*^9, 
  3.519315594304468*^9, 3.5193178961501265`*^9, 3.5193185035188656`*^9, 
  3.5198585773410654`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{"%", ",", 
   RowBox[{"Rest", "@", "dims"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5193154141901665`*^9, 3.5193154291220202`*^9}, {
  3.519315521732317*^9, 3.519315546154714*^9}, {3.5193155927353783`*^9, 
  3.5193155932434072`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.51931542981606*^9, 3.5193155546441994`*^9, 
  3.5193155959655633`*^9, 3.519317896170127*^9, 3.5193185035418673`*^9, 
  3.5198585773580666`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Close items", "Subsection",
 CellChangeTimes->{{3.519319015365142*^9, 3.519319017716276*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Sclose", "[", "memorySpaceID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Fclose", "[", "fileID", "]"}]}], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
  3.519294255857411*^9, 3.519294258239547*^9}, {3.5192976786471834`*^9, 
  3.5192976970572357`*^9}, {3.5192978590565023`*^9, 3.519297865346862*^9}, {
  3.519298947165306*^9, 3.5192989534256644`*^9}, {3.5192997733345604`*^9, 
  3.5192997910195723`*^9}, {3.519299915975719*^9, 3.5192999227341056`*^9}, {
  3.5193002501308317`*^9, 3.519300284100775*^9}, {3.5193126037264166`*^9, 
  3.519312620163357*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5193132640571856`*^9, 
  3.5193138923591223`*^9, 3.519314975917098*^9, 3.519315599665775*^9, 
  3.519317896197129*^9, 3.5193185035668683`*^9, 3.5198585773760676`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5193132640571856`*^9, 
  3.5193138923591223`*^9, 3.519314975917098*^9, 3.519315599665775*^9, 
  3.519317896197129*^9, 3.5193185035668683`*^9, 3.5198585773780675`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5193132640571856`*^9, 
  3.5193138923591223`*^9, 3.519314975917098*^9, 3.519315599665775*^9, 
  3.519317896197129*^9, 3.5193185035668683`*^9, 3.5198585773790674`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5193132640571856`*^9, 
  3.5193138923591223`*^9, 3.519314975917098*^9, 3.519315599665775*^9, 
  3.519317896197129*^9, 3.5193185035668683`*^9, 3.519858577380068*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1089, 983},
WindowMargins->{{Automatic, 18}, {Automatic, 25}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 342, 4, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[946, 30, 98, 1, 105, "Section"],
Cell[1047, 33, 874, 15, 41, "Text"],
Cell[1924, 50, 663, 12, 41, "Text"],
Cell[2590, 64, 607, 13, 90, "Text"],
Cell[3200, 79, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3514, 91, 187, 4, 105, "Section"],
Cell[3704, 97, 20491, 432, 3929, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[24232, 534, 169, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[24426, 540, 98, 1, 54, "Subsection"],
Cell[CellGroupData[{
Cell[24549, 545, 171, 3, 43, "Input"],
Cell[24723, 550, 1400, 19, 42, "Output"]
}, Open  ]],
Cell[26138, 572, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[26301, 578, 166, 4, 43, "Input"],
Cell[26470, 584, 286, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26793, 594, 173, 4, 43, "Input"],
Cell[26969, 600, 261, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27267, 610, 381, 11, 43, "Input"],
Cell[27651, 623, 420, 11, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28108, 639, 823, 20, 152, "Input"],
Cell[28934, 661, 1493, 38, 118, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30464, 704, 199, 4, 43, "Input"],
Cell[30666, 710, 403, 10, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31106, 725, 412, 9, 43, "Input"],
Cell[31521, 736, 1152, 16, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[32722, 758, 162, 2, 54, "Subsection"],
Cell[CellGroupData[{
Cell[32909, 764, 440, 9, 43, "Input"],
Cell[33352, 775, 1058, 14, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34447, 794, 298, 7, 43, "Input"],
Cell[34748, 803, 279, 4, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35064, 812, 500, 10, 71, "Input"],
Cell[35567, 824, 251, 3, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35855, 832, 467, 10, 71, "Input"],
Cell[36325, 844, 262, 4, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36624, 853, 729, 10, 98, "Input"],
Cell[37356, 865, 188, 3, 42, "Output"],
Cell[37547, 870, 190, 3, 42, "Output"],
Cell[37740, 875, 188, 3, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37977, 884, 270, 3, 54, "Subsection"],
Cell[CellGroupData[{
Cell[38272, 891, 464, 9, 43, "Input"],
Cell[38739, 902, 1129, 15, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39905, 922, 373, 7, 43, "Input"],
Cell[40281, 931, 344, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40662, 941, 413, 8, 43, "Input"],
Cell[41078, 951, 247, 3, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41362, 959, 173, 3, 43, "Input"],
Cell[41538, 964, 242, 3, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41817, 972, 370, 7, 43, "Input"],
Cell[42190, 981, 301, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42528, 991, 533, 11, 71, "Input"],
Cell[43064, 1004, 165, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43266, 1011, 256, 5, 43, "Input"],
Cell[43525, 1018, 384, 8, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43946, 1031, 594, 11, 71, "Input"],
Cell[44543, 1044, 172, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44752, 1051, 152, 2, 43, "Input"],
Cell[44907, 1055, 1060, 16, 93, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46004, 1076, 287, 6, 43, "Input"],
Cell[46294, 1084, 1418, 37, 118, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[47761, 1127, 99, 1, 54, "Subsection"],
Cell[CellGroupData[{
Cell[47885, 1132, 755, 11, 125, "Input"],
Cell[48643, 1145, 240, 3, 42, "Output"],
Cell[48886, 1150, 240, 3, 42, "Output"],
Cell[49129, 1155, 240, 3, 42, "Output"],
Cell[49372, 1160, 238, 3, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
