(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     35844,        968]
NotebookOptionsPosition[     32562,        848]
NotebookOutlinePosition[     33028,        866]
CellTagsIndexPosition[     32985,        863]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\[OpenCurlyDoubleQuote]h5_hypeb\[CloseCurlyDoubleQuote]", "Subtitle",
 CellChangeTimes->{{3.5192928170291147`*^9, 3.5192928285487733`*^9}, 
   3.5192935097227345`*^9, 3.5192943555601134`*^9, 3.519297569739954*^9, 
   3.5192996482954082`*^9, 3.5192998637117295`*^9, 3.519300195040681*^9, 
   3.5193122677061977`*^9}],

Cell[CellGroupData[{

Cell["Information", "Section",
 CellChangeTimes->{{3.5192929670456953`*^9, 3.519292967780737*^9}}],

Cell[TextData[{
 "The example shown in this file appears at: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/selectsimple.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/selectsimple.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/selectsimple.html"],
 " (accessed 10 July 2011)"
}], "Text",
 CellChangeTimes->{{3.519292751319356*^9, 3.5192928011712074`*^9}, {
  3.5192928385653467`*^9, 3.5192928533341913`*^9}, {3.519293488863541*^9, 
  3.5192934978050528`*^9}, {3.5192943687078657`*^9, 3.5192943692978992`*^9}, {
  3.519294399419622*^9, 3.519294399420622*^9}, {3.519297581437623*^9, 
  3.519297589704096*^9}, {3.5192996582149763`*^9, 3.519299666932474*^9}, {
  3.519299875591409*^9, 3.5192998884281435`*^9}, {3.51930020377318*^9, 
  3.5193002097265205`*^9}, {3.5193122779837856`*^9, 3.5193122993560076`*^9}}],

Cell[TextData[{
 "The example shown in this file is following the tutorial: ",
 ButtonBox["http://www.hdfgroup.org/HDF5/Tutor/introductory.html",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/Tutor/introductory.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/Tutor/introductory.html"]
}], "Text",
 CellChangeTimes->{{3.519204574069906*^9, 3.5192046043556385`*^9}, {
  3.5192048157717304`*^9, 3.519204834786818*^9}, {3.5192057745415688`*^9, 
  3.5192057875533133`*^9}, {3.519220971218769*^9, 3.5192209824754133`*^9}, {
  3.519292702541566*^9, 3.5192927154303036`*^9}, {3.5192928674960012`*^9, 
  3.519292879400682*^9}}],

Cell[TextData[{
 "Good references for the shown HDF5 functions include:\n",
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html\n",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/RM_H5Front.html"],
 ButtonBox["http://www.hdfgroup.org/HDF5/doc/RM/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.hdfgroup.org/HDF5/doc/RM/"], None},
  ButtonNote->"http://www.hdfgroup.org/HDF5/doc/RM/"]
}], "Text",
 CellChangeTimes->{{3.519292884540976*^9, 3.519292921736103*^9}}],

Cell[TextData[{
 "Prepared 10 July 2011 by Scot Martin for Windows 7, 64-bit, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version 8.0.1."
}], "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, {
  3.519292549013785*^9, 3.519292559290373*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
\[OpenCurlyDoubleQuote]c\[CloseCurlyDoubleQuote] code we seek to replicate in \
this example\
\>", "Section",
 CellChangeTimes->{{3.519293164569993*^9, 3.5192931737455177`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"/", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**"}]}], "*", "\n", " ", "*", "  ", "\n", " ", "*", 
  " ", "This", " ", "example", " ", "shows", " ", "how", " ", "to", " ", 
  "write", " ", "a", " ", "subset", " ", "of", " ", "data", " ", 
  RowBox[{"(", 
   RowBox[{"a", " ", "slab"}], ")"}], " ", "to"}], "\n", 
 RowBox[{" ", 
  RowBox[{
  "*", " ", "a", " ", "dataset", " ", "in", " ", "an", " ", "HDF5", " ", 
   RowBox[{"file", "."}]}]}], "\n", 
 RowBox[{" ", 
  RowBox[{"*", "\n", " ", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**", "**"}], "*", 
   RowBox[{"/", "\n", " ", "\n", "#"}], "include", " ", "\"\<hdf5.h\>\""}], 
  "\n"}], "\n", 
 RowBox[{"#", "define", " ", "FILE", "        ", "\"\<hype.h5\>\""}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "DATASETNAME", " ", "\"\<IntArray\>\""}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "RANK", "  ", "2"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"#", "define", " ", "DIM0", "     ", 
   RowBox[{"8", "                 ", "/"}], "*", " ", "size", " ", "of", " ", 
   "dataset", " ", "*", 
   RowBox[{"/", "       ", "\n", "#"}], "define", " ", "DIM1", "     ", 
   "10"}], " ", "\n"}], "\n", "int", "\n", 
 RowBox[{"main", " ", 
  RowBox[{"(", "void", ")"}]}], "\n", 
 RowBox[{"{", "\n", "    ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"int", "         ", 
       RowBox[{
        RowBox[{"rdata", "[", "DIM0", "]"}], "[", "DIM1", "]"}]}], ";"}], 
     "          ", "/"}], "*", " ", "buffer", " ", "for", " ", "read", " ", 
    "*", 
    RowBox[{"/", "\n", " ", "\n", "    ", "hid_t"}], "       ", "file_id"}], 
   ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"dataset_id", ";"}], "        ", "/"}], "*", " ", 
           "handles", " ", "*", 
           RowBox[{"/", "\n", "    ", "hid_t"}], "       ", "dataspace_id"}], 
          ";", " ", "\n", "\n", "    ", 
          RowBox[{"herr_t", "      ", "status"}], ";", 
          "                             ", "\n", "   ", "\n", "    ", 
          RowBox[{"hsize_t", "     ", 
           RowBox[{"count", "[", "2", "]"}]}], ";"}], "              ", "/"}],
         "*", " ", "size", " ", "of", " ", "subset", " ", "in", " ", "the", 
        " ", "file", " ", "*", 
        RowBox[{"/", "\n", "    ", "hsize_t"}], "     ", 
        RowBox[{"offset", "[", "2", "]"}]}], ";"}], "             ", "/"}], 
     "*", " ", "subset", " ", "offset", " ", "in", " ", "the", " ", "file", 
     " ", "*", 
     RowBox[{"/", "\n", "    ", "hsize_t"}], "     ", 
     RowBox[{"stride", "[", "2", "]"}]}], ";", "\n", "    ", 
    RowBox[{"hsize_t", "     ", 
     RowBox[{"block", "[", "2", "]"}]}], ";", "\n", "    ", 
    RowBox[{"int", "         ", "i"}]}], ",", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"j", ";"}], "\n", "\n", "\n", "    ", "/", 
           RowBox[{
           "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
             "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
             "**", "**", "**", "**", "**", "**", "**"}]}], "*", "\n", "     ",
           "*", " ", "Open", " ", "the", " ", "file", " ", "and", " ", 
          "dataset", " ", "and", " ", "read", " ", "a", " ", 
          RowBox[{
          "selection", "\n", "     ", "**", "**", "**", "**", "**", "**", "**",
            "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
           "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
           "**"}], "*", 
          RowBox[{"/", "\n", "\n", "    ", "file_id"}]}], " ", "=", " ", 
         RowBox[{"H5Fopen", " ", 
          RowBox[{"(", 
           RowBox[{"FILE", ",", " ", 
            RowBox[{"H5F_ACC", "_RDWR"}], ",", " ", "H5P_DEFAULT"}], 
           ")"}]}]}], ";", "\n", "    ", 
        RowBox[{"dataset_id", " ", "=", " ", 
         RowBox[{"H5Dopen", " ", 
          RowBox[{"(", 
           RowBox[{
           "file_id", ",", " ", "DATASETNAME", ",", " ", "H5P_DEFAULT"}], 
           ")"}]}]}], ";"}], "\n", "\n", "\n", "    ", "/", 
       RowBox[{
       "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**"}]}], "*", "\n", "     ", "*", " ",
       "Read", " ", "data", " ", "using", " ", "block", " ", "and", " ", 
      "stride", " ", "in", " ", 
      RowBox[{
      "selection", "  ", "\n", "     ", "**", "**", "**", "**", "**", "**", "**",
        "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
        "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
      "*", 
      RowBox[{"/", "\n", "    ", "status"}]}], " ", "=", " ", 
     RowBox[{"H5Dread", " ", 
      RowBox[{"(", 
       RowBox[{"dataset_id", ",", " ", 
        RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", " ", 
        "H5S_ALL", ",", "\n", "                       ", "H5P_DEFAULT", ",", 
        " ", "rdata"}], ")"}]}]}], ";", "\n", "\n", "    ", 
    RowBox[{"printf", " ", 
     RowBox[{"(", "\"\<\\nData In File :\\n\>\"", ")"}]}], ";", "\n", "    ", 
    RowBox[{
     RowBox[{"for", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
        RowBox[{"i", "<", "DIM0"}], ";", " ", 
        RowBox[{"i", "++"}]}], ")"}], 
      RowBox[{"{", " ", "\n", "       ", 
       RowBox[{
        RowBox[{"for", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
           RowBox[{"j", "<", "DIM1"}], ";", " ", 
           RowBox[{"j", "++"}]}], ")"}], " ", "\n", "           ", "printf", 
         " ", 
         RowBox[{"(", 
          RowBox[{"\"\< %i\>\"", ",", " ", 
           RowBox[{
            RowBox[{"rdata", "[", "i", "]"}], "[", "j", "]"}]}], ")"}]}], ";",
         "\n", "       ", 
        RowBox[{"printf", " ", 
         RowBox[{"(", "\"\<\\n\>\"", ")"}]}], ";"}], "\n", "    ", "}"}], " ",
       "\n", "\n", "    ", 
      RowBox[{"offset", "[", "0", "]"}]}], " ", "=", " ", "1"}], ";", "\n", 
    "    ", 
    RowBox[{
     RowBox[{"offset", "[", "1", "]"}], " ", "=", " ", "1"}], ";", " ", "\n", 
    "\n", "    ", 
    RowBox[{
     RowBox[{"count", "[", "0", "]"}], "  ", "=", " ", "2"}], ";", "  ", "\n",
     "    ", 
    RowBox[{
     RowBox[{"count", "[", "1", "]"}], "  ", "=", " ", "2"}], ";", "\n", "\n",
     "    ", 
    RowBox[{
     RowBox[{"stride", "[", "0", "]"}], " ", "=", " ", "4"}], ";", "\n", 
    "    ", 
    RowBox[{
     RowBox[{"stride", "[", "1", "]"}], " ", "=", " ", "4"}], ";", "\n", "\n",
     "    ", 
    RowBox[{
     RowBox[{"block", " ", "[", "0", "]"}], " ", "=", " ", "2"}], ";", "\n", 
    "    ", 
    RowBox[{
     RowBox[{"block", " ", "[", "1", "]"}], " ", "=", " ", "2"}], ";", "\n", 
    "\n", "\n", "    ", 
    RowBox[{
     RowBox[{"for", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
        RowBox[{"i", "<", "DIM0"}], ";", " ", 
        RowBox[{"i", "++"}]}], ")"}], "\n", "       ", "for", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
        RowBox[{"j", "<", "DIM1"}], ";", " ", 
        RowBox[{"j", "++"}]}], ")"}], " ", "\n", "           ", 
      RowBox[{
       RowBox[{"rdata", "[", "i", "]"}], "[", "j", "]"}]}], "=", " ", "0"}], 
    ";", "\n", "\n", "    ", 
    RowBox[{"dataspace_id", " ", "=", " ", 
     RowBox[{"H5Dget_space", " ", 
      RowBox[{"(", "dataset_id", ")"}]}]}], ";", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Sselect_hyperslab", " ", 
      RowBox[{"(", 
       RowBox[{"dataspace_id", ",", " ", 
        RowBox[{"H5S_SELECT", "_SET"}], ",", " ", "offset", ",", "\n", 
        "                                  ", "stride", ",", " ", "count", 
        ",", " ", "block"}], ")"}]}]}], ";", " ", "\n", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Dread", " ", 
      RowBox[{"(", 
       RowBox[{"dataset_id", ",", " ", 
        RowBox[{"H5T_NATIVE", "_INT"}], ",", " ", "H5S_ALL", ",", " ", 
        "dataspace_id", ",", "  ", "\n", "                      ", 
        "H5P_DEFAULT", ",", " ", "rdata"}], ")"}]}]}], ";", " ", "\n", "  ", 
    "\n", "    ", 
    RowBox[{"printf", " ", 
     RowBox[{"(", "\"\<\\nSelected Data Read From File:\\n\>\"", ")"}]}], ";",
     "\n", "    ", 
    RowBox[{
     RowBox[{"for", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"i", " ", "=", " ", "0"}], ";", " ", 
        RowBox[{"i", "<", "DIM0"}], ";", " ", 
        RowBox[{"i", "++"}]}], ")"}], 
      RowBox[{"{", " ", "\n", "       ", 
       RowBox[{
        RowBox[{"for", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"j", " ", "=", " ", "0"}], ";", " ", 
           RowBox[{"j", "<", "DIM1"}], ";", " ", 
           RowBox[{"j", "++"}]}], ")"}], " ", "\n", "           ", "printf", 
         " ", 
         RowBox[{"(", 
          RowBox[{"\"\< %i\>\"", ",", " ", 
           RowBox[{
            RowBox[{"rdata", "[", "i", "]"}], "[", "j", "]"}]}], ")"}]}], ";",
         "\n", "       ", 
        RowBox[{"printf", " ", 
         RowBox[{"(", "\"\<\\n\>\"", ")"}]}], ";"}], "\n", "    ", "}"}], 
      "\n", "    ", "\n", "\n", "    ", "status"}], " ", "=", " ", 
     RowBox[{"H5Sclose", " ", 
      RowBox[{"(", "dataspace_id", ")"}]}]}], ";", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Dclose", " ", 
      RowBox[{"(", "dataset_id", ")"}]}]}], ";", "\n", "    ", 
    RowBox[{"status", " ", "=", " ", 
     RowBox[{"H5Fclose", " ", 
      RowBox[{"(", "file_id", ")"}]}]}], ";"}]}], "\n", " ", "\n", 
  "}"}]}], "Code",
 Evaluatable->False,
 InitializationCell->False,
 CellChangeTimes->{
  3.519293195844782*^9, {3.519293535018181*^9, 3.5192935371253014`*^9}, 
   3.5192947363358927`*^9, {3.5192976111403217`*^9, 3.519297613493457*^9}, 
   3.519299687043625*^9, 3.519299907039208*^9, 3.519300234101915*^9, {
   3.5193123235503917`*^9, 3.5193123294377284`*^9}},
 ShowAutoStyles->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation in Mathematica", "Section",
 CellChangeTimes->{{3.5192929340948105`*^9, 3.5192929346948442`*^9}, 
   3.519313458994335*^9}],

Cell[CellGroupData[{

Cell["set up", "Subsection",
 CellChangeTimes->{{3.5193133876242533`*^9, 3.5193133879962745`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.51929197161576*^9, 3.5192919762470245`*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519292033619306*^9, 3.519292077834835*^9, 3.519293278044483*^9, 
   3.5192933410290856`*^9, 3.51929358762619*^9, 3.5192939899972043`*^9, 
   3.5192940208019667`*^9, {3.519294066372573*^9, 3.5192940892308807`*^9}, 
   3.519294140378806*^9, 3.5192942642948933`*^9, 3.5192951968002295`*^9, 
   3.5192956044795475`*^9, 3.519295875904072*^9, {3.519296162665474*^9, 
   3.519296189902032*^9}, 3.519296361928871*^9, {3.519296435988107*^9, 
   3.5192964655077953`*^9}, {3.519296563337391*^9, 3.519296579440312*^9}, 
   3.5192966475512075`*^9, 3.519296714693048*^9, 3.519296828787574*^9, {
   3.519296986314584*^9, 3.5192969988212996`*^9}, 3.5192970670842037`*^9, {
   3.519297124506488*^9, 3.5192971778215375`*^9}, 3.5192972206729884`*^9, 
   3.519297315862433*^9, 3.519298385033586*^9, 3.5192985987368093`*^9, {
   3.519298677505315*^9, 3.5192987039768286`*^9}, {3.519299021085534*^9, 
   3.5192990583276644`*^9}, 3.519299150636944*^9, 3.519299358026806*^9, 
   3.5192998028952513`*^9, {3.519299974267053*^9, 3.519299990806999*^9}, 
   3.5193000243959208`*^9, 3.519300554724253*^9, 3.51931242387813*^9, 
   3.519318378619722*^9, 3.5193185238120265`*^9, 3.5193191188530607`*^9, 
   3.519858584499475*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519291983838459*^9, 3.5192919892877703`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dims", "=", 
  RowBox[{"{", 
   RowBox[{"8", ",", "10"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.519312726710451*^9, 3.519312738795142*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"8", ",", "10"}], "}"}]], "Output",
 CellChangeTimes->{3.519318379388766*^9, 3.519318524591071*^9, 
  3.519319119613104*^9, 3.519858584524476*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"offset", ",", "count", ",", "stride", ",", "block"}], "}"}], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.519313773058299*^9, 3.51931378951224*^9}, 
   3.5193138368439474`*^9, {3.5193187092436323`*^9, 3.519318723233433*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.51931873245296*^9, 3.5193191196381054`*^9, 
  3.5198585845404773`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", "\"\<hype.h5\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5192932542341213`*^9, 3.5192932705320535`*^9}, {
   3.519293546201821*^9, 3.519293546673848*^9}, {3.519299700630402*^9, 
   3.5192997010814276`*^9}, 3.5192999274513755`*^9, 3.5193123460486784`*^9}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\hype.h5\"\>"], \
"Output",
 CellChangeTimes->{
  3.519293282504738*^9, 3.519293341686123*^9, 3.5192935900623293`*^9, 
   3.5192940722649097`*^9, 3.519294143445981*^9, 3.5192942649679317`*^9, 
   3.51929519942638*^9, 3.5192956052085896`*^9, 3.5192958766121125`*^9, {
   3.5192961627434783`*^9, 3.519296189952035*^9}, 3.5192964982366676`*^9, 
   3.5192967151690755`*^9, 3.5192968294806137`*^9, {3.5192969870256248`*^9, 
   3.5192969988793025`*^9}, 3.519297067500228*^9, {3.5192971250555196`*^9, 
   3.519297178339567*^9}, 3.5192972211590166`*^9, 3.5192973163494606`*^9, 
   3.5192983855706167`*^9, 3.519298599190835*^9, {3.5192986775503173`*^9, 
   3.5192987040238314`*^9}, {3.5192990211415377`*^9, 3.5192990590117035`*^9}, 
   3.5192991507349496`*^9, 3.5192993581158113`*^9, 3.519299803606292*^9, {
   3.5192999743440576`*^9, 3.519299990840001*^9}, 3.519300024877948*^9, 
   3.5193005569333797`*^9, 3.5193183794127674`*^9, 3.5193185246190724`*^9, 
   3.519319119667107*^9, 3.5198585845574784`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["file and dataSet setup", "Subsection",
 CellChangeTimes->{{3.5193133687171717`*^9, 3.519313369157197*^9}, {
  3.5193134962204647`*^9, 3.5193135002076926`*^9}, {3.5193183075706577`*^9, 
  3.519318307832673*^9}, {3.519318768668031*^9, 3.5193187696710887`*^9}, {
  3.5193188693757915`*^9, 3.5193188750951185`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fileID", "=", 
  RowBox[{"H5Fopen", "[", 
   RowBox[{"file", ",", "H5FuACCuRDWR", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519293284368845*^9, 3.5192933127534685`*^9}, {
  3.51929517844018*^9, 3.51929519331003*^9}, {3.5192997040635986`*^9, 
  3.519299719896504*^9}, {3.519300517294112*^9, 3.5193005410704727`*^9}}],

Cell[BoxData["16777216"], "Output",
 CellChangeTimes->{{3.519293315496625*^9, 3.5192933417421265`*^9}, 
   3.5192935917324247`*^9, 3.5192941453610907`*^9, 3.519294265022935*^9, 
   3.519295201047473*^9, 3.5192956052665925`*^9, 3.519295876670116*^9, {
   3.51929616276748*^9, 3.519296189973036*^9}, 3.5192964997407537`*^9, 
   3.519296715224078*^9, 3.5192968295336165`*^9, {3.5192969870766277`*^9, 
   3.519296998899304*^9}, 3.5192970675232286`*^9, {3.519297125100522*^9, 
   3.5192971783905697`*^9}, 3.519297221207019*^9, 3.519297316401464*^9, 
   3.51929838561862*^9, 3.5192985992418385`*^9, {3.5192986775683184`*^9, 
   3.5192987040438323`*^9}, {3.5192990211625385`*^9, 3.519299059067707*^9}, 
   3.519299150750951*^9, 3.519299358131812*^9, 3.519299803656295*^9, {
   3.5192999743630586`*^9, 3.5192999908630023`*^9}, 3.51930002492395*^9, {
   3.5193005418225155`*^9, 3.519300561731654*^9}, 3.5193183857811317`*^9, 
   3.5193185254941225`*^9, 3.5193191197331114`*^9, 3.519858584573479*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSetID", "=", 
  RowBox[{"H5Dopen", "[", 
   RowBox[{"fileID", ",", "\"\<IntArray\>\"", ",", "H5PuDEFAULT"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5193006122835455`*^9, 3.519300683856639*^9}, {
  3.519300716119485*^9, 3.519300717364556*^9}, {3.5193183974607997`*^9, 
  3.519318411033576*^9}}],

Cell[BoxData["83886080"], "Output",
 CellChangeTimes->{3.5193007180135927`*^9, 3.519318411785619*^9, 
  3.5193185269752073`*^9, 3.5193191197581124`*^9, 3.51985858458948*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["read all data", "Subsection",
 CellChangeTimes->{{3.5193133687171717`*^9, 3.519313369157197*^9}, {
  3.5193134962204647`*^9, 3.5193135002076926`*^9}, {3.5193183075706577`*^9, 
  3.519318307832673*^9}, {3.519318768668031*^9, 3.5193187696710887`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"readDataObject", "=", 
  RowBox[{"NETNew", "[", 
   RowBox[{"\"\<System.Int32[]\>\"", ",", 
    RowBox[{"Times", "@@", "dims"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193152834486885`*^9, 3.5193152948493404`*^9}, {
  3.5193153717127366`*^9, 3.519315373644847*^9}, {3.519318596207167*^9, 
  3.5193186100199575`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\[LeftGuillemet]", 
   RowBox[{"NETObject", "[", 
    RowBox[{"System", ".", 
     RowBox[{"Int32", "[", "]"}]}], "]"}], "\[RightGuillemet]"}],
  NETLink`Objects`NETObject$516345397510145]], "Output",
 CellChangeTimes->{3.5193152958493977`*^9, 3.519315374321886*^9, 
  3.5193178960931225`*^9, 3.5193186120520735`*^9, 3.5193191197891145`*^9, 
  3.519858584607481*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dread", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "H5SuALL", ",", 
   "H5PuDEFAULT", ",", "readDataObject"}], "]"}]], "Input",
 CellChangeTimes->{{3.519300737805725*^9, 3.5193007944409647`*^9}, {
   3.519300831396078*^9, 3.519300835263299*^9}, 3.519313253801599*^9, {
   3.519314957731058*^9, 3.519314967813635*^9}, {3.519315315339512*^9, 
   3.5193153602920837`*^9}, 3.519315393400977*^9, 3.519318514446491*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.5193153611491327`*^9, 3.5193153949870677`*^9}, 
   3.519317896113124*^9, 3.519318645764002*^9, 3.5193191199341226`*^9, 
   3.5198585846234818`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{
   RowBox[{"NETObjectToExpression", "@", "readDataObject"}], ",", 
   RowBox[{"Rest", "@", "dims"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5193153978962345`*^9, 3.5193154101379347`*^9}, {
  3.5193190843630877`*^9, 3.5193190946906786`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2",
      ",", "2", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.519319119974125*^9, 3.519858584640483*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.519319111447637*^9, 3.5193191131997375`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "1", "1", "1", "1", "2", "2", "2", "2", "2"},
    {"1", "1", "5", "5", "5", "5", "2", "2", "2", "2"},
    {"1", "1", "5", "5", "5", "5", "2", "2", "2", "2"},
    {"1", "1", "5", "5", "5", "5", "2", "2", "2", "2"},
    {"1", "1", "1", "1", "1", "2", "2", "2", "2", "2"},
    {"1", "1", "1", "1", "1", "2", "2", "2", "2", "2"},
    {"1", "1", "1", "1", "1", "2", "2", "2", "2", "2"},
    {"1", "1", "1", "1", "1", "2", "2", "2", "2", "2"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5193191200001264`*^9, 3.519858584659484*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["read some data", "Subsection",
 CellChangeTimes->{{3.5193133687171717`*^9, 3.519313369157197*^9}, {
  3.5193134962204647`*^9, 3.5193135002076926`*^9}, {3.5193183075706577`*^9, 
  3.519318307832673*^9}, {3.519318768668031*^9, 3.5193187767354927`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataSpaceID", "=", 
  RowBox[{"H5DgetSpace", "[", "dataSetID", "]"}]}]], "Input",
 CellChangeTimes->{{3.5193005785726175`*^9, 3.519300600259858*^9}, {
  3.5193188128895607`*^9, 3.5193188218710747`*^9}}],

Cell[BoxData["67108866"], "Output",
 CellChangeTimes->{3.519318822477109*^9, 3.519319120019128*^9, 
  3.5198585846774855`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H5SselectHyperSlab", " ", "[", 
  RowBox[{
  "dataSpaceID", ",", " ", "H5SuSET", ",", " ", "offset", ",", "stride", ",", 
   " ", "count", ",", " ", "block"}], "]"}]], "Input",
 CellChangeTimes->{{3.5193189099861145`*^9, 3.519318910327134*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193189126142645`*^9, 3.5193191200421286`*^9, 
  3.519858584693486*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"readDataObject", "=", 
  RowBox[{"NETNew", "[", 
   RowBox[{"\"\<System.Int32[]\>\"", ",", 
    RowBox[{"Times", "@@", "dims"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\[LeftGuillemet]", 
   RowBox[{"NETObject", "[", 
    RowBox[{"System", ".", 
     RowBox[{"Int32", "[", "]"}]}], "]"}], "\[RightGuillemet]"}],
  NETLink`Objects`NETObject$340668903849985]], "Output",
 CellChangeTimes->{3.5193187836568885`*^9, 3.51931912006513*^9, 
  3.5198585847104874`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"H5Dread", "[", "Integer32", "]"}], "[", 
  RowBox[{"dataSetID", ",", 
   RowBox[{
    RowBox[{"H5T`copy", "[", "H5TuNATIVEuINT", "]"}], "@", 
    RowBox[{"Id", "[", "]"}]}], ",", "H5SuALL", ",", "dataSpaceID", ",", 
   "H5PuDEFAULT", ",", "readDataObject"}], "]"}]], "Input",
 CellChangeTimes->{{3.5193189463061914`*^9, 3.519318956542777*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.519318949217358*^9, 3.5193189697555327`*^9}, 
   3.519319120086131*^9, 3.5198585847254877`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{
   RowBox[{"NETObjectToExpression", "@", "readDataObject"}], ",", 
   RowBox[{"Rest", "@", "dims"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5193153978962345`*^9, 3.5193154101379347`*^9}, {
  3.5193190843630877`*^9, 3.5193190946906786`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "5", ",", "0", ",", "0", ",", "5", ",", "2", ",", "0",
      ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "5", ",", "0", ",", "0", ",", "5", ",", "2", ",", "0",
      ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "2", ",", "2", ",", "0",
      ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "2", ",", "2", ",", "0",
      ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5193191017720838`*^9, 3.5193191201041327`*^9}, 
   3.519858584742489*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.5193191064143496`*^9, 3.519319108155449*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
    {"0", "1", "5", "0", "0", "5", "2", "0", "0", "0"},
    {"0", "1", "5", "0", "0", "5", "2", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
    {"0", "1", "1", "0", "0", "2", "2", "0", "0", "0"},
    {"0", "1", "1", "0", "0", "2", "2", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.519319108387462*^9, 3.5193191201301336`*^9}, 
   3.51985858475949*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Close items", "Subsection",
 CellChangeTimes->{{3.519319015365142*^9, 3.519319017716276*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"H5Sclose", "[", "dataSpaceID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Dclose", "[", "dataSetID", "]"}], "\[IndentingNewLine]", 
 RowBox[{"H5Fclose", "[", "fileID", "]"}]}], "Input",
 CellChangeTimes->{{3.51929331872581*^9, 3.5192933323945913`*^9}, {
  3.519294255857411*^9, 3.519294258239547*^9}, {3.5192976786471834`*^9, 
  3.5192976970572357`*^9}, {3.5192978590565023`*^9, 3.519297865346862*^9}, {
  3.519298947165306*^9, 3.5192989534256644`*^9}, {3.5192997733345604`*^9, 
  3.5192997910195723`*^9}, {3.519299915975719*^9, 3.5192999227341056`*^9}, {
  3.5193002501308317`*^9, 3.519300284100775*^9}, {3.51931899959324*^9, 
  3.5193190000322647`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5193191201491346`*^9, 
  3.5198585847774906`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5193191201491346`*^9, 
  3.519858584778491*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5193009990916696`*^9, 3.5193191201491346`*^9, 
  3.519858584779491*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1089, 983},
WindowMargins->{{81, Automatic}, {10, Automatic}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 321, 4, 74, "Subtitle"],
Cell[CellGroupData[{
Cell[925, 30, 98, 1, 105, "Section"],
Cell[1026, 33, 874, 15, 41, "Text"],
Cell[1903, 50, 663, 12, 41, "Text"],
Cell[2569, 64, 607, 13, 90, "Text"],
Cell[3179, 79, 277, 7, 41, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3493, 91, 187, 4, 105, "Section"],
Cell[3683, 97, 10631, 252, 2498, "Code",
 Evaluatable->False,
 InitializationCell->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[14351, 354, 144, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[14520, 360, 98, 1, 54, "Subsection"],
Cell[CellGroupData[{
Cell[14643, 365, 171, 3, 43, "Input"],
Cell[14817, 370, 1296, 18, 42, "Output"]
}, Open  ]],
Cell[16128, 391, 138, 2, 43, "Input"],
Cell[CellGroupData[{
Cell[16291, 397, 166, 4, 43, "Input"],
Cell[16460, 403, 185, 4, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16682, 412, 546, 15, 43, "Input"],
Cell[17231, 429, 381, 12, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17649, 446, 412, 9, 43, "Input"],
Cell[18064, 457, 1058, 15, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19171, 478, 317, 4, 54, "Subsection"],
Cell[CellGroupData[{
Cell[19513, 486, 364, 7, 43, "Input"],
Cell[19880, 495, 990, 13, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20907, 513, 327, 7, 43, "Input"],
Cell[21237, 522, 173, 2, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21459, 530, 255, 3, 54, "Subsection"],
Cell[CellGroupData[{
Cell[21739, 537, 345, 7, 43, "Input"],
Cell[22087, 546, 411, 9, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22535, 560, 592, 11, 71, "Input"],
Cell[23130, 573, 198, 3, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23365, 581, 295, 6, 43, "Input"],
Cell[23663, 589, 1317, 35, 118, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25017, 629, 126, 2, 43, "Input"],
Cell[25146, 633, 1016, 23, 204, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26211, 662, 256, 3, 54, "Subsection"],
Cell[CellGroupData[{
Cell[26492, 669, 226, 4, 43, "Input"],
Cell[26721, 675, 126, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26884, 682, 268, 5, 43, "Input"],
Cell[27155, 689, 121, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27313, 696, 173, 4, 43, "Input"],
Cell[27489, 702, 337, 8, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27863, 715, 378, 8, 71, "Input"],
Cell[28244, 725, 146, 2, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28427, 732, 295, 6, 43, "Input"],
Cell[28725, 740, 1349, 36, 118, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30111, 781, 126, 2, 43, "Input"],
Cell[30240, 785, 1043, 24, 204, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31332, 815, 99, 1, 54, "Subsection"],
Cell[CellGroupData[{
Cell[31456, 820, 680, 10, 98, "Input"],
Cell[32139, 832, 123, 2, 42, "Output"],
Cell[32265, 836, 121, 2, 42, "Output"],
Cell[32389, 840, 121, 2, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
