(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     50921,       1404]
NotebookOptionsPosition[     42190,       1156]
NotebookOutlinePosition[     46275,       1266]
CellTagsIndexPosition[     46105,       1259]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
Prepared 15 July 2011 by Scot Martin\
\>", "Text",
 CellChangeTimes->{{3.5192900627995815`*^9, 3.519290073040167*^9}, 
   3.519754544943753*^9}],

Cell["\<\
This notebook is provided for informational purposes. That is, the user never \
need run it unless new constants needed to be added.\
\>", "Text",
 CellChangeTimes->{{3.519290225388881*^9, 3.5192902488452225`*^9}}],

Cell["\<\
This file should be run with a fresh kernel, i.e., Quit[...] before running \
this file.\
\>", "Text",
 CellChangeTimes->{{3.5193260900867925`*^9, 3.5193261053656664`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5193261670881968`*^9, 3.519326177017765*^9}}],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\"\>"], "Output",
 CellChangeTimes->{
  3.519326177328782*^9, 3.519326366373595*^9, 3.519326863197012*^9, 
   3.5193376509630365`*^9, 3.5196638847461967`*^9, 3.5197542271445756`*^9, {
   3.519754444874029*^9, 3.519754461864001*^9}, 3.519754533096075*^9, 
   3.5197554173686523`*^9, 3.51985848930403*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$pathToDefinitions", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], ",", 
     "\"\<DefinitionsForConstants.txt\>\""}], "}"}], "]"}]}]], "Input"],

Cell[BoxData["\<\"C:\\\\HDF5\\\\HDF5WrappersForMathematica\\\\\
DefinitionsForConstants.txt\"\>"], "Output",
 CellChangeTimes->{
  3.519326125552821*^9, 3.519326189733492*^9, 3.5193263663935966`*^9, 
   3.519326863211013*^9, 3.519337650986038*^9, 3.5196638847911987`*^9, 
   3.5197542271915784`*^9, {3.5197544448940306`*^9, 3.5197544618790016`*^9}, 
   3.519754533125077*^9, 3.519755417410655*^9, 3.5198584893470325`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Get", "[", "$pathToDefinitions", "]"}]], "Input"],

Cell[BoxData["9"], "Output",
 CellChangeTimes->{{3.519326163555995*^9, 3.5193261912325773`*^9}, 
   3.519326366415598*^9, 3.519326863236014*^9, 3.519337651006039*^9, 
   3.5196638848092003`*^9, 3.5197542272115793`*^9, {3.5197544449220324`*^9, 
   3.5197544619240046`*^9}, 3.519754533147078*^9, 3.5197554174256563`*^9, 
   3.5198584893630333`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Enumerations", "Section",
 CellChangeTimes->{{3.5197544217337055`*^9, 3.519754422985777*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"enumerations", "=", 
   RowBox[{"Names", "[", "\"\<H5*\>\"", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", " ", "//", "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.5193262376702337`*^9, 3.519326263779727*^9}, {
  3.5197544258859434`*^9, 3.519754456749708*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"H5DuCHUNKED\"\>"},
    {"\<\"H5DuCOMPACT\"\>"},
    {"\<\"H5DuCONTIGUOUS\"\>"},
    {"\<\"H5DuNLAYOUTS\"\>"},
    {"\<\"H5FuACCuCREAT\"\>"},
    {"\<\"H5FuACCuDEBUG\"\>"},
    {"\<\"H5FuACCuEXCL\"\>"},
    {"\<\"H5FuACCuRDONLY\"\>"},
    {"\<\"H5FuACCuRDWR\"\>"},
    {"\<\"H5FuACCuTRUNC\"\>"},
    {"\<\"H5GuCOMPACT\"\>"},
    {"\<\"H5GuDATASET\"\>"},
    {"\<\"H5GuDENSE\"\>"},
    {"\<\"H5GuGROUP\"\>"},
    {"\<\"H5GuLINK\"\>"},
    {"\<\"H5GuSYMBOLuTABLE\"\>"},
    {"\<\"H5GuTYPE\"\>"},
    {"\<\"H5IuATTR\"\>"},
    {"\<\"H5IuBADID\"\>"},
    {"\<\"H5IuDATASET\"\>"},
    {"\<\"H5IuDATASPACE\"\>"},
    {"\<\"H5IuDATATYPE\"\>"},
    {"\<\"H5IuERRORuCLASS\"\>"},
    {"\<\"H5IuERRORuMSG\"\>"},
    {"\<\"H5IuERRORuSTACK\"\>"},
    {"\<\"H5IuFILE\"\>"},
    {"\<\"H5IuGENPROPuCLS\"\>"},
    {"\<\"H5IuGENPROPuLST\"\>"},
    {"\<\"H5IuGROUP\"\>"},
    {"\<\"H5IuNTYPES\"\>"},
    {"\<\"H5IuREFERENCE\"\>"},
    {"\<\"H5IuUNINIT\"\>"},
    {"\<\"H5IuVFL\"\>"},
    {"\<\"H5PuATTRIBUTEuCREATE\"\>"},
    {"\<\"H5PuDATASETuACCESS\"\>"},
    {"\<\"H5PuDATASETuCREATE\"\>"},
    {"\<\"H5PuDATASETuXFER\"\>"},
    {"\<\"H5PuDATATYPEuACCESS\"\>"},
    {"\<\"H5PuDATATYPEuCREATE\"\>"},
    {"\<\"H5PuDEFAULT\"\>"},
    {"\<\"H5PuFILEuACCESS\"\>"},
    {"\<\"H5PuFILEuCREATE\"\>"},
    {"\<\"H5PuFILEuMOUNT\"\>"},
    {"\<\"H5PuGROUPuACCESS\"\>"},
    {"\<\"H5PuGROUPuCREATE\"\>"},
    {"\<\"H5PuLINKuACCESS\"\>"},
    {"\<\"H5PuLINKuCREATE\"\>"},
    {"\<\"H5PuOBJECTuCOPY\"\>"},
    {"\<\"H5PuOBJECTuCREATE\"\>"},
    {"\<\"H5PuROOT\"\>"},
    {"\<\"H5PuSTRINGuCREATE\"\>"},
    {"\<\"H5SuALL\"\>"},
    {"\<\"H5SuAND\"\>"},
    {"\<\"H5SuNOTA\"\>"},
    {"\<\"H5SuNOTB\"\>"},
    {"\<\"H5SuNOuTYPE\"\>"},
    {"\<\"H5SuOR\"\>"},
    {"\<\"H5SuSCALAR\"\>"},
    {"\<\"H5SuSET\"\>"},
    {"\<\"H5SuSIMPLE\"\>"},
    {"\<\"H5SuUNLIMITED\"\>"},
    {"\<\"H5SuXOR\"\>"},
    {"\<\"H5TuARRAY\"\>"},
    {"\<\"H5TuASCEND\"\>"},
    {"\<\"H5TuBITFIELD\"\>"},
    {"\<\"H5TuCOMPOUND\"\>"},
    {"\<\"H5TuCuS1\"\>"},
    {"\<\"H5TuDEFAULT\"\>"},
    {"\<\"H5TuDESCEND\"\>"},
    {"\<\"H5TuENUM\"\>"},
    {"\<\"H5TuFLOAT\"\>"},
    {"\<\"H5TuIEEEuF32BE\"\>"},
    {"\<\"H5TuIEEEuF32LE\"\>"},
    {"\<\"H5TuIEEEuF64BE\"\>"},
    {"\<\"H5TuIEEEuF64LE\"\>"},
    {"\<\"H5TuINTEGER\"\>"},
    {"\<\"H5TuNATIVEuB16\"\>"},
    {"\<\"H5TuNATIVEuB32\"\>"},
    {"\<\"H5TuNATIVEuB64\"\>"},
    {"\<\"H5TuNATIVEuB8\"\>"},
    {"\<\"H5TuNATIVEuDOUBLE\"\>"},
    {"\<\"H5TuNATIVEuFLOAT\"\>"},
    {"\<\"H5TuNATIVEuHADDR\"\>"},
    {"\<\"H5TuNATIVEuHBOOL\"\>"},
    {"\<\"H5TuNATIVEuHERR\"\>"},
    {"\<\"H5TuNATIVEuHSIZE\"\>"},
    {"\<\"H5TuNATIVEuHSSIZE\"\>"},
    {"\<\"H5TuNATIVEuINT\"\>"},
    {"\<\"H5TuNATIVEuLDOUBLE\"\>"},
    {"\<\"H5TuNATIVEuLLONG\"\>"},
    {"\<\"H5TuNATIVEuLONG\"\>"},
    {"\<\"H5TuNATIVEuOPAQUE\"\>"},
    {"\<\"H5TuNATIVEuSCHAR\"\>"},
    {"\<\"H5TuNATIVEuSHORT\"\>"},
    {"\<\"H5TuNATIVEuUCHAR\"\>"},
    {"\<\"H5TuNATIVEuUINT\"\>"},
    {"\<\"H5TuNATIVEuULLONG\"\>"},
    {"\<\"H5TuNATIVEuULONG\"\>"},
    {"\<\"H5TuNATIVEuUSHORT\"\>"},
    {"\<\"H5TuOPAQUE\"\>"},
    {"\<\"H5TuREFERENCE\"\>"},
    {"\<\"H5TuSTDuB16BE\"\>"},
    {"\<\"H5TuSTDuB16LE\"\>"},
    {"\<\"H5TuSTDuB32BE\"\>"},
    {"\<\"H5TuSTDuB32LE\"\>"},
    {"\<\"H5TuSTDuB64BE\"\>"},
    {"\<\"H5TuSTDuB64LE\"\>"},
    {"\<\"H5TuSTDuB8BE\"\>"},
    {"\<\"H5TuSTDuB8LE\"\>"},
    {"\<\"H5TuSTDuI16BE\"\>"},
    {"\<\"H5TuSTDuI16LE\"\>"},
    {"\<\"H5TuSTDuI32BE\"\>"},
    {"\<\"H5TuSTDuI32LE\"\>"},
    {"\<\"H5TuSTDuI64BE\"\>"},
    {"\<\"H5TuSTDuI64LE\"\>"},
    {"\<\"H5TuSTDuI8BE\"\>"},
    {"\<\"H5TuSTDuI8LE\"\>"},
    {"\<\"H5TuSTDuREFuDSETREG\"\>"},
    {"\<\"H5TuSTDuREFuOBJ\"\>"},
    {"\<\"H5TuSTDuU16BE\"\>"},
    {"\<\"H5TuSTDuU16LE\"\>"},
    {"\<\"H5TuSTDuU32BE\"\>"},
    {"\<\"H5TuSTDuU32LE\"\>"},
    {"\<\"H5TuSTDuU64BE\"\>"},
    {"\<\"H5TuSTDuU64LE\"\>"},
    {"\<\"H5TuSTDuU8BE\"\>"},
    {"\<\"H5TuSTDuU8LE\"\>"},
    {"\<\"H5TuSTRING\"\>"},
    {"\<\"H5TuTIME\"\>"},
    {"\<\"H5TuVLEN\"\>"},
    {"\<\"H5uCRTuORDER\"\>"},
    {"\<\"H5uDATASET\"\>"},
    {"\<\"H5uDECREASING\"\>"},
    {"\<\"H5uGROUP\"\>"},
    {"\<\"H5uHALTuWITHuFAILURE\"\>"},
    {"\<\"H5uINCREASING\"\>"},
    {"\<\"H5uNAME\"\>"},
    {"\<\"H5uNAMEDuDATATYPE\"\>"},
    {"\<\"H5uNATIVE\"\>"},
    {"\<\"H5uSHORTuCIRCUITuSUCCESS\"\>"},
    {"\<\"H5uSUCCESS\"\>"},
    {"\<\"H5uUNKNOWN\"\>"}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{
   "H5DuCHUNKED", "H5DuCOMPACT", "H5DuCONTIGUOUS", "H5DuNLAYOUTS", 
    "H5FuACCuCREAT", "H5FuACCuDEBUG", "H5FuACCuEXCL", "H5FuACCuRDONLY", 
    "H5FuACCuRDWR", "H5FuACCuTRUNC", "H5GuCOMPACT", "H5GuDATASET", 
    "H5GuDENSE", "H5GuGROUP", "H5GuLINK", "H5GuSYMBOLuTABLE", "H5GuTYPE", 
    "H5IuATTR", "H5IuBADID", "H5IuDATASET", "H5IuDATASPACE", "H5IuDATATYPE", 
    "H5IuERRORuCLASS", "H5IuERRORuMSG", "H5IuERRORuSTACK", "H5IuFILE", 
    "H5IuGENPROPuCLS", "H5IuGENPROPuLST", "H5IuGROUP", "H5IuNTYPES", 
    "H5IuREFERENCE", "H5IuUNINIT", "H5IuVFL", "H5PuATTRIBUTEuCREATE", 
    "H5PuDATASETuACCESS", "H5PuDATASETuCREATE", "H5PuDATASETuXFER", 
    "H5PuDATATYPEuACCESS", "H5PuDATATYPEuCREATE", "H5PuDEFAULT", 
    "H5PuFILEuACCESS", "H5PuFILEuCREATE", "H5PuFILEuMOUNT", 
    "H5PuGROUPuACCESS", "H5PuGROUPuCREATE", "H5PuLINKuACCESS", 
    "H5PuLINKuCREATE", "H5PuOBJECTuCOPY", "H5PuOBJECTuCREATE", "H5PuROOT", 
    "H5PuSTRINGuCREATE", "H5SuALL", "H5SuAND", "H5SuNOTA", "H5SuNOTB", 
    "H5SuNOuTYPE", "H5SuOR", "H5SuSCALAR", "H5SuSET", "H5SuSIMPLE", 
    "H5SuUNLIMITED", "H5SuXOR", "H5TuARRAY", "H5TuASCEND", "H5TuBITFIELD", 
    "H5TuCOMPOUND", "H5TuCuS1", "H5TuDEFAULT", "H5TuDESCEND", "H5TuENUM", 
    "H5TuFLOAT", "H5TuIEEEuF32BE", "H5TuIEEEuF32LE", "H5TuIEEEuF64BE", 
    "H5TuIEEEuF64LE", "H5TuINTEGER", "H5TuNATIVEuB16", "H5TuNATIVEuB32", 
    "H5TuNATIVEuB64", "H5TuNATIVEuB8", "H5TuNATIVEuDOUBLE", 
    "H5TuNATIVEuFLOAT", "H5TuNATIVEuHADDR", "H5TuNATIVEuHBOOL", 
    "H5TuNATIVEuHERR", "H5TuNATIVEuHSIZE", "H5TuNATIVEuHSSIZE", 
    "H5TuNATIVEuINT", "H5TuNATIVEuLDOUBLE", "H5TuNATIVEuLLONG", 
    "H5TuNATIVEuLONG", "H5TuNATIVEuOPAQUE", "H5TuNATIVEuSCHAR", 
    "H5TuNATIVEuSHORT", "H5TuNATIVEuUCHAR", "H5TuNATIVEuUINT", 
    "H5TuNATIVEuULLONG", "H5TuNATIVEuULONG", "H5TuNATIVEuUSHORT", 
    "H5TuOPAQUE", "H5TuREFERENCE", "H5TuSTDuB16BE", "H5TuSTDuB16LE", 
    "H5TuSTDuB32BE", "H5TuSTDuB32LE", "H5TuSTDuB64BE", "H5TuSTDuB64LE", 
    "H5TuSTDuB8BE", "H5TuSTDuB8LE", "H5TuSTDuI16BE", "H5TuSTDuI16LE", 
    "H5TuSTDuI32BE", "H5TuSTDuI32LE", "H5TuSTDuI64BE", "H5TuSTDuI64LE", 
    "H5TuSTDuI8BE", "H5TuSTDuI8LE", "H5TuSTDuREFuDSETREG", "H5TuSTDuREFuOBJ", 
    "H5TuSTDuU16BE", "H5TuSTDuU16LE", "H5TuSTDuU32BE", "H5TuSTDuU32LE", 
    "H5TuSTDuU64BE", "H5TuSTDuU64LE", "H5TuSTDuU8BE", "H5TuSTDuU8LE", 
    "H5TuSTRING", "H5TuTIME", "H5TuVLEN", "H5uCRTuORDER", "H5uDATASET", 
    "H5uDECREASING", "H5uGROUP", "H5uHALTuWITHuFAILURE", "H5uINCREASING", 
    "H5uNAME", "H5uNAMEDuDATATYPE", "H5uNATIVE", "H5uSHORTuCIRCUITuSUCCESS", 
    "H5uSUCCESS", "H5uUNKNOWN"}],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5193262444406214`*^9, 3.51932625124401*^9}, 
   3.5193263664505997`*^9, 3.519326863254015*^9, 3.5193376510230403`*^9, 
   3.519663884827201*^9, 3.519754227229581*^9, {3.519754433103356*^9, 
   3.5197544619380054`*^9}, 3.5197545331720796`*^9, 3.519755417441657*^9, 
   3.5198584893790345`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Remove", "[", "\"\<H5*\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519326329055461*^9, 3.5193263404621134`*^9}}],

Cell[BoxData[
 RowBox[{"Remove", "[", "\"\<$pathToDefinitions\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.5193263500226603`*^9, 3.519326358166126*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["HDF5`", "Section",
 CellChangeTimes->{{3.5197544768088555`*^9, 3.519754478216936*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<HDF5`\>\"", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"enumerationsAndFunctions", "=", 
   RowBox[{"Names", "[", "\"\<HDF5`*\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Complement", "[", 
   RowBox[{"enumerationsAndFunctions", ",", "enumerations"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Select", "[", 
   RowBox[{"%", ",", 
    RowBox[{
     RowBox[{"StringMatchQ", "[", 
      RowBox[{"#", ",", 
       RowBox[{"\"\<H5\>\"", "~~", "__"}]}], "]"}], "&"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.519754494401862*^9, 3.519754515801086*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"H5Aclose\"\>"},
    {"\<\"H5Acreate\"\>"},
    {"\<\"H5AgetName\"\>"},
    {"\<\"H5AgetNumAttrs\"\>"},
    {"\<\"H5AgetSpace\"\>"},
    {"\<\"H5AgetStorageSize\"\>"},
    {"\<\"H5AgetType\"\>"},
    {"\<\"H5Aopen\"\>"},
    {"\<\"H5AopenByIndex\"\>"},
    {"\<\"H5AopenByName\"\>"},
    {"\<\"H5Aread\"\>"},
    {"\<\"H5Awrite\"\>"},
    {"\<\"H5close\"\>"},
    {"\<\"H5Dclose\"\>"},
    {"\<\"H5Dcreate\"\>"},
    {"\<\"H5DgetCreatePList\"\>"},
    {"\<\"H5DgetOffset\"\>"},
    {"\<\"H5DgetSpace\"\>"},
    {"\<\"H5DgetStorageSize\"\>"},
    {"\<\"H5DgetType\"\>"},
    {"\<\"H5Dopen\"\>"},
    {"\<\"H5Dread\"\>"},
    {"\<\"H5DsetExtent\"\>"},
    {"\<\"H5Dwrite\"\>"},
    {"\<\"H5Fclose\"\>"},
    {"\<\"H5Fcreate\"\>"},
    {"\<\"H5Fopen\"\>"},
    {"\<\"H5Gclose\"\>"},
    {"\<\"H5Gcreate\"\>"},
    {"\<\"H5getUlibversion\"\>"},
    {"\<\"H5GgetNumObjs\"\>"},
    {"\<\"H5GgetObjNameByIndex\"\>"},
    {"\<\"H5GgetObjTypeByIndex\"\>"},
    {"\<\"H5Gopen\"\>"},
    {"\<\"H5IgetType\"\>"},
    {"\<\"H5Oclose\"\>"},
    {"\<\"H5Oopen\"\>"},
    {"\<\"H5open\"\>"},
    {"\<\"H5Pclose\"\>"},
    {"\<\"H5Pcreate\"\>"},
    {"\<\"H5PsetChunk\"\>"},
    {"\<\"H5Sclose\"\>"},
    {"\<\"H5Scopy\"\>"},
    {"\<\"H5Screate\"\>"},
    {"\<\"H5ScreateUsimple\"\>"},
    {"\<\"H5SextentCopy\"\>"},
    {"\<\"H5SgetSelectElemNPoints\"\>"},
    {"\<\"H5SgetSelectHyperNBlocks\"\>"},
    {"\<\"H5SgetSelectNPoints\"\>"},
    {"\<\"H5SgetSelectType\"\>"},
    {"\<\"H5SgetSimpleExtentDims\"\>"},
    {"\<\"H5SgetSimpleExtentNDims\"\>"},
    {"\<\"H5SgetSimpleExtentNPoints\"\>"},
    {"\<\"H5SisSimple\"\>"},
    {"\<\"H5SselectAll\"\>"},
    {"\<\"H5SselectHyperSlab\"\>"},
    {"\<\"H5SselectNone\"\>"},
    {"\<\"H5Tclose\"\>"},
    {"\<\"H5Tcopy\"\>"},
    {"\<\"H5TgetClass\"\>"},
    {"\<\"H5TgetMemberClass\"\>"},
    {"\<\"H5TgetMemberIndex\"\>"},
    {"\<\"H5TgetMemberName\"\>"},
    {"\<\"H5TgetMemberOffset\"\>"},
    {"\<\"H5TgetMemberType\"\>"},
    {"\<\"H5TgetNativeType\"\>"},
    {"\<\"H5TgetNMembers\"\>"},
    {"\<\"H5TgetSize\"\>"},
    {"\<\"H5TisVariableStr\"\>"}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{
   "H5Aclose", "H5Acreate", "H5AgetName", "H5AgetNumAttrs", "H5AgetSpace", 
    "H5AgetStorageSize", "H5AgetType", "H5Aopen", "H5AopenByIndex", 
    "H5AopenByName", "H5Aread", "H5Awrite", "H5close", "H5Dclose", 
    "H5Dcreate", "H5DgetCreatePList", "H5DgetOffset", "H5DgetSpace", 
    "H5DgetStorageSize", "H5DgetType", "H5Dopen", "H5Dread", "H5DsetExtent", 
    "H5Dwrite", "H5Fclose", "H5Fcreate", "H5Fopen", "H5Gclose", "H5Gcreate", 
    "H5getUlibversion", "H5GgetNumObjs", "H5GgetObjNameByIndex", 
    "H5GgetObjTypeByIndex", "H5Gopen", "H5IgetType", "H5Oclose", "H5Oopen", 
    "H5open", "H5Pclose", "H5Pcreate", "H5PsetChunk", "H5Sclose", "H5Scopy", 
    "H5Screate", "H5ScreateUsimple", "H5SextentCopy", 
    "H5SgetSelectElemNPoints", "H5SgetSelectHyperNBlocks", 
    "H5SgetSelectNPoints", "H5SgetSelectType", "H5SgetSimpleExtentDims", 
    "H5SgetSimpleExtentNDims", "H5SgetSimpleExtentNPoints", "H5SisSimple", 
    "H5SselectAll", "H5SselectHyperSlab", "H5SselectNone", "H5Tclose", 
    "H5Tcopy", "H5TgetClass", "H5TgetMemberClass", "H5TgetMemberIndex", 
    "H5TgetMemberName", "H5TgetMemberOffset", "H5TgetMemberType", 
    "H5TgetNativeType", "H5TgetNMembers", "H5TgetSize", "H5TisVariableStr"}],
  Editable->False]], "Output",
 CellChangeTimes->{3.5197545340021267`*^9, 3.5197554180816936`*^9, 
  3.5198584900930753`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["HDF5Extend`", "Section",
 CellChangeTimes->{{3.519754388279792*^9, 3.5197543937771063`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<HDF5Extend`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Names", "[", "\"\<HDF5Extend`*\>\"", "]"}], " ", "//", 
  "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.51975423561506*^9, 3.519754236117089*^9}, {
  3.5197545245025835`*^9, 3.5197545249196076`*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"H5AExtendGetName\"\>"},
    {"\<\"H5AExtendRead\"\>"},
    {"\<\"H5DExtendOpen\"\>"},
    {"\<\"H5DExtendRead\"\>"},
    {"\<\"H5DExtendWrite\"\>"},
    {"\<\"H5ExtendGetUlibVersion\"\>"},
    {"\<\"H5FExtendOpen\"\>"},
    {"\<\"H5GExtendGetNumObjs\"\>"},
    {"\<\"H5GExtendGetObjNameByIndex\"\>"},
    {"\<\"H5GExtendOpen\"\>"},
    {"\<\"H5SExtendGetSimpleExtentDims\"\>"},
    {"\<\"$HDF5ExtendPackageVersion\"\>"}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{
   "H5AExtendGetName", "H5AExtendRead", "H5DExtendOpen", "H5DExtendRead", 
    "H5DExtendWrite", "H5ExtendGetUlibVersion", "H5FExtendOpen", 
    "H5GExtendGetNumObjs", "H5GExtendGetObjNameByIndex", "H5GExtendOpen", 
    "H5SExtendGetSimpleExtentDims", "$HDF5ExtendPackageVersion"}],
  Editable->False]], "Output",
 CellChangeTimes->{3.5197545340491295`*^9, 3.5197554181076946`*^9, 
  3.519858490120077*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Information", "/@", 
  RowBox[{"Names", "[", "\"\<HDF5Extend`*\>\"", "]"}], " "}]], "Input",
 CellChangeTimes->{{3.5197543264572563`*^9, 3.5197543314765434`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"H5AExtendGetName[\\\"AttributeID\\\"] returns the String name \
for the indicated AttributeID.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198584902230825`*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5AExtendGetName", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5AExtendGetName],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198584902470837`*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5AExtendRead[\\\"AttributeID\\\", \\\"MemoryTypeID\\\", \
\\\"Dimensions\\\"] reads the value of an attribute. \\\"Dimensions\\\" is \
typically {1} for most common applications. This function takes the option \\\
\"DataType\\\", which is Integer32 by default. Allowed DataTypes include \
Byte, Integer32, Integer64, SingleFloat, and DoubleFloat.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198584903290887`*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5AExtendRead", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "H5AExtendRead", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"\<\"DataType\"\>", "\[Rule]", "Integer32"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5AExtendRead],
  Editable->False]], "Print",
 CellChangeTimes->{3.51985849034709*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5DExtendOpen[{\\\"dataSetIDsymbol\\\" = H5Dopen[....]}, body] \
sets the dataSetIDsymbol and then runs the body. The purpose of this function \
is that it provides an automatic H5Dclose[dataSetIDsymbol] after executing \
body. The return value is that of the body.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5198584904180937`*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5DExtendOpen", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"HoldAll", ",", "ReadProtected"}], "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5DExtendOpen],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858490435095*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5DExtendRead[\\\"DataSpaceID\\\", \\\"MemoryTypeID\\\", \
\\\"MemorySpaceID\\\", \\\"FileSpaceID\\\", \\\"xferPListID\\\", \
\\\"Dimensions\\\"] reads data from a file. The first 5 arguments are as \
defined for H5Dread. The \\\"Dimensions\\\" argument should be a list of \
dimensions of the object to be read, e.g., \\\"{10}\\\" for a rank 1 data set \
of length 10, \\\"{10,5}\\\" for a rank 2 data set of dimensions 10 by 5, and \
so forth. This function takes the option \\\"DataType\\\", which is Integer32 \
by default. Allowed DataTypes include Byte, Integer32, Integer64, \
SingleFloat, and DoubleFloat. (Other allowed values can be easily added by \
additional programming of H5Dread in \\\"HDF5`\\\" and of H5DExtendRead in \\\
\"HDF5Extend`\\\".)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858490505099*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5DExtendRead", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "H5DExtendRead", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"\<\"DataType\"\>", "\[Rule]", "Integer32"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5DExtendRead],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198584905220995`*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5DExtendRead[\\\"DataSpaceID\\\", \\\"MemoryTypeID\\\", \
\\\"MemorySpaceID\\\", \\\"FileSpaceID\\\", \\\"xferPListID\\\", \
\\\"Data\\\"] writes data to a file. The first 5 arguments are as defined for \
H5Dwrite. The \\\"Data\\\" argument should be a list or a list of lists, \
depending on dimensions of data. This function takes the option \
\\\"DataType\\\", which is Integer32 by default. Other allowed values are \
Byte, SingleFloat, and DoubleFloat. (Other allowed values can be easily added \
by additional programming of H5Dwrite in \\\"HDF5`\\\" and of H5DExtendWrite \
in \\\"HDF5Extend`\\\".)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858490594104*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5DExtendWrite", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "H5DExtendWrite", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"\<\"DataType\"\>", "\[Rule]", "Integer32"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5DExtendWrite],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858490611105*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5ExtendGetUlibVersion[] returns the version of the H5 library \
as a list of {major, minor, revision}.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858490680109*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5ExtendGetUlibVersion", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5ExtendGetUlibVersion],
  Editable->False]], "Print",
 CellChangeTimes->{3.51985849069611*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5FExtendOpen[{\\\"fileIDsymbol\\\" = H5Fopen[....]}, body] \
sets the fileIDsymbol and then runs the body. The purpose of this function is \
that it provides an automatic H5Fclose[fileIDsymbol] after executing body. \
The return value is that of the body.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198584907661138`*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5FExtendOpen", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"HoldAll", ",", "ReadProtected"}], "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5FExtendOpen],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858490782115*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5GExtendGetNumObjs[\\\"GroupOrFileID\\\"] returns the number \
of objects at one node of the GroupOrFileID.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.519858490856119*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5GExtendGetNumObjs", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5GExtendGetNumObjs],
  Editable->False]], "Print",
 CellChangeTimes->{3.51985849087212*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5GExtendGetObjNameByIndex[\\\"GroupOrFileID\\\", \
\\\"Index\\\"] returns the String name for the indicated Index of the \
GroupOrFileID.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858490943124*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5GExtendGetObjNameByIndex", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5GExtendGetObjNameByIndex],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858490960125*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5GExtendOpen[{\\\"groupIDsymbol\\\" = H5Gopen[....]}, body] \
sets the groupIDsymbol and then runs the body. The purpose of this function \
is that it provides an automatic H5Dclose[dataSetIDsymbol] after executing \
body. The return value is that of the body.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5198584910321293`*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5GExtendOpen", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"HoldAll", ",", "ReadProtected"}], "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5GExtendOpen],
  Editable->False]], "Print",
 CellChangeTimes->{3.51985849104813*^9},
 CellTags->"Info3519844090-4565354"],

Cell[BoxData[
 StyleBox["\<\"H5SExtendGetSimpleExtentDims[\\\"DataSpaceID\\\"] returns as a \
list the dimensions of the DataSpaceID.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198584911201344`*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "H5SExtendGetSimpleExtentDims", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`H5SExtendGetSimpleExtentDims],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858491136135*^9},
 CellTags->"Info3519844091-4565354"],

Cell["HDF5Extend`$HDF5ExtendPackageVersion", "Print", "PrintUsage",
 CellChangeTimes->{3.519858491240141*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{"$HDF5ExtendPackageVersion", "=", "\<\"V1.00\"\>"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5Extend`$HDF5ExtendPackageVersion],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198584912561417`*^9},
 CellTags->"Info3519844091-4565354"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", 
   ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", 
   "Null"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5197543328446217`*^9, {3.5197544468341413`*^9, 3.5197544636431026`*^9}, 
   3.519754534771171*^9, 3.5197554187677326`*^9, 3.519858491293144*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["HDF5HighLevel`", "Section",
 CellChangeTimes->{{3.519754388279792*^9, 3.5197543937771063`*^9}, {
  3.5197554284732876`*^9, 3.519755429444343*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<HDF5HighLevel`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Names", "[", "\"\<HDF5HighLevel`*\>\"", "]"}], " ", "//", 
  "ColumnForm"}]}], "Input",
 CellChangeTimes->{{3.51975423561506*^9, 3.519754236117089*^9}, {
  3.5197545245025835`*^9, 3.5197545249196076`*^9}, {3.5197554325735226`*^9, 
  3.5197554377388177`*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"DataSetDataTypeClass\"\>"},
    {"\<\"DataSetDimensions\"\>"},
    {"\<\"NamesAndTypes\"\>"},
    {"\<\"NamesAndTypesAtOneNode\"\>"},
    {"\<\"ReadAttributes\"\>"},
    {"\<\"ReadColumnRank1\"\>"},
    {"\<\"ReadColumnRank2\"\>"},
    {"\<\"ReadHyperSlab\"\>"},
    {"\<\"$HDF5HighLevelPackageVersion\"\>"}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{
   "DataSetDataTypeClass", "DataSetDimensions", "NamesAndTypes", 
    "NamesAndTypesAtOneNode", "ReadAttributes", "ReadColumnRank1", 
    "ReadColumnRank2", "ReadHyperSlab", "$HDF5HighLevelPackageVersion"}],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.5197545340491295`*^9, {3.5197554181076946`*^9, 3.5197554380518355`*^9}, 
   3.5198584914011497`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Information", "/@", 
  RowBox[{"Names", "[", "\"\<HDF5HighLevel`*\>\"", "]"}], " "}]], "Input",
 CellChangeTimes->{{3.5197543264572563`*^9, 3.5197543314765434`*^9}, {
  3.5197554423540816`*^9, 3.519755443496147*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"DataSetDataTypeClass[\\\"FileName\\\", \\\"PathToDataSet\\\"] \
returns a ClassCode. The legend for the ClassCode is as follows: {0, \
\\\"INTEGER\\\"}, {1, \\\"FLOAT\\\"}, {2, \\\"TIME\\\"}, {3, \\\"STRING\\\"}, \
{4, \\\"BITFIELD\\\"}, {5, \\\"OPAQUE\\\"}, {6, \\\"COMPOUND\\\"}, {7, \
\\\"REFERENCE\\\"}, {8, \\\"ENUM\\\"}, {9, \\\"VLEN\\\"}, {10, \
\\\"ARRAY\\\"}.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858491485155*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "DataSetDataTypeClass", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`DataSetDataTypeClass],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198584914931555`*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 StyleBox["\<\"DataSetDimensions[\\\"FileName\\\", \\\"PathToDataSet\\\"] \
returns the dimensions of the data set as a list.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5198584915681596`*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "DataSetDimensions", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`DataSetDimensions],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198584915851603`*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 StyleBox["\<\"NamesAndTypesAtOneNode[\\\"FileName\\\"] returns a list of \
{{\\\"Name\\\", Type}, ...} for all nodes in file. For Type information, see \
NamesAndTypesAtOneNode[...].\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858491660165*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "NamesAndTypes", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`NamesAndTypes],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198584916761656`*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 StyleBox["\<\"NamesAndTypesAtOneNode[\\\"GroupOrFileID\\\"] returns a list \
of {{\\\"Name\\\", Type}, ...} for all subnodes of the node indicated by the \
GroupOrFileID. Types include: {0, \\\"GROUP\\\"}, {1, \\\"DATASET\\\"}, {2, \
\\\"DATATYPE\\\"}. (The user typically will not call this function directly \
but instead will call NamesAndTypes.)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.51985849174817*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "NamesAndTypesAtOneNode", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`NamesAndTypesAtOneNode],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858491765171*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 StyleBox["\<\"ReadAttributes[\\\"FileName\\\", \\\"PathToObject\\\"] returns \
a list of information and values about the object. Use \\\".\\\" for the root \
directory for the object.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858491839175*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "ReadAttributes", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`ReadAttributes],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858491854176*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 StyleBox["\<\"ReadColumnRank1[\\\"FileName\\\", \\\"PathToDataSet\\\"] \
returns the data from the specified dataset of rank 1. This function uses \
ReadHyperSlab[...].\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198584919161797`*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "ReadColumnRank1", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`ReadColumnRank1],
  Editable->False]], "Print",
 CellChangeTimes->{3.51985849192218*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 StyleBox["\<\"ReadColumnRank2[\\\"FileName\\\", \\\"PathToDataSet\\\", \
\\\"Column\\\"] returns one column of data from the specified dataset of rank \
2. This function uses ReadHyperSlab[...].\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5198584919841833`*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "ReadColumnRank2", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`ReadColumnRank2],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858491990184*^9},
 CellTags->"Info3519844091-4565354"],

Cell[BoxData[
 StyleBox["\<\"ReadHyperSlab[\\\"FileName\\\", \\\"PathToDataSet\\\", \
\\\"OffsetList\\\", \\\"CountList\\\"] returns a hyperslab of data from the \
specified dataset.\\n\\nThe offset index runs from 1 forward, which is \
standard Mathematica syntax, rather than 0 forward as in the HDFView program. \
In case of error, the returned dataset is full of 0's.\\n\\nThis function is \
set up to work on datasets of integer32, integer64, single floating point, \
and double floating point. Extension to integer or other primitive data types \
would be easy to implement.\\n\\nThis function takes the option \
\\\"FinalIndexFull\\\", which is False by default. In the case of True, then \
OffsetList and CountList should be reduced by one in length and the function \
will provide the correct values such that the full data range is read in this \
dimension.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.519858492052187*^9},
 CellTags->"Info3519844092-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "ReadHyperSlab", "]"}], "=", 
      RowBox[{"{", "ReadProtected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "ReadHyperSlab", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"\<\"FinalIndexFull\"\>", "\[Rule]", "False"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`ReadHyperSlab],
  Editable->False]], "Print",
 CellChangeTimes->{3.519858492059188*^9},
 CellTags->"Info3519844092-4565354"],

Cell["HDF5HighLevel`$HDF5HighLevelPackageVersion", "Print", "PrintUsage",
 CellChangeTimes->{3.5198584921581936`*^9},
 CellTags->"Info3519844092-4565354"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{"$HDF5HighLevelPackageVersion", "=", "\<\"V1.00\"\>"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[HDF5HighLevel`$HDF5HighLevelPackageVersion],
  Editable->False]], "Print",
 CellChangeTimes->{3.5198584921641936`*^9},
 CellTags->"Info3519844092-4565354"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", 
   ",", "Null", ",", "Null", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5197543328446217`*^9, {3.5197544468341413`*^9, 3.5197544636431026`*^9}, 
   3.519754534771171*^9, {3.5197554187677326`*^9, 3.5197554450832376`*^9}, 
   3.5198584921961956`*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1419, 955},
WindowMargins->{{55, Automatic}, {Automatic, 13}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3519844090-4565354"->{
  Cell[17514, 488, 242, 4, 63, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[17759, 494, 501, 14, 32, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[18263, 510, 498, 8, 93, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[18764, 520, 1034, 29, 74, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[19801, 551, 415, 7, 93, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[20219, 560, 527, 15, 32, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[20749, 577, 905, 13, 180, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[21657, 592, 1037, 29, 74, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[22697, 623, 752, 11, 151, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[23452, 636, 1038, 29, 74, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[24493, 667, 249, 4, 63, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[24745, 673, 510, 14, 32, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[25258, 689, 404, 6, 93, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[25665, 697, 527, 15, 32, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[26195, 714, 256, 5, 63, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[26454, 721, 504, 14, 32, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[26961, 737, 284, 5, 63, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[27248, 744, 519, 14, 32, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[27770, 760, 411, 7, 93, "Print",
   CellTags->"Info3519844090-4565354"],
  Cell[28184, 769, 526, 15, 32, "Print",
   CellTags->"Info3519844090-4565354"]},
 "Info3519844091-4565354"->{
  Cell[28713, 786, 252, 4, 63, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[28968, 792, 523, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[29494, 808, 146, 2, 60, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[29643, 812, 802, 21, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[32688, 903, 514, 8, 93, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[33205, 913, 512, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[33720, 929, 260, 5, 63, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[33983, 936, 506, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[34492, 952, 314, 5, 63, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[34809, 959, 498, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[35310, 975, 480, 7, 93, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[35793, 984, 514, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[36310, 1000, 316, 5, 63, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[36629, 1007, 498, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[37130, 1023, 302, 5, 63, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[37435, 1030, 499, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[37937, 1046, 328, 5, 93, "Print",
   CellTags->"Info3519844091-4565354"],
  Cell[38268, 1053, 500, 14, 32, "Print",
   CellTags->"Info3519844091-4565354"]},
 "Info3519844092-4565354"->{
  Cell[38771, 1069, 984, 14, 325, "Print",
   CellTags->"Info3519844092-4565354"],
  Cell[39758, 1085, 1040, 29, 74, "Print",
   CellTags->"Info3519844092-4565354"],
  Cell[40801, 1116, 154, 2, 60, "Print",
   CellTags->"Info3519844092-4565354"],
  Cell[40958, 1120, 811, 21, 32, "Print",
   CellTags->"Info3519844092-4565354"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3519844090-4565354", 42620, 1169},
 {"Info3519844091-4565354", 44267, 1210},
 {"Info3519844092-4565354", 45752, 1247}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 154, 4, 41, "Text"],
Cell[714, 26, 224, 4, 41, "Text"],
Cell[941, 32, 182, 4, 41, "Text"],
Cell[CellGroupData[{
Cell[1148, 40, 172, 3, 43, "Input"],
Cell[1323, 45, 361, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1721, 55, 228, 6, 43, "Input"],
Cell[1952, 63, 421, 6, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2410, 74, 73, 1, 43, "Input"],
Cell[2486, 77, 346, 5, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2869, 87, 99, 1, 105, "Section"],
Cell[CellGroupData[{
Cell[2993, 92, 307, 6, 71, "Input"],
Cell[3303, 100, 7521, 192, 3002, "Output"]
}, Open  ]],
Cell[10839, 295, 137, 2, 43, "Input"],
Cell[10979, 299, 152, 2, 43, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11168, 306, 92, 1, 105, "Section"],
Cell[CellGroupData[{
Cell[11285, 311, 732, 20, 152, "Input"],
Cell[12020, 333, 3667, 96, 1488, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15736, 435, 98, 1, 105, "Section"],
Cell[CellGroupData[{
Cell[15859, 440, 336, 8, 71, "Input"],
Cell[16198, 450, 1068, 26, 278, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17303, 481, 186, 3, 43, "Input"],
Cell[CellGroupData[{
Cell[17514, 488, 242, 4, 63, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[17759, 494, 501, 14, 32, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[18263, 510, 498, 8, 93, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[18764, 520, 1034, 29, 74, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[19801, 551, 415, 7, 93, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[20219, 560, 527, 15, 32, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[20749, 577, 905, 13, 180, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[21657, 592, 1037, 29, 74, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[22697, 623, 752, 11, 151, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[23452, 636, 1038, 29, 74, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[24493, 667, 249, 4, 63, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[24745, 673, 510, 14, 32, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[25258, 689, 404, 6, 93, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[25665, 697, 527, 15, 32, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[26195, 714, 256, 5, 63, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[26454, 721, 504, 14, 32, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[26961, 737, 284, 5, 63, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[27248, 744, 519, 14, 32, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[27770, 760, 411, 7, 93, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[28184, 769, 526, 15, 32, "Print",
 CellTags->"Info3519844090-4565354"],
Cell[28713, 786, 252, 4, 63, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[28968, 792, 523, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[29494, 808, 146, 2, 60, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[29643, 812, 802, 21, 32, "Print",
 CellTags->"Info3519844091-4565354"]
}, Open  ]],
Cell[30460, 836, 389, 8, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30898, 850, 152, 2, 105, "Section"],
Cell[CellGroupData[{
Cell[31075, 856, 395, 9, 71, "Input"],
Cell[31473, 867, 913, 23, 212, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32423, 895, 240, 4, 43, "Input"],
Cell[CellGroupData[{
Cell[32688, 903, 514, 8, 93, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[33205, 913, 512, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[33720, 929, 260, 5, 63, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[33983, 936, 506, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[34492, 952, 314, 5, 63, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[34809, 959, 498, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[35310, 975, 480, 7, 93, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[35793, 984, 514, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[36310, 1000, 316, 5, 63, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[36629, 1007, 498, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[37130, 1023, 302, 5, 63, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[37435, 1030, 499, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[37937, 1046, 328, 5, 93, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[38268, 1053, 500, 14, 32, "Print",
 CellTags->"Info3519844091-4565354"],
Cell[38771, 1069, 984, 14, 325, "Print",
 CellTags->"Info3519844092-4565354"],
Cell[39758, 1085, 1040, 29, 74, "Print",
 CellTags->"Info3519844092-4565354"],
Cell[40801, 1116, 154, 2, 60, "Print",
 CellTags->"Info3519844092-4565354"],
Cell[40958, 1120, 811, 21, 32, "Print",
 CellTags->"Info3519844092-4565354"]
}, Open  ]],
Cell[41784, 1144, 378, 8, 42, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
